/* 
SQLyog v3.71
Host - 192.168.1.3 : Database - trafficdb
**************************************************************
Server version 5.0.18-log
*/

create database if not exists `trafficdb`;

use `trafficdb`;

/*
Table structure for daemonData
*/

drop table if exists `daemonData`;
CREATE TABLE `daemonData` (
  `count` int(11) NOT NULL auto_increment,
  `userName` varchar(255) NOT NULL,
  `userLimit` int(11) NOT NULL,
  `userTraffic` int(11) NOT NULL,
  `userCacheTraffic` int(11) NOT NULL,
  `underLimit` int(11) NOT NULL,
  `oldUserTraffic` int(11) NOT NULL,
  `userID` int(11) unsigned NOT NULL,
  `LdapUpdate` int(10) unsigned NOT NULL default '0',
  `lastTime` int(10) unsigned NOT NULL default '0',
  `commercialLimit` int(11) NOT NULL default '0',
  `commercialTraffic` int(11) NOT NULL default '0',
  `commercialCacheTraffic` int(11) NOT NULL default '0',
  PRIMARY KEY  (`userName`),
  UNIQUE KEY `count` (`count`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for full_proxy_stat
*/

drop table if exists `full_proxy_stat`;
CREATE TABLE `full_proxy_stat` (
  `id` int(8) NOT NULL auto_increment,
  `Time` int(10) unsigned NOT NULL default '0',
  `TimeRequest` int(10) unsigned NOT NULL default '0',
  `Computer` varchar(100) default NULL,
  `Status` tinyint(3) unsigned NOT NULL default '0',
  `StatusStr` varchar(32) default NULL,
  `Code` smallint(5) unsigned NOT NULL default '0',
  `Size` int(10) unsigned NOT NULL default '0',
  `Method` varchar(10) NOT NULL,
  `URL` text,
  `DNUser` varchar(255) default NULL,
  `HierarhyInfo` varchar(32) default NULL,
  `HierarhyHost` varchar(255) default NULL,
  `ObjectType` varchar(64) default NULL,
  PRIMARY KEY  (`id`),
  KEY `global_time` (`Time`),
  KEY `user_time` (`DNUser`,`Time`),
  KEY `user_method_time` (`DNUser`,`Method`,`Time`),
  KEY `Status` (`Status`,`StatusStr`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for proxy_stat
*/

drop table if exists `proxy_stat`;
CREATE TABLE `proxy_stat` (
  `id` int(8) NOT NULL auto_increment,
  `Time` int(10) unsigned NOT NULL default '0',
  `Computer` varchar(100) default NULL,
  `Inet` int(10) unsigned NOT NULL default '0',
  `toInet` int(10) unsigned NOT NULL default '0',
  `Cache` int(10) unsigned NOT NULL default '0',
  `URL` text,
  `Code` smallint(5) unsigned NOT NULL default '0',
  `ObjectType` varchar(64) default NULL,
  `DNUser` varchar(255) default NULL,
  `Site` varchar(255) default NULL,
  `DNGroup` varchar(255) default NULL,
  `DNOrg` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `global_time` (`Time`),
  KEY `user_time` (`DNUser`,`Time`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for squid2sqlData
*/

drop table if exists `squid2sqlData`;
CREATE TABLE `squid2sqlData` (
  `count` int(11) NOT NULL auto_increment,
  `userName` varchar(255) NOT NULL,
  `limitName` varchar(255) NOT NULL,
  `groupName` varchar(255) NOT NULL,
  `userLimit` int(11) NOT NULL default '0',
  `userTraffic` int(11) NOT NULL default '0',
  `userCacheTraffic` int(11) NOT NULL default '0',
  `fromUserTraffic` int(11) NOT NULL default '0',
  `lastUpdate` int(11) NOT NULL default '0',
  PRIMARY KEY  (`count`),
  UNIQUE KEY `userIndex` (`userName`,`groupName`,`limitName`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for stat_cache
*/

drop table if exists `stat_cache`;
CREATE TABLE `stat_cache` (
  `id` int(11) NOT NULL auto_increment,
  `sTime` int(10) unsigned zerofill NOT NULL,
  `eTime` int(10) unsigned zerofill NOT NULL,
  `sumHits` int(11) default NULL,
  `sumInet` int(11) default NULL,
  `sumCache` int(11) default NULL,
  `sumToInet` int(11) default NULL,
  `DN` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for stat_treeSettings
*/

drop table if exists `stat_treeSettings`;
CREATE TABLE `stat_treeSettings` (
  `type` text,
  `count` smallint(6) unsigned zerofill NOT NULL,
  `father` text,
  `level` tinyint(4) unsigned zerofill default NULL,
  `dn` text NOT NULL,
  `fullname` text,
  `visible` tinyint(1) default NULL,
  `id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for stat_userCache
*/

drop table if exists `stat_userCache`;
CREATE TABLE `stat_userCache` (
  `sTime` int(11) unsigned NOT NULL,
  `eTime` int(11) unsigned NOT NULL,
  `sumHits` int(11) unsigned default NULL,
  `sumInet` int(11) unsigned default NULL,
  `sumCache` int(11) unsigned default NULL,
  `toInet` int(11) unsigned default NULL,
  `DNUser` int(11) unsigned default NULL,
  `DNGroup` int(11) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for userData
*/

drop table if exists `userData`;
CREATE TABLE `userData` (
  `count` int(11) NOT NULL auto_increment,
  `month` int(11) unsigned NOT NULL,
  `year` int(11) unsigned NOT NULL,
  `userName` varchar(255) NOT NULL,
  `userLimit` int(11) NOT NULL,
  `userTraffic` int(11) NOT NULL,
  `userCacheTraffic` int(11) NOT NULL,
  `underLimit` int(11) NOT NULL,
  `oldUserTraffic` int(11) NOT NULL,
  `userID` int(11) unsigned NOT NULL,
  `LdapUpdate` int(10) unsigned NOT NULL default '0',
  `lastTime` int(10) unsigned NOT NULL default '0',
  `commercialLimit` int(11) NOT NULL default '0',
  `commercialTraffic` int(11) NOT NULL default '0',
  `commercialCacheTraffic` int(11) NOT NULL default '0',
  PRIMARY KEY  (`userName`,`month`,`year`),
  UNIQUE KEY `count` (`count`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for userGroups
*/

drop table if exists `userGroups`;
CREATE TABLE `userGroups` (
  `year` smallint(6) unsigned NOT NULL default '0',
  `month` tinyint(4) unsigned NOT NULL default '0',
  `count` int(11) NOT NULL auto_increment,
  `userName` varchar(255) NOT NULL,
  `limitName` varchar(255) NOT NULL,
  `groupName` varchar(255) NOT NULL,
  `userLimit` int(11) NOT NULL default '0',
  `userTraffic` int(11) NOT NULL default '0',
  `userCacheTraffic` int(11) NOT NULL default '0',
  `fromUserTraffic` int(11) NOT NULL default '0',
  `lastUpdate` int(11) NOT NULL default '0',
  PRIMARY KEY  (`count`),
  UNIQUE KEY `userIndex` (`userName`,`groupName`,`limitName`,`year`,`month`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

/*
Table structure for userIP
*/

drop table if exists `userIP`;
CREATE TABLE `userIP` (
  `IPstr` varchar(18) NOT NULL default '0.0.0.0',
  `IPaddr` int(16) unsigned NOT NULL default '0',
  `UserName` varchar(255) NOT NULL default 'Public',
  `registrationTime` int(16) unsigned NOT NULL default '0',
  `userID` int(11) unsigned NOT NULL default '0',
  `detachConnection` tinyint(4) unsigned NOT NULL default '0',
  `dropTime` int(16) unsigned NOT NULL default '0',
  PRIMARY KEY  (`IPstr`,`IPaddr`),
  UNIQUE KEY `IPstr` (`IPstr`),
  UNIQUE KEY `IPaddr` (`IPaddr`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;

