#! /bin/sh
#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# Author: Werner Fink <werner@suse.de>, 1996
#         Burchard Steinbild, 1996
#
# /etc/init.d/boot.local
#
# script with local commands to be executed from init on system startup
#
# Here you should add things, that should happen directly after booting
# before we're going to the first run level.
#

##rmmod ipfwadm; rmmod ipchains
##modprobe ip_tables; modprobe ip_queue; modprobe ip_conntrack; modprobe ip_conntrack_ftp
##modprobe ip_nat_ftp
##modprobe ip6table_filter ip6table_mangle

DAEMONDIR=/usr/novell/sys/mySQUID/squid_daemon_s/
TRAFFICDAEMON=/usr/novell/sys/mySQUID/squid_daemon_s/squid_daemon
MYBASE=/usr/novell/sys/mySQUID/sqlbase/squidsql
SQLOG=/usr/local/squid/var/logs/access.log
MYSQUID=/usr/local/squid/sbin/squid
STARTSCRIPT=/usr/novell/sys/mySQUID/sqlbase/startsqlscript

# Source SuSE config
. /etc/rc.status

#test -x modprobe iptable_filter
#test -x modprobe ip_tables
#test -x modprobe ip_queue

#test -x /usr/novell/sys/mySQUID/squid_daemon/squid_daemon
#test -x /usr/local/squid/sbin/squid -YD

. /etc/rc.status

rc_reset


case "$1" in
    start)
	echo -n "____________Start traffic daemon_______________"
	## Start daemon with startproc(8). If this fails
	## the echo return value is set appropriate.

	# NOTE: startproc return 0, even if service is 
	# already running to match LSB spec.
	#modprobe iptable_filter
	#modprobe ip_tables
	#modprobe ip_queue
	
	startproc $TRAFFICDAEMON
	#cd DAEMONDIR
	#startproc ./serv_daemon
	#startproc $MYBASE < $SQLOG &
	#startproc $MYSQUID -YD
	$STARTSCRIPT

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "____________Stop traffic daemon_______________"
	## Stop daemon with killproc(8) and if this fails
	## set echo the echo return value.

	#killproc -TERM $MYSQUID
	$MYSQUID -k kill
	#killproc -TERM $MYBASE
	killproc -TERM $TRAFFICDAEMON
	#cd DAEMONDIR
	#killproc -TERM ./serv_daemon
	# Remember status and be verbose
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload,
	## give out the argument which is required for a reload.

	;;
    *)
	echo "Usage: $0 {start|stop}"
	exit 1
	;;
esac
rc_exit