#! /bin/sh
#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# Author: Werner Fink <werner@suse.de>, 1996
#         Burchard Steinbild, 1996
#
# /etc/init.d/boot.local
#
# script with local commands to be executed from init on system startup
#
# Here you should add things, that should happen directly after booting
# before we're going to the first run level.
#


#DAEMONDIR=/usr/novell/sys/mySQUID/squid_daemon_s/
#TRAFFICDAEMON=/usr/novell/sys/mySQUID/squid_daemon_s/squid_daemon
#MYSQUID=/usr/local/squid/sbin/squid
#CREATEPIPE=/usr/novell/sys/mySQUID/sqlbase/createpipe
#MYSQUID2SQL=/usr/novell/sys/mySQUID/sqlbase/squid2sql
MYSQL5=/usr/local/mysql/share/mysql/mysql.server

# Source SuSE config
. /etc/rc.status

. /etc/rc.status

rc_reset


case "$1" in
    start)
	echo -n "____________Start MySQL 5.0_______________\n"
	## Start daemon with startproc(8). If this fails
	## the echo return value is set appropriate.

	# NOTE: startproc return 0, even if service is 
	# already running to match LSB spec.
	
	$MYSQL5 start
	#startproc $TRAFFICDAEMON
 	#$CREATEPIPE
	#$MYSQUID2SQL
	#$MYSQUID -D
	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "____________Stop MySQL 5.0_______________\n"
	## Stop daemon with killproc(8) and if this fails
	## set echo the echo return value.

	#$MYSQUID -k shutdown
	#killproc -TERM $MYSQUID2SQL
	#killproc -TERM $TRAFFICDAEMON
	$MYSQL5 stop
	# Remember status and be verbose
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload,
	## give out the argument which is required for a reload.

	;;
    *)
	echo "Usage: $0 {start|stop}"
	exit 1
	;;
esac
rc_exit