#! /bin/sh
#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# Author: Werner Fink <werner@suse.de>, 1996
#         Burchard Steinbild, 1996
#
# /etc/init.d/boot.local
#
# script with local commands to be executed from init on system startup
#
# Here you should add things, that should happen directly after booting
# before we're going to the first run level.
#


DAEMONDIR=/usr/novell/sys/mySQUID/squid_daemon_s/
TRAFFICDAEMON=/usr/novell/sys/mySQUID/squid_daemon_s/squid_daemon
#MYSQUID=/usr/local/squid/sbin/squid
SQUIDDIR=/usr/local/squid
MYSQUID=$SQUIDDIR/sbin/squid
sqlogdir=$SQUIDDIR/var/logs
MYSQUID2SQL=/usr/novell/sys/mySQUID/sqlbase/squid2sql
#MYSQL5=/usr/local/mysql/share/mysql/mysql.server

# Source SuSE config
. /etc/rc.status

. /etc/rc.status

rc_reset


case "$1" in
    start)
	echo "____________Start traffic daemon_______________"
	## Start daemon with startproc(8). If this fails
	## the echo return value is set appropriate.

	# NOTE: startproc return 0, even if service is 
	# already running to match LSB spec.
	
	startproc $TRAFFICDAEMON
		echo "start log script"
		if [ -s "$sqlogdir/access.log" ]; then
		echo "move log file"
		mv $sqlogdir/access.log $sqlogdir/access.log.backup
		fi
		echo "create pipe chanal"
		mknod $sqlogdir/access.log -m 666 p
		chown tsquid:tsquid $sqlogdir/access.log	
	$MYSQUID2SQL
	$MYSQUID -D
	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo "____________Stop traffic daemon_______________"
	## Stop daemon with killproc(8) and if this fails
	## set echo the echo return value.
	$MYSQUID -k shutdown
	sleep 5
		echo "start delete log script"
		rm -f $sqlogdir/access.log	
	killproc -TERM $MYSQUID2SQL
	killproc -TERM $TRAFFICDAEMON
	# Remember status and be verbose
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload,
	## give out the argument which is required for a reload.

	;;
    *)
	echo "Usage: $0 {start|stop}"
	exit 1
	;;
esac
rc_exit