#include "ldap2sql.h"

using std::string;
using std::vector;
using std::iterator;


extern void saveLog(bool ntime, const char *format,...);
char *localName [] = {"limit", "commercial", "unlimit", NULL};
//char *allLimitNames[] = {"ADSlimitArray", "ADScommercialArray", "ADSunderArray", NULL};

attrName::attrName (char *getName)
{
	strncpy (groupName, getName, 256);
	Limit = 0;
	Traffic = 0;
	CacheTraffic = 0;
	fromUser = 0;
	update = false;
}

limitArray::limitArray(char *getName)
{
	strncpy (limitName, getName, 256);
	value = 0;
	inet = 0;
	cache = 0;
	limitInfo.clear();
}

userInfo::userInfo(char *getName)
{
	/*ldapLimit = 0;
	ldapUnderLimit = 0;
	ldapComLimit = 0;*/
	
			time_t rtime;
			time (&rtime);
			struct tm *today;
			today =  localtime( &rtime );

			month = today->tm_mon;
			year = today->tm_year;

	lastUpdate = 0;
	strncpy (userName, getName, 256);
	userLimits.clear();
			//allLimits = {"ADSlimitArray", "ADSunderArray", "ADScommercialArray", NULL};
			//strncpy(userLimits[0],limitName,,255)
	
	/*int i = 0;
	while (allNames[i] != NULL)
	{
		 limitArray limit(allNames[i]);
	  	userLimits.push_back(limit);
	  	++i;
	}*/
	/*limitArray limit("ADSlimitArray"), under("ADSunderArray"), comercial("ADScommercialArray");
	userLimits.push_back(limit);
	userLimits.push_back(under);
	userLimits.push_back(comercial);*/
}

/*userLimitStruct::userLimitStruct()
{
	update = false;
	userLimitInfo.clear();
}*/

//int myLDAP::myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter,	vector <attrName> &userGroups)
//int myLDAP::myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter, userLimitInfo **myLocInfo)
int myLDAP::myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter, typeLimitArray &myLocInfo)
{
	LDAPMessage *searchResult, *entry;
	BerElement  *ber;
    char        *attribute, **values, *dn;       

	uint	rc, i, j, a;
	rc = ldap_search_ext_s(  
                    localLD,               // LDAP session handle 
                    searchBase,            // container to search 
                    LDAP_SCOPE_BASE,			 // search scope 
                    filter,								 // search filter NULL
                    attrs,                 // "1.1" returns entry names only
                    0,                     // return attributes and values 
                    NULL,                  // server controls 
                    NULL,                  // client controls 
                    &timeOut,              // &timeOut  search timeout 
                    LDAP_NO_LIMIT,         // no size limit 
                    &searchResult );       // returned results 
    
    if ( rc != LDAP_SUCCESS ) 
    {
        saveLog(true, "ldap_search_ext_s: %s\n", ldap_err2string( rc ) );
				if (searchResult)
				{
					ldap_msgfree( searchResult );
					searchResult = NULL;
				}
        return ( -1 );
    }   
     
	char seps [] = " \0\n";
	char sepsE [] = ";\n\0";
	char sepsL [] = "$\0\n";

	char infoStr[256];
		//int limit = 0;
		//int unlimit = 0;
		int locLimit = 0;
	//int limit, excess, commercial;
	//attrName aStr();
					//saveLog (false, "==========================start ldap Serch===============================\n");

    for (   entry   =   ldap_first_entry( localLD, searchResult );
            entry   !=  NULL;
            entry   =   ldap_next_entry( localLD, entry ) )    
			{
        if (( dn = ldap_get_dn( localLD, entry )) != NULL )
        {
            ldap_memfree( dn );
        }

		for (   attribute = ldap_first_attribute( localLD, entry, &ber );
			    attribute != NULL; 
	            attribute = ldap_next_attribute( localLD, entry, ber ) )
		{
            values = ldap_get_values( localLD, entry, attribute);
            if (values != NULL)                
            {
							//for (n = 0; n < myLocInfo.userLimits.size(); ++n)
							//n = 0;
							//while (attrs[n] != NULL)
							//{
					//saveLog (false, "n - %d\n", n);

								if (strstr (attribute, attrs[0]) != NULL)
								//if (strstr (attribute, attrs[n]) != NULL)
								{
//					saveLog (false, "attribute - %s\n", attribute);
									//limitArray groupLimits(attrs[n]);
									for ( i = 0; values[i] != NULL; i++ )
										{
//					saveLog (false, "i - %d\n", i);

											locLimit = 0;
											//limit = 0; excess = 0;	commercial = 0;
											//char *limitSubStr, *underSubStr, *comSubStr;
											//char locLimitStr[255];
											strncpy (infoStr, values[i], 255);
											vectorAttrs locLimitStrs;
											myString locString;

											char *getStr, *eDirStr, *GroupStr;

											eDirStr = strtok(infoStr, sepsE);
											GroupStr = strtok(NULL, sepsE);
//					saveLog (false, "eDirStr - %s\n", eDirStr);
											getStr = strtok(eDirStr, sepsL);

											uint meter = 0;
											while ((localName[meter] != NULL) && (getStr != NULL))
												{
//					saveLog (false, "getStr - %s\n", getStr);
													strncpy (locString.str, getStr, 255);
													locLimitStrs.push_back (locString);
													getStr = strtok(NULL, sepsL);
													meter ++;
												}

											for (j = 0; j < locLimitStrs.size(); ++j)
												{
													char *LimitStr, *LimitScaleStr;
													//eDirStr = strtok(infoStr, sepsE);
													//GroupStr = strtok(NULL, sepsE);
													LimitStr = strtok(locLimitStrs[j].str, seps);
													if (LimitStr == NULL) 
														LimitStr = "0";
													locLimit = atol(LimitStr);
//					saveLog (false, "locLimit - %d (%s)\n", locLimit, localName[j]);
													LimitScaleStr = strtok(NULL, seps);
													if (LimitScaleStr != NULL) 
													{
														if (strcmp (LimitScaleStr, "Gb") == 0)
															locLimit *= 1073741824;
														if (strcmp (LimitScaleStr, "Mb") == 0)
															locLimit *= 1048576;
														if (strcmp (LimitScaleStr, "Kb") == 0)
															locLimit *= 1024;
													}

													limitArray groupLimits(localName[j]);
													attrName myAttr(GroupStr);
													myAttr.Limit = locLimit;
															//groupLimits.limitInfo.push_back(myAttr);													
													bool addLimit = true;
													
													//if ((strstr(attribute, "ADSunderArray") != NULL) && ((groupLimits.value == -1) || (climit == -1)))
													//if ((strstr(attribute, attrs[1]) != NULL) && 
													groupLimits.limitInfo.push_back(myAttr);
													if ( (groupLimits.value == -1) || (locLimit == -1) )
														groupLimits.value = -1;
													else
														groupLimits.value += locLimit;
													
													for (a = 0; a < myLocInfo.size(); ++a)
													{
														if (strstr(myLocInfo[a].limitName, localName[j]))
															{
																addLimit = false;
																myLocInfo[a].limitInfo.push_back (myAttr);
																if ( (myLocInfo[a].value == -1) || (myAttr.Limit == -1) )
																	myLocInfo[a].value = -1;
																else
																	myLocInfo[a].value += myAttr.Limit;
																break;
															}
													}
													
													if (addLimit) 
														{
															myLocInfo.push_back(groupLimits);
														}
												}
											
										}
										//myLocInfo.push_back(groupLimits);
								}
								if (strstr (attribute, attrs[1]) != NULL)
								{
									for ( i = 0; values[i] != NULL; i++ )
									{
										locLimit = 0;
										strncpy (infoStr, values[i], 255);
														//saveLog (true, "infoStr %s\n", infoStr);
										char *LimitStr, *LimitScaleStr;

										LimitStr = strtok(infoStr, seps);
														//saveLog (true, "LimitStr %s\n", LimitStr);
										if (LimitStr == NULL) 
											{
											//LimitStr = "0";
											LimitStr = infoStr;
											saveLog (true, "error parse %s\n", attribute);
											}
										locLimit = atol(LimitStr);
										LimitScaleStr = strtok(NULL, seps);
//saveLog(true, "%s %s\n", attribute, LimitStr);
										if (LimitScaleStr != NULL) 
										{
											if (strcmp (LimitScaleStr, "Gb") == 0)
												locLimit *= 1073741824;
											if (strcmp (LimitScaleStr, "Mb") == 0)
												locLimit *= 1048576;
											if (strcmp (LimitScaleStr, "Kb") == 0)
												locLimit *= 1024;
										}
														limitArray groupLimits(localName[1]);
														attrName myAttr("UnGroup");
														myAttr.Limit = locLimit;
														
														bool addLimit = true;
														if ( (groupLimits.value == -1) || (locLimit == -1) )
															groupLimits.value = -1;
														else
															groupLimits.value += locLimit;
														
														for (a = 0; a < myLocInfo.size(); ++a)
														{
															if (strstr(myLocInfo[a].limitName, localName[2]))
																{
																	addLimit = false;
																	myLocInfo[a].limitInfo.push_back (myAttr);
																	if ( (myLocInfo[a].value == -1) || (myAttr.Limit == -1) )
																		myLocInfo[a].value = -1;
																	else
																		myLocInfo[a].value += myAttr.Limit;
																	break;
																}
														}
														
														if (addLimit) 
															{
																groupLimits.limitInfo.push_back(myAttr);
																myLocInfo.push_back(groupLimits);
															}

									}
								}

							//	++n;
							//}
							//ldap_value_free( values );
            }
            ldap_memfree( attribute );
		}
	  ber_free(ber, 0);
			}
	ldap_msgfree( searchResult );
	searchResult = NULL;
	return 1;
}
//--------------------------------------------------------------------------
//int myLDAP::myLdapInfo(char *loginName, int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit)
int myLDAP::myLdapInfo(userInfo &myUserInfo)
{
	int i;
	for (i = 0; i < 4; ++i)
	{
		/*ldapLimit = 0;
		ldapUnderLimit = 0;
		ldapComLimit = 0;*/

		int rc;
		if (GlobalLd == NULL)
		{
			if (needSSL)
			{
				GlobalLd = ldapssl_init(ldapHost, ldapPort, 1);            
				if (GlobalLd == NULL )
				{
					saveLog(true, "ldapssl_init error\n");
					//ld = NULL;
					continue;
				}	
			}
				else
				{
					GlobalLd = ldap_init(ldapHost, ldapPort);            
					if (GlobalLd == NULL )
					{
						saveLog(true, "ldap_init error\n");
						//ld = NULL;
						continue;
					}	
				}
		}

		rc = ldap_simple_bind_s( GlobalLd, loginDN, password );
		if (rc != LDAP_SUCCESS )
		{
			saveLog(true, "ldap_simple_bind_s: %s\n", ldap_err2string( rc ));
			if (GlobalLd)
			{
				saveLog(true, "ldap_unbind_s in ERROR bind\n");
				if ((rc = ldap_unbind_s( GlobalLd )) != 0)
						{
								saveLog(true, "(ldap_simple_bind_s ERROR) ldap_unbind_s: %s\n", ldap_err2string( rc ));
						}
			}
			GlobalLd = NULL;
			continue;
		}


				if (LSC (GlobalLd, myUserInfo) < 0)
				{
					saveLog(true, "LSC error (%s)\n", myUserInfo.userName);
						if (GlobalLd )
						{
							if ((rc = ldap_unbind_s( GlobalLd )) != 0)
							{
									saveLog(true, "ldap_unbind_s: %s (LSC error)\n", ldap_err2string( rc ));
							}
							GlobalLd = NULL;
						}
				}
					else
					{
						return 1;
					}

	}
	return (-1);
}
//int myLDAP::LSC (LDAP   *ld, char *loginName,int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit)
int myLDAP::myLDAP::LSC (LDAP   *ld, userInfo &myUserInfo)
{   
  int retCode;
	
	typeLimitArray allLimits;
	retCode = 1;

	//if (myLdapSearch(ld, myUserInfo.userName, allLimitNames, NULL, allLimits) <= 0)
	if (myLdapSearch(ld, myUserInfo.userName, getAttr, NULL, allLimits) <= 0)
	{
		saveLog(true, "search in user date error\n");
		retCode = -1;
		return retCode;
	}

	/*time_t rtime;
	time (&rtime);
	myUserInfo.lastUpdate = rtime;*/

	uint i, j, k, l;
	for (i=0; i<myUserInfo.userLimits.size(); ++i)
	{
//saveLog(false, "memory limitName-%s - limit=%d\n", myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].value );
		for (j = 0; j <myUserInfo.userLimits[i].limitInfo.size(); ++j)
		{
//saveLog(false, "				memory GroupName-%s - limit=%d\n", myUserInfo.userLimits[i].limitInfo[j].groupName,  myUserInfo.userLimits[i].limitInfo[j].Limit);

			myUserInfo.userLimits[i].limitInfo[j].update = false;
			for (k = 0; k < allLimits.size(); ++k)
			{
				if (strstr(myUserInfo.userLimits[i].limitName, allLimits[k].limitName) != NULL)
				{
					myUserInfo.userLimits[i].value = allLimits[k].value;
					for (l = 0; l < allLimits[k].limitInfo.size(); ++l)
					{
						if (strstr(myUserInfo.userLimits[i].limitInfo[j].groupName, allLimits[k].limitInfo[l].groupName)!= NULL)
						{
							myUserInfo.userLimits[i].limitInfo[j].Limit =  allLimits[k].limitInfo[l].Limit;
							myUserInfo.userLimits[i].limitInfo[j].update = true;
							allLimits[k].limitInfo[l].update = true;
						}
					}
				}
			}
		}
	}

	for (i=0; i<myUserInfo.userLimits.size(); ++i)
	{
		for (j = 0; j <myUserInfo.userLimits[i].limitInfo.size(); ++j)
		{
			if (!myUserInfo.userLimits[i].limitInfo[j].update)
				myUserInfo.userLimits[i].limitInfo[j].Limit = 0;
		}
	}

			for (k = 0; k < allLimits.size(); ++k)
			{
				bool findLimitName = false;
				if (!myUserInfo.userLimits.empty())
				{
					for (i=0; i<myUserInfo.userLimits.size(); ++i)
					{
						if (strstr(myUserInfo.userLimits[i].limitName, allLimits[k].limitName) != NULL)
						{
							findLimitName = true;
							for (l = 0; l < allLimits[k].limitInfo.size(); ++l)
							{
								if (!allLimits[k].limitInfo[l].update)
								{
									allLimits[k].limitInfo[l].update = true;
									int count = myUserInfo.userLimits[i].limitInfo.size();
									myUserInfo.userLimits[i].limitInfo.push_back(allLimits[k].limitInfo[l]);
									myUserInfo.userLimits[i].limitInfo[count].update = true;
								}
							}
						}
					}
				}
				if (!findLimitName)
				{
					myUserInfo.userLimits.push_back(allLimits[k]);
				}
			}
/*saveLog (true, "getLimit!!!!!!!!!!!!!!!!!!!!!!!!\n");
			for (k = 0; k < allLimits.size(); ++k)
			{
				saveLog(false, "Cet limitName-%s - limit=%d\n", allLimits[k].limitName, allLimits[k].value );
				for (l = 0; l < allLimits[k].limitInfo.size(); ++l)
					saveLog(false, "				get GroupName-%s - limit=%d\n", allLimits[k].limitInfo[l].groupName,  allLimits[k].limitInfo[l].Limit);
			}
saveLog (true, "haveLimit!???????????????????????????\n");
	for (i=0; i<myUserInfo.userLimits.size(); ++i)
	{
				saveLog(false, "Have limitName-%s - limit=%d\n", myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].value );
		for (j = 0; j <myUserInfo.userLimits[i].limitInfo.size(); ++j)
			saveLog(false, "				have GroupName-%s - limit=%d\n", myUserInfo.userLimits[i].limitInfo[j].groupName,  myUserInfo.userLimits[i].limitInfo[j].Limit);
	}*/

	
  return( retCode );
}

myLDAP::myLDAP()
{

	snprintf(ldapHost, 255, "192.168.1.1");
	timeOut.tv_sec=10;
	timeOut.tv_usec=0;

	    // Set LDAP version to 3 and set connection timeout. 
	int version;
	version = LDAP_VERSION3;
  ldap_set_option( NULL, LDAP_OPT_PROTOCOL_VERSION, &version);
  ldap_set_option( NULL, LDAP_OPT_NETWORK_TIMEOUT, &timeOut);

	GlobalLd = NULL;
}
void myLDAP::setHost(ServerInfo si)
//void myLDAP::setHost(char *ldapServer, bool localNeddSSL)
{
	int count, i, len;
	count = si.myVectorAttrs.size();
	
	getAttr = new (char *)[count+1];
	for (i = 0; i < count; ++i)
	{
		len = strlen(si.myVectorAttrs[i].str) + 1;
		getAttr[i] = new char [len];
		strncpy (getAttr[i], si.myVectorAttrs[i].str, len);
	}
	getAttr[count] = NULL;

	if (si.ldapServer) snprintf(ldapHost, 255, si.ldapServer);
	//else snprintf(ldapHost, 255, "192.168.1.3");
	
	needSSL = si.needSSL;

	int rc;
	if (needSSL)
	{
		rc = ldapssl_client_init(   NULL,	NULL );     
	    
		if (rc != LDAP_SUCCESS)
		{
			saveLog (true, "ldapssl_client_init error: %s \n", ldap_err2string( rc ));
				exit( -1 );
		}

		rc = ldapssl_set_verify_mode(LDAPSSL_VERIFY_NONE);
		if (rc != LDAP_SUCCESS)
		{
			saveLog ( true, "ldapssl_set_verify_mode error: %s\n", ldap_err2string( rc ));
			exit( -1 );
		}
	}
  if (needSSL)
	{
		ldapPort = 636;
		//loginDN		    = "cn=proxyuser,ou=inet,o=nirctu";
		//password		  = "in4Teko7up";
		strncpy (LDAPlogin, si.LDAPlogin, 255);
		strncpy (LDAPpassword, si.LDAPpassword, 255);
		loginDN		    = LDAPlogin;
		password		  = LDAPpassword;
		//strncpy (loginDN, si.LDAPlogin, 255);
		//strncpy (password, si.LDAPpassword, 255);
	}
	else
		{
			ldapPort = 389;
			loginDN           = NULL;
			password          = NULL;
			//strncpy (loginDN, "", 255);
			//strncpy (password, "", 255);
		}
			if (GlobalLd )
			{
				saveLog(true, "clear ldap connection\n");
				if ((rc = ldap_unbind_s( GlobalLd )) != 0)
				{
						saveLog(true, "ldap_unbind_s (ALL): %s\n", ldap_err2string( rc ));
				}
			}
			GlobalLd = NULL;

}
void myLDAP::myLDAPdeInit()
{
	if (GlobalLd )
	{
		int rc;
		if ((rc = ldap_unbind_s( GlobalLd )) != 0)
		{
				saveLog(true, "ldap_unbind_s: %s (LSC error)\n", ldap_err2string( rc ));
		}
	}
	if (needSSL)
		ldapssl_client_deinit();
}
myLDAP::~myLDAP()
{
	if (getAttr != NULL)
	{
		int count = 0;
		while (getAttr[count] != NULL)
		{
			delete [] getAttr[count];
		}
		delete [] getAttr;
	}
	myLDAPdeInit();
}
// Local Variables:
// mode:C++
// End:
