#ifndef MY_LDAP2SQL_H
#define MY_LDAP2SQL_H

#include <ldap_ssl.h>
#include <ldap.h>
#include <ldapx.h>
#include <ctype.h>
#include <pthread.h>

#include <time.h>

#include <vector>
#include <string> 

using std::string;
using std::vector;
using std::iterator;

//const int limitNumber = 3;


struct myString
{
	char str[255];
};

typedef vector <myString> vectorAttrs;

struct ServerInfo
{
	vectorAttrs myVectorAttrs;
	bool needSSL;
	char host [255];
	unsigned int port;
	char ldapServer [255], 
		username [255],
		password [255],
		database [255], 
		LDAPlogin[255], 
		LDAPpassword[255];
	ServerInfo& operator = (ServerInfo &si);
};


struct attrName
{
	attrName(char *getName);
	char groupName[256];
	int Limit;
	int Traffic;
	int CacheTraffic;
	int fromUser;

	bool update;
};

struct limitArray
{
	limitArray(char *getName);
	char limitName[256];
	int value, inet, cache, toinet;
	vector <attrName> limitInfo;
};

typedef vector <limitArray> typeLimitArray;

struct userInfo
{
	userInfo(char *getName);
	char userName[256];

	time_t lastUpdate;
	uint month, year;

	typeLimitArray userLimits;
};

//vector <userInfo> myInfo;

class myLDAP
{

protected:
	char ldapHost[256];
	struct timeval timeOut;
	bool needSSL;
	LDAP *GlobalLd;
	int  ldapPort;
	char *loginDN, *password;
	//char loginDN[255], password[255];
	char LDAPlogin[255], LDAPpassword[255];

	char **getAttr;
	//int myLDAP::LSC (LDAP   *ld, char *loginName, int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit);
	//int myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter, vector <attrName> &userGroups);
	int myLDAP::LSC (LDAP   *ld, userInfo &myLocInfo);
	int myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter, typeLimitArray &myUserInfo);
	//int myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter, userLimitInfo **myUserInfo);

public:
	myLDAP();
	~myLDAP();
	void myLDAPdeInit();
	//void setHost(char *ldapServer, bool localNeddSSL);
	void setHost(ServerInfo si);
	//int myLdapInfo(char *loginName, int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit);
	int myLdapInfo(userInfo &myUserInfo);
};

#endif //MY_LDAP2SQL_H
