#ifndef _SQUID_DATA_H
#define _SQUID_DATA_H


#include <linux/types.h>
#include <linux/socket.h>
#include <pthread.h>

#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <arpa/inet.h>

#include <sys/time.h>
#include <netinet/in.h>
#include <errno.h>

#include <vector>
#include <string>

using std::string;
using std::vector;
using std::iterator;


struct myString
{
	char str[255];
};

typedef vector <myString> vectorAttrs;

struct ServerInfo
{
	vectorAttrs myVectorAttrs;
	bool needSSL;
	char host [255];
	unsigned int port;
	char ldapServer [255], 
		username [255],
		password [255],
		database [255], 
		LDAPlogin[255], 
		LDAPpassword[255];
	ServerInfo& operator = (ServerInfo &si);
};

struct SIdentUser
{
	SIdentUser();
	char userName[256];
	char strUserIP[18];
	struct in_addr userIP;
	time_t rTime;
	uint userID;
	bool detachConnection;
	time_t dropTime;
};

struct SUserData
{
	SUserData();

	char userName[256];
	int userLimit;
	int userTraffic;
	int userCacheTraffic;
	int underLimit;
	int oldUserTraffic;
	uint userID;
	time_t lastTime;
	time_t LdapUpdate;
	int commercialLimit;
	int commercialTraffic;
	int commercialCacheTraffic;
};

/*struct threadInfo
{
	SquidDaemon *pD;
	int numberThread;
};*/

#endif /*_SQUID_DATA_H*/
 
