//#include <ldap.h>
//#include <ctype.h>
//#include <ldap_ssl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "myldap.h"
#include <vector>
#include <string>
#include <iostream>
#include <fstream>

using std::string;
using std::vector;
using std::iterator;

extern void saveLog(bool ntime, const char *format,...);
extern void stringToLow(char *inStr);


//-------------------------------------------------------------------------
int myLDAP::myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter,
														int &sLimit, int &sUnderLimit, int &sComLimit, vector <attrName> &userGroups)
{
	LDAPMessage *searchResult, *entry;
	BerElement  *ber;
    char        *attribute, **values, *dn;       


	int	rc, i;
	rc = ldap_search_ext_s(  
                    localLD,               // LDAP session handle 
                    searchBase,            // container to search 
                    LDAP_SCOPE_BASE,			 // search scope 
                    filter,								 // search filter NULL
                    attrs,                 // "1.1" returns entry names only
                    0,                     // return attributes and values 
                    NULL,                  // server controls 
                    NULL,                  // client controls 
                    &timeOut,              // &timeOut  search timeout 
                    LDAP_NO_LIMIT,         // no size limit 
                    &searchResult );       // returned results 
    
    if ( rc != LDAP_SUCCESS ) 
    {
        saveLog(true, "ldap_search_ext_s: %s\n", ldap_err2string( rc ) );
				if (searchResult)
				{
					ldap_msgfree( searchResult );
					searchResult = NULL;
				}
				//if (localLD)
					//ldap_unbind_s( localLD );
												//ldap_destroy( localLD );//for ldap_dup
        return ( -1 );
    }   
     
	//char seps [] = " ;	\0\n";
	char gseps [] = ";\0";
	char lseps [] = "$\0";
	char seps [] = " \0";
	char infoStr[256];
		int limit = 0;
		int unlimit = 0;
		int climit = 0;

	sLimit = 0;
	sComLimit = 0;

	attrName aStr;

	//if ( (entry = ldap_first_entry( localLD, searchResult )) != NULL)
    for (   entry   =   ldap_first_entry( localLD, searchResult );
            entry   !=  NULL;
            entry   =   ldap_next_entry( localLD, entry ) )    
			{
/*		for (   attribute = ldap_first_attribute( localLD, searchResult, &ber );
			    attribute != NULL; 
	            attribute = ldap_next_attribute( localLD, searchResult, ber ) )*/
        if (( dn = ldap_get_dn( localLD, entry )) != NULL )
        {
            //saveLog(true, "\n dn: %s\n", dn );
            ldap_memfree( dn );
        }

		for (   attribute = ldap_first_attribute( localLD, entry, &ber );
			    attribute != NULL; 
	            attribute = ldap_next_attribute( localLD, entry, ber ) )
		{
            values = ldap_get_values( localLD, entry, attribute);
            if (values != NULL)                
            {
                //for ( i = 0; values[i] != NULL; i++ )
								//{
									//if (strstr (attribute, "groupMembership") != NULL)getAttr
									if (strstr (attribute, getAttr[0]) != NULL)
									{
										for ( i = 0; values[i] != NULL; i++ )
										{
//saveLog (true, "attribute - %s values[%d] - %s\n", attribute, i, values[i]);

											strncpy (aStr.name, values[i], 255);
											userGroups.push_back(aStr);
										}
									}
									if (strstr (attribute, getAttr[1]) != NULL)
									{
										for ( i = 0; values[i] != NULL; i++ )
										{
//saveLog (true, "attribute - %s values[%d] - %s\n", attribute, i, values[i]);
											char *limitSubStr, *underSubStr, *comSubStr, *getStr;
											strncpy (infoStr, values[i], 255);

											getStr = strtok (infoStr, gseps);
											if (getStr != NULL)
												{
												char subStr[1024];
												strncpy (subStr, getStr, 1024);
																//saveLog(true, "subStr %s\n", subStr);
												limitSubStr = strtok (subStr, lseps);
																//saveLog(true, "limitSubStr %s\n", limitSubStr);
												comSubStr = strtok (NULL, lseps);
																//saveLog(true, "comSubStr %s\n", comSubStr);
												underSubStr = strtok (NULL, lseps);
																//saveLog(true, "underSubStr %s\n", underSubStr);
												if(
												 (limitSubStr != NULL ) &&
													(underSubStr != NULL ) &&
													 (comSubStr != NULL )
													 )
												{
													//commercialLimit
													char *comLimitStr, *comLimitScaleStr;
													climit = 0;
													comLimitStr = strtok(comSubStr, seps);
													if (comLimitStr == NULL)
														{
														saveLog (true, "error parse %s\n", comLimitStr);
														comLimitStr = comSubStr;
														}
													climit = atol(comLimitStr);
													comLimitScaleStr = strtok(NULL, seps);
//saveLog(true, "comLimitStr %s\n", comLimitStr);
													if (comLimitScaleStr != NULL) 
													{
														if (strcmp (comLimitScaleStr, "Gb") == 0)
															climit *= 1073741824;
														if (strcmp (comLimitScaleStr, "Mb") == 0)
															climit *= 1048576;
														if (strcmp (comLimitScaleStr, "Kb") == 0)
															climit *= 1024;
													}
													sComLimit += climit;
//saveLog(true, "sComLimit %d\n", sComLimit);

													//limit
													limit = 0;

													//strncpy (infoStr, values[i], 255);
													char *LimitStr, *LimitScaleStr;

													LimitStr = strtok(limitSubStr, seps);
													if (LimitStr == NULL) 
														LimitStr = "0";
													limit = atol(LimitStr);
													LimitScaleStr = strtok(NULL, seps);

													if (LimitScaleStr != NULL) 
													{
														if (strcmp (LimitScaleStr, "Gb") == 0)
															limit *= 1073741824;
														if (strcmp (LimitScaleStr, "Mb") == 0)
															limit *= 1048576;
														if (strcmp (LimitScaleStr, "Kb") == 0)
															limit *= 1024;
													}
													sLimit += limit;
													
													//underLimit
													unlimit = 0;

													//strncpy (infoStr, values[i], 255);
													char *UnLimitStr, *UnLimitScaleStr;

													UnLimitStr = strtok(underSubStr, seps);
													if (UnLimitStr == NULL)
														{
														//UnLimitStr = "0";
														saveLog(true, "eroor parse underSubStr\n");
															UnLimitStr = underSubStr;
														}
													unlimit = atol(UnLimitStr);
													UnLimitScaleStr = strtok(NULL, seps);
//saveLog(true, "underSubStr %s\n", UnLimitStr);
													if (UnLimitScaleStr != NULL) 
													{
														if (strcmp (UnLimitScaleStr, "Gb") == 0)
															unlimit *= 1073741824;
														if (strcmp (UnLimitScaleStr, "Mb") == 0)
															unlimit *= 1048576;
														if (strcmp (UnLimitScaleStr, "Kb") == 0)
															unlimit *= 1024;
													}
													if ((sUnderLimit != -1) || (unlimit != -1))
													{
														sUnderLimit += unlimit;
													}
													else
														 sUnderLimit = -1;
												}
													else {saveLog(true, "error find some limits\n");}
				
												}
											else {saveLog(true, "error get limits string\n");}

										}	

							/*		//if (strstr (attribute, "ADScommercialArray") != NULL)
							if (strstr (attribute, getAttr[3]) != NULL)
							//		if (strstr (attribute, "ADScommercialLimit") != NULL)
									{

										climit = 0;

										strncpy (infoStr, values[i], 255);
										char *LimitStr, *LimitScaleStr;

										LimitStr = strtok(infoStr, seps);
										if (LimitStr == NULL) 
											LimitStr = "0";
										limit = atol(LimitStr);
										LimitScaleStr = strtok(NULL, seps);
										if (LimitScaleStr != NULL) 
										{
											if (strcmp (LimitScaleStr, "Gb") == 0)
												climit *= 1073741824;
											if (strcmp (LimitScaleStr, "Mb") == 0)
												climit *= 1048576;
											if (strcmp (LimitScaleStr, "Kb") == 0)
												climit *= 1024;
										}
										//sLimit = limit;
										sComLimit += climit;
									}
						//if (strstr (attribute, "ADSlimitArray") != NULL)
						if (strstr (attribute, getAttr[1]) != NULL)
						//			if (strstr (attribute, "ADSinternetLimit") != NULL)
									{

										limit = 0;

										strncpy (infoStr, values[i], 255);
										char *LimitStr, *LimitScaleStr;

										LimitStr = strtok(infoStr, seps);
										if (LimitStr == NULL) 
											LimitStr = "0";
										limit = atol(LimitStr);
										LimitScaleStr = strtok(NULL, seps);
										if (LimitScaleStr != NULL) 
										{
											if (strcmp (LimitScaleStr, "Gb") == 0)
												limit *= 1073741824;
											if (strcmp (LimitScaleStr, "Mb") == 0)
												limit *= 1048576;
											if (strcmp (LimitScaleStr, "Kb") == 0)
												limit *= 1024;
										}
										//sLimit = limit;
										sLimit += limit;
									}
							//if (strstr (attribute, "ADSunderArray") != NULL)
							if (strstr (attribute, getAttr[2]) != NULL)
							//		if (strstr (attribute, "ADSunderLimit") != NULL)
									{
										unlimit = 0;

										strncpy (infoStr, values[i], 255);
										char *UnLimitStr, *UnLimitScaleStr;

										UnLimitStr = strtok(infoStr, seps);
										if (UnLimitStr == NULL) 
											UnLimitStr = "0";
										unlimit = atol(UnLimitStr);
										UnLimitScaleStr = strtok(NULL, seps);
										if (UnLimitScaleStr != NULL) 
										{
											if (strcmp (UnLimitScaleStr, "Gb") == 0)
												unlimit *= 1073741824;
											if (strcmp (UnLimitScaleStr, "Mb") == 0)
												unlimit *= 1048576;
											if (strcmp (UnLimitScaleStr, "Kb") == 0)
												unlimit *= 1024;
										}
										if ((sUnderLimit != -1) || (unlimit != -1))
										{
											sUnderLimit += unlimit;
										}
										else
											 sUnderLimit = -1;
									}*/
									}
									if (strstr (attribute, getAttr[2]) != NULL)
									{
										for ( i = 0; values[i] != NULL; i++ )
										{
//saveLog (true, "attribute - %s values[%d] - %s\n", attribute, i, values[i]);

											strncpy (infoStr, values[i], 255);
												char *comLimitStr, *comLimitScaleStr;
												climit = 0;
												comLimitStr = strtok(infoStr, seps);
//saveLog(true, "comLimitStr %s\n", comLimitStr);
												if (comLimitStr == NULL)
												{
													//comLimitStr = "0";
													comLimitStr = infoStr;
													saveLog (true, "error get %s\n", attribute);
												}
												climit = atol(comLimitStr);
												comLimitScaleStr = strtok(NULL, seps);
												if (comLimitScaleStr != NULL) 
												{
													if (strcmp (comLimitScaleStr, "Gb") == 0)
														climit *= 1073741824;
													if (strcmp (comLimitScaleStr, "Mb") == 0)
														climit *= 1048576;
													if (strcmp (comLimitScaleStr, "Kb") == 0)
														climit *= 1024;
												}
												sComLimit += climit;
//saveLog(true, "sComLimit %d\n", sComLimit);

										}
									}

								//}
							ldap_value_free( values );
            }
            ldap_memfree( attribute );
		}
	  ber_free(ber, 0);
			}
	//else 
	//	saveLog (true, "no entry description");
	ldap_msgfree( searchResult );
	searchResult = NULL;

						//saveLog (true, "sLimit=%d  sComLimit=%d  sUnderLimit=%d\n", sLimit, sComLimit , sUnderLimit);
	return 1;
}
//--------------------------------------------------------------------------
int myLDAP::myLdapInfo(char *loginName, int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit)
{
	int i;
	for (i = 0; i < 4; ++i)
	{
		ldapLimit = 0;
		ldapUnderLimit = 0;
		ldapComLimit = 0;

		int rc;
		if (GlobalLd == NULL)
		{
			if (needSSL)
			{
				saveLog(true, "init LDAP SSL connections\n");
				GlobalLd = ldapssl_init(ldapHost, ldapPort, 1);            
				if (GlobalLd == NULL )
				{
					saveLog(true, "ldapssl_init error\n");
					continue;
				}	
			}
				else
				{
					saveLog(true, "init LDAP connections\n");
					GlobalLd = ldap_init(ldapHost, ldapPort);            
					if (GlobalLd == NULL )
					{
						saveLog(true, "ldap_init error\n");
						continue;
					}	
				}
		}

		//rc = ldap_simple_bind_s( GlobalLd, LDAPlogin, LDAPpassword );
		rc = ldap_simple_bind_s( GlobalLd, loginDN, password );
		if (rc != LDAP_SUCCESS )
		{
			saveLog(true, "ldap_simple_bind_s: %s\n", ldap_err2string( rc ));
			if (GlobalLd)
			{
				saveLog(true, "ldap_unbind_s in ERROR bind\n");
				if ((rc = ldap_unbind_s( GlobalLd )) != 0)
				{
						saveLog(true, "(ldap_simple_bind_s ERROR) ldap_unbind_s: %s\n", ldap_err2string( rc ));
				}
			}
			GlobalLd = NULL;
			//return (-1);
			continue;
		}
		//ld = ldap_dup(ld);

				if (LSC (GlobalLd, loginName, ldapLimit, ldapUnderLimit, ldapComLimit) < 0)
				{
					saveLog(true, "LSC error (%s)\n", loginName);
						if (GlobalLd != NULL)
						{
							saveLog(true, "ldap_unbind_s in ERROR LSC\n");
							if ((rc = ldap_unbind_s( GlobalLd )) != 0)
							{
									saveLog(true, "ldap_unbind_s error (LSC): %s\n", ldap_err2string( rc ));
							}
							GlobalLd = NULL;
						}
						else
						{
							saveLog(true, "LDAP idenificator was destroy LD=%d!!!\n", GlobalLd);
						}
				}
					else
					{
						/*if (GlobalLd )
						{
							saveLog(true, "ldap_unbind_s in ERROR LSC\n");
							if ((rc = ldap_unbind_s( GlobalLd )) != 0)
							{
									saveLog(true, "ldap_unbind_s (ALL): %s\n", ldap_err2string( rc ));
							}
							//ldap_destroy( ld );
							GlobalLd = NULL;
						}*/
						return 1;
					}

	}
	return (-1);
}
int myLDAP::LSC (LDAP   *ld, char *loginName,int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit)
{   
  int sLimit, sUnderLimit, sComLimit, retCode;

//, groupLimit, groupUnderLimit;
//char        *attrs[] = {"groupMembership", "ADSlimitArray", "ADSunderArray","ADScommercialArray", "networkAddress", NULL};
//   char        *attrs[] = {"groupMembership", "ADSinternetLimit", "ADSunderLimit","ADScommercialLimit", "networkAddress", NULL};
//char        *attrsGroup[] = {"ADSinternetLimit", "ADSunderLimit", NULL};

  if (getAttr == NULL)
	  return -1;
	sLimit = 0;
	sUnderLimit = 0;
	sComLimit = 0;
	//groupLimit = 0;
	//groupUnderLimit = 0;
   //searchBase        = loginName;char *searchBase    
		vector <attrName> userGroups;
		userGroups.clear();
		vector <attrName> podGroups;
		podGroups.clear();
		char groupName[256], userName[256];
	bool have_inet = false;
	//retCode = 1;
	//if (myLdapSearch(ld, loginName, attrs, sLimit, sUnderLimit, userGroups) <= 0)
	if ((retCode = myLdapSearch(ld, loginName, getAttr, NULL, sLimit, sUnderLimit, sComLimit, userGroups)) <= 0)
	{
		saveLog(true, "search in user date error\n");
		//retCode = -1;
	}
	else
	{
		uint i;
		if (!userGroups.empty())
		{
			for (i = 0; i < userGroups.size(); ++i)
			{
				strncpy(groupName, userGroups[i].name, 256);
				strncpy(userName, loginName, 256);
				stringToLow(groupName);
				stringToLow(userName);
			
				//if (strstr(groupName, "ou=inet,o=nirctu"))
				if (strstr(groupName, "ou=inet"))
				{
					have_inet = true;
				}
				/*char *second = "ou=";
				char *userUnit, *groupUnit;
				if ((userUnit = strstr(userName, second)) != NULL)
				{
					if ((groupUnit = strstr(groupName, second)) != NULL)
					{
						if (strstr(groupUnit, userUnit))
						//if (strstr(groupUnit, userUnit) || strstr(groupUnit, "ou=inet,o=nirctu"))
						{
							//if (myLdapSearch(ld, userGroups[i].name, attrsGroup, groupLimit, groupUnderLimit, podGroups) <= 0)
							if (myLdapSearch(ld, userGroups[i].name, attrsGroup, NULL, groupLimit, groupUnderLimit, podGroups) <= 0)
							{
								saveLog(true, "search in group %s date error\n", userGroups[i].name);
								retCode = -1;
								break;
							}
							else
							{
								if (sUnderLimit != -1)
								{
									if (groupUnderLimit == -1)
									{
										sUnderLimit = -1;
										//saveLog(true, "user %s in group %s have safe limit\n", loginName, userGroups[i].name);
									}
										else
										{
											if (groupUnderLimit > sUnderLimit)
												groupUnderLimit = groupUnderLimit;
										}
								}
							}

						}
					}
				}*/
			}
	
		}
		else
			{
				saveLog (true, "not find groups\n");
			}
	}
	if (!have_inet)
	{
		sLimit = 0;
		sUnderLimit = 0;
		sComLimit = 0;
		saveLog (true, "user %s not have inet access\n", loginName);
	}
	ldapLimit = sLimit;
	ldapUnderLimit = sUnderLimit;
	ldapComLimit = sComLimit;

  return( retCode );
}

//myLDAP::myLDAP(bool LneedSSL)
myLDAP::myLDAP()
{

	snprintf(ldapHost, 255, "192.168.1.1");
	timeOut.tv_sec=10;
	timeOut.tv_usec=0;

	    // Set LDAP version to 3 and set connection timeout. 
	int version;
	version = LDAP_VERSION3;
  ldap_set_option( NULL, LDAP_OPT_PROTOCOL_VERSION, &version);
  ldap_set_option( NULL, LDAP_OPT_NETWORK_TIMEOUT, &timeOut);

	GlobalLd = NULL;
	getAttr = NULL;
}
//void myLDAP::setHost(char *ldapServer, bool localNeddSSL, vectorAttrs myVectorAttrs)
void myLDAP::setHost(ServerInfo si)
{
	int count, i, len;
	count = si.myVectorAttrs.size();
	
	getAttr = new (char *)[count+1];
	for (i = 0; i < count; ++i)
	{
		len = strlen(si.myVectorAttrs[i].str) + 1;
		getAttr[i] = new char [len];
		strncpy (getAttr[i], si.myVectorAttrs[i].str, len);
	}
	getAttr[count] = NULL;
	
	if (si.ldapServer) snprintf(ldapHost, 255, si.ldapServer);
	//else snprintf(ldapHost, 255, "192.168.1.1");
	
	needSSL = si.needSSL;//localNeddSSL;

	int rc;
	if (needSSL)
	{
		rc = ldapssl_client_init(   NULL,	NULL );     
	    
		if (rc != LDAP_SUCCESS)
		{
			saveLog (true, "ldapssl_client_init error: %s \n", ldap_err2string( rc ));
				exit( -1 );
		}

		rc = ldapssl_set_verify_mode(LDAPSSL_VERIFY_NONE);
		if (rc != LDAP_SUCCESS)
		{
			saveLog ( true, "ldapssl_set_verify_mode error: %s\n", ldap_err2string( rc ));
			exit( -1 );
		}
	}
  if (needSSL)
	{
		ldapPort = 636;
		//loginDN		    = "cn=proxyuser,ou=inet,o=nirctu";
		//password		  = "in4Teko7up";
		strncpy (LDAPlogin, si.LDAPlogin, 255);
		strncpy (LDAPpassword, si.LDAPpassword, 255);
		loginDN		    = LDAPlogin;
		password		  = LDAPpassword;
	}
	else
		{
			ldapPort = 389;
			loginDN           = NULL;
			password          = NULL;
			//strncpy (LDAPlogin, "", 255);
			//strncpy (LDAPpassword, "", 255);
		}
			if (GlobalLd )
			{
				saveLog(true, "clear ldap connection\n");
				if ((rc = ldap_unbind_s( GlobalLd )) != 0)
				{
						saveLog(true, "ldap_unbind_s (ALL): %s\n", ldap_err2string( rc ));
				}
			}
			GlobalLd = NULL;

}
void myLDAP::myLDAPdeInit()
{
	if (GlobalLd != NULL)
	{
		int rc;
		if ((rc = ldap_unbind_s( GlobalLd )) != 0)
		{
				saveLog(true, "ldap_unbind_s: %s (LSC error)\n", ldap_err2string( rc ));
		}
		if (needSSL)
			ldapssl_client_deinit();
	}
}
myLDAP::~myLDAP()
{
	if (getAttr != NULL)
	{
		int count = 0;
		while (getAttr[count] != NULL)
		{
			delete [] getAttr[count];
		}
		delete [] getAttr;
	}
  //myLDAPdeInit();
}

// Local Variables:
// mode:C++
// End:
