#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ldap.h>
#include <ldap_ssl.h>
#include <ctype.h>
//#include "myldap.h"
#include <vector>
#include <string>
#include <iostream>
#include <fstream>

using std::string;
using std::vector;
using std::iterator;

/*typedef struct attrName
{
	char name[256];
};*/

//extern void saveLog(char *mylog, bool ntime);
//extern void saveLog(bool ntime, const char *format, va_list args);
//extern void saveLog(bool ntime, const char *format,...);
//extern void saveLog(va_alist);
extern void saveLog(bool ntime, const char *format,...);
//void saveLog(bool ntime, const char *format, va_list args);


//-------------------------------------------------------------------------
int myLdapSearch(LDAP *ld, struct timeval &timeOut, char *searchBase, char  **attrs, int &sLimit, int &sUnderLimit, bool userData)
{
	//int mylimit = 0;
	char logStr[1024];
	LDAPMessage *searchResult, *entry;
	BerElement  *ber;
    char        *attribute, **values, *dn;       


	int	rc, i;
	rc = ldap_search_ext_s(  
                    ld,                    // LDAP session handle 
                    searchBase,            // container to search 
                    LDAP_SCOPE_BASE,   // search scope 
                    NULL,     // search filter 
                    attrs,                 // "1.1" returns entry names only
                    0,                     // return attributes and values 
                    NULL,                  // server controls 
                    NULL,                  // client controls 
                    &timeOut,              // &timeOut  search timeout 
                    LDAP_NO_LIMIT,         // no size limit 
                    &searchResult );       // returned results 
    
    if ( rc != LDAP_SUCCESS ) 
    {
        //printf("ldap_search_ext_s: %s\n", ldap_err2string( rc ));
		//snprintf (logStr, 1023, "ldap_search_ext_s: %s\n", ldap_err2string( rc ) );
        //saveLog(logStr, true);
        saveLog(true, "ldap_search_ext_s: %s\n", ldap_err2string( rc ) );
  
		ldap_msgfree( searchResult );
        
		//ldap_unbind_s( ld );
        //ldapssl_client_deinit();

        return ( -1 );
    }   
     
	bool findIL = false, findUL = false;
	char seps [] = " ;	\0\n";
	char infoStr[256];
	//char grouplevel;
		int limit = 0;
		int unlimit = 0;
		//grouplevel = 0;
	//attrName aStr;

	if ( (entry = ldap_first_entry( ld, searchResult )) != NULL)
    {
		for (   attribute = ldap_first_attribute( ld, searchResult, &ber );
			    attribute != NULL; 
	            attribute = ldap_next_attribute( ld, searchResult, ber ) )
		{
			//if (attribute != NULL)
			//{
            // Get values and print. 
            values = ldap_get_values( ld, entry, attribute);
            if (values != NULL)                
            {
                for ( i = 0; values[i] != NULL; i++ )
				{
					/*if (strstr (attribute, "groupMembership") != NULL)
					{
						if ((strstr(values[i], "InetGrp")) != NULL)
						{
							strncpy (aStr.name, values[i], 255);
							listAttr.push_back(aStr);
						}
					}
					if (strstr (attribute, "ADSgroupLevel") != NULL)
					{
						strncpy (infoStr, values[i], 255);
						grouplevel = atoi(infoStr);
					}*/

					if (strstr (attribute, "ADSinternetLimit") != NULL)
					{

						limit = 0;

						strncpy (infoStr, values[i], 255);
						char *LimitStr, *LimitScaleStr;

						LimitStr = strtok(infoStr, seps);
						if (LimitStr == NULL) 
							LimitStr = "0";
						limit = atol(LimitStr);
						LimitScaleStr = strtok(NULL, seps);
						if (LimitScaleStr != NULL) 
						{
							if (strcmp (LimitScaleStr, "Gb") == 0)
								limit *= 1073741824;
							if (strcmp (LimitScaleStr, "Mb") == 0)
								limit *= 1048576;
							if (strcmp (LimitScaleStr, "Kb") == 0)
								limit *= 1024;
						}
						findIL = true;
					}
					if (strstr (attribute, "ADSunderLimit") != NULL)
					{
						unlimit = 0;

						strncpy (infoStr, values[i], 255);
						char *UnLimitStr, *UnLimitScaleStr;

						UnLimitStr = strtok(infoStr, seps);
						if (UnLimitStr == NULL) 
							UnLimitStr = "0";
						unlimit = atol(UnLimitStr);
						UnLimitScaleStr = strtok(NULL, seps);
						if (UnLimitScaleStr != NULL) 
						{
							if (strcmp (UnLimitScaleStr, "Gb") == 0)
								unlimit *= 1073741824;
							if (strcmp (UnLimitScaleStr, "Mb") == 0)
								unlimit *= 1048576;
							if (strcmp (UnLimitScaleStr, "Kb") == 0)
								unlimit *= 1024;
						}
						findUL = true;
					}
				}
			 ldap_value_free( values );
             ldap_memfree( attribute );
           }
        }
	if (userData)
	{
		if (findIL)
		{
			sLimit = limit;
		}
		if (findUL)
		{
			sUnderLimit = unlimit;
		}
	}


		
	  ber_free(ber, 0);
	  ldap_msgfree( searchResult );
	}
	else 
		//saveLog ("no entry description", true);
		saveLog (true, "no entry description");

	return 1;
}
//--------------------------------------------------------------------------
int myLdapSSLConnect( char *loginName, char *ldapServer, int &ldapLimit, int &ldapUnderLimit)
{   
    int sLimit, sUnderLimit;
	/*attrName aStr;
	vector <attrName> listAttr;*/
	
	int         version, ldapPort, rc, i, retCode;
    char        *ldapHost, *loginDN, *password, *searchBase;   
	//char logStr[1024];
    //char        *attribute, **values, *dn;       
    LDAP        *ld;
	//BerElement  *ber;
    //LDAPMessage *searchResult, *entry;

    //char        *attrs[] = {"description", NULL};// 
    //char        *attrs[] = {"description", "objectClass", "+", "*", "Group Membership", NULL};// groupMembership
    //char        *attrs[] = {"description", "groupMembership", NULL};// 
    //char        *attrs[] = {"description", "groupMembership", "ADSinternetLimit", "ADSunderLimit", NULL};// 
    char        *attrs[] = {"groupMembership", "ADSinternetLimit", "ADSunderLimit", NULL};// 
    char        *attrsG[] = {"ADSinternetLimit", "ADSunderLimit", "ADSgroupLevel", NULL};// 
    //char        *attrs2[] = {NULL};// 
    //char        *attrs3[] = { NULL};// 
	
	
	
	struct timeval timeOut = {10,0};   // 10 second connection/search timeout
            
	/*listAttr.clear();
	sprintf(aStr.name, 255, "???");
	listAttr.push_back(aStr);*/

	if (ldapServer) ldapHost = ldapServer;
		else ldapHost          = "192.168.1.4 192.168.1.1 192.168.1.3";

    ldapPort          = 636;
//    loginDN           = "CN=PKireev,OU=CIT,O=NIRCTU";//"cn=suseadmin, o=institute";
//    password          = "ragnogora";
//    loginDN           = "cn=nodeadmin, o=institute";
//    password          = "raptor";
    loginDN           = NULL;
    password          = NULL;
    searchBase        = loginName;    

    // Set LDAP version to 3 and set connection timeout. 

	sLimit = 0;
	sUnderLimit = 0;

	ldapLimit = sLimit;
	ldapUnderLimit = sUnderLimit;

	retCode = 1;

	version = LDAP_VERSION3;
    ldap_set_option( NULL, LDAP_OPT_PROTOCOL_VERSION, &version);
    ldap_set_option( NULL, LDAP_OPT_NETWORK_TIMEOUT, &timeOut);

    rc = ldapssl_client_init(   NULL,//"/usr/novell/sys/mySQUID/daemon/NIRCTU-TREE_CA-PublicKeyCert.der",
								NULL );     
    if (rc != LDAP_SUCCESS)
    {
        //printf("ldapssl_client_init error: %d\n", rc);
        //snprintf(logStr, 1023, );
        //saveLog ( logStr, true);
        saveLog (true, "ldapssl_client_init error: %d\n", rc);
		return( -1 );
    }

	rc = ldapssl_set_verify_mode(LDAPSSL_VERIFY_NONE);
    if (rc != LDAP_SUCCESS)
    {
        ldapssl_client_deinit();
        //printf("ldapssl_set_verify_mode error: %d\n", rc);
        //snprintf(logStr, 1023, "ldapssl_set_verify_mode error: %d\n", rc);
        //saveLog ( logStr, true);
        saveLog ( true, "ldapssl_set_verify_mode error: %d\n", rc);
		return( -1 );
    }

    ld = ldapssl_init(ldapHost, ldapPort, 1);            
    if (ld == NULL )
    {
        //saveLog("ldapssl_init error\n", true );
        saveLog(true, "ldapssl_init error\n");
		ldapssl_client_deinit();
		return( -1 );
    }	
	
		/*if ( (ld = ldap_init( ldapHost, ldapPort )) == NULL ) 
		{ 
			saveLog( "ldap_init error" , true); 
			return( 1 ); 
		} 

		// Load SSL routines  
		if ( ldapssl_install_routines( ld ) != LDAP_SUCCESS ) 
		{ 
			saveLog("ldapssl_install_routines error", true ); 
			return( -1 ); 
		} */


		/*version = LDAP_VERSION3;
		ldap_set_option( ld, LDAP_OPT_PROTOCOL_VERSION, &version);
		ldap_set_option( ld, LDAP_OPT_NETWORK_TIMEOUT, &timeOut);*/

	//
    rc = ldap_simple_bind_s( ld, loginDN, password );
    if (rc != LDAP_SUCCESS )
    {
		//snprintf (logStr, 1023, "ldap_simple_bind_s: %s for %s\n", ldap_err2string( rc ), loginName);
        //saveLog(logStr, true);
        saveLog(true, "ldap_simple_bind_s: %s for %s\n", ldap_err2string( rc ), loginName);
        ldap_unbind_s ( ld );

		ldapssl_client_deinit();

        return( -1 );
    }



	//if (myLdapSearch(ld, timeOut, loginName, attrs, sLimit, sUnderLimit, true) > 0)
	//{
		/*for (i = 0; i < listAttr.size(); ++i)
		{
			if (myLdapSearch(ld, timeOut, listAttr[i].name, attrsG, false) < 0)
			{
				saveLog("search in Group date error ", false);
				retCode = -1;
			}
		}*/
	//}
	//else 
	if (myLdapSearch(ld, timeOut, loginName, attrs, sLimit, sUnderLimit, true) <= 0)
		{
			//saveLog("search in user date error ", true);
			saveLog(true, "search in user date error ");
			retCode = -1;
		}


	ldapLimit = sLimit;
	ldapUnderLimit = sUnderLimit;

	ldap_unbind_s( ld );  

    ldapssl_client_deinit();

    return( retCode );
}


// Local Variables:
// mode:C++
// End:
