#ifndef _SERV_DAEMON_H
#define _SERV_DAEMON_H

#include <time.h>
#include <vector>
#include <string>
#include <iostream>
#include <fstream>

#include <linux/types.h>
#include <linux/socket.h>
#include <pthread.h>

#define  MAX_PKT_SIZE     0xffff
#define  numListenThread  20
#define  numLocalService  30

using std::string;
using std::vector;
using std::iterator;


//volatile bool workDaemon;
//void savelog(char *mylog, bool ntime);

struct McStr
{
	char lineStr[4096];
	//time_t killTime;
	//time_t beginTime;
};

struct SIdentUser
{
	char userName[256];
	char strUserIP[18];
	//struct in_addr userIP;
	struct in_addr userIP;
	time_t rTime;
	unsigned int userID;
	bool detachConnection;
	time_t dropTime;
};
struct SUserData
{
	char userName[256];
	unsigned long userLimit;
	unsigned long userTraffic;
	unsigned long userCacheTraffic;
	unsigned long underLimit;
	//bool unlimited;
	unsigned long oldUserTraffic;
	unsigned int userID;
	time_t lastTime;
};

class TCmdLine
{
protected:
	FILE *pipe_fp;
	int asCount;
public:
	TCmdLine();
	~TCmdLine();
	bool iptablesCmd(char *cmdLine);
	bool iptablesAnswer( char* acswerString);
	bool cmdFree();
	bool iptablesSaveAnswer(char *cmdLine);
};

class tcpdaemon 
{
	protected:
		//pthread_mutex_t request_mutex;

		vector <SUserData> collected;
		vector <SIdentUser> share;
		//vector <McStr> rejectOutputRules, rejectInputRules;

		char myHostName[256], myIPstr[18];//, logtext[255];
		int sockfd;
		int sockRL;
		bool firstRegistration;
		char myLdapServer[256];
		char myDaemonServer[256];
		struct in_addr daemonServIP;
		char *ldapServer, *daemonServer;
		//char killConnLine[1024];

		void daemonize();
		void startDaemon();

		//bool operate(int fd, char *userIP);
		bool operate(int fd, struct in_addr userIPaddr, char *userIPstr);
		//bool KillUserConection(char *userIP);
		//bool KillUserConection(struct in_addr userIPaddr, char *userIPst);
		bool oldKillUserConection(struct in_addr userIPaddr, char *userIPstr, unsigned int killTime);
		void oldKillProcess(char *userIPstr, int killTime);
		//int registerUserIP(char *userIP, char *userName, int myLimit);
		//int registerUserIP(struct in_addr userIPaddr, char *userIPstr, char *userName, int myLimit);
		int registerUserIP(struct in_addr userIPaddr, char *userIPstr, char *userName, int &getLimit);

		//void deregisterUserIP(char *userIP);
		void deregisterUserIP(struct in_addr userIPaddr, char *userIPstr);
		void sendToRLimit(int fd, struct in_addr rlIPaddr, char *rlIPstr);
		
		//void saveUserTrafficToDisk(char *userName, int baseTraffic);
		void restorIPtablesRule();
		void saveUserTrafficToDisk(SUserData &sud);
		void saveTraffic();

		static void sighandler(int signum);
		static void stopDaemon (int signum);

		static void* packetTraffic(void *data);
		//void packetTraffic(void *data);
		static void die(struct ipq_handle *h);

		static void* listenerThread(void *data);
		static void* serviceThread(void *data);

		volatile bool workDaemon, readyToWork;
	public:
		void prepareIpTables();
		bool alreadyRun();
		pthread_t traffic_thread, listen_thread[numListenThread], service_thread[numLocalService];
		//int fdListen[numListenThread], fdService[numLocalService];

		tcpdaemon() {workDaemon = true;firstRegistration = false;readyToWork = false;ldapServer = "192.168.1.4";daemonServer = "192.168.1.38";};
		~tcpdaemon(){};
	void exec();
};

/*struct KillThreadData
{
	tcpdaemon *tcpD;
	unsigned int lillTime;
};
struct ThreadData
{
	tcpdaemon *tcpD;
	int number_fd;
};*/



#endif /*_SERV_DAEMON_H*/
