#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <syslog.h>
#include <signal.h>

#include <string.h>
#include <stdlib.h>
#include <iomanip>

#include <sys/un.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>


#include <linux/netfilter.h>

#include <linux/netlink.h>
#include <net/if.h>
#include <unistd.h>


#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#include <net/if_arp.h>
#include <netinet/in_systm.h>
#include <netinet/tcp.h>
#include <sys/resource.h>

#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <grp.h>

#include <jni.h>

#include "squid_daemon.h"
//#include "mysql.h"

//#include "myldap.h"

#define BUFFER_SIZE             (8*1024)
const int clLen = 1024;
//pthread_mutex_t request_mutex = PTHREAD_MUTEX_INITIALIZER;



//myLDAP lsConn;

SquidDaemon *pointToDaemon;

SquidDaemon::SquidDaemon() 
{
	workDaemon = true;
	//firstRegistration = false;
	readyToWork = false;

	allowTime = 31;
	close_time = 30;

	saveLog(true, "\n--START--\nset host for LDAP\n");
	/*int i;
	for (i = 0; i < numListenThread; ++i)
		lsConn[i].setHost(ldapServer);*/
	lsConn.setHost(ldapServer);
	saveLog(true, "ready LDAP\n");
};

SquidDaemon::~SquidDaemon() 
{
	//delete lsConn;
}

int SquidDaemon::alreadyRun() 
{
	int pid = 0;
	char rBuf[256];
	FILE *dF;
	char fileName[1024];

	snprintf (fileName, 1024, "%s/daemonPid", daemonDir);
	dF = fopen(fileName, "r");
	if (dF != NULL)
	{
		if (fgets(rBuf, 255, dF) != NULL)
		{
			pid = atoi(rBuf);
			//saveLog (true, " read pid=%d\n", pid);
		}else 
			//saveLog (true, "cannot read pid file\n");
			printf ("cannot read pid file\n");
		fclose (dF);
	}//else saveLog (true, "cannot open pid file\n");
	
	if (pid > 0)
	{
	    if (kill(pid, 0) >= 0)
		{

			saveLog (true, "SquidDaemon already run!!!\n");
			return pid;
		}
	}
	return 0;
}

void SquidDaemon::execute() 
{
	pointToDaemon = this;

	//struct sigaction sa, act;
	struct sigaction act;
	//char logText [255];

	FILE *dF;
	char fileName[256];
	
	int pid;
	if ((pid = alreadyRun()) > 0)
	{
		printf ("serv daemon allreade run! pid = %d\n", pid);
		exit(0);
	}
	
	if (!pripareNet())
	{
		printf ("error Net pripare \n");
		saveLog(true, "error Net pripare \n");
		return;
	}

	saveLog (true, "Daemonizing begining.. \n");
    parentPid = fork();

    switch(parentPid) 
    {
	case 0:
	    setsid();
	    chdir("/");

	    close(0);
	    close(1);
	    close(2);

	    memset(&act, 0, sizeof(act));
	    act.sa_handler = stopParentDaemon;
	    sigaction(SIGTERM, &act, NULL);

	    daemonize();
	    saveLog (true, "exit parent daemon\n");
	    exit(0);

	case -1:
	    saveLog (true, "parent fork() error\n");
	    break;

	default:
		snprintf (fileName, 255, "%s/daemonPid", daemonDir);

		dF = fopen(fileName, "w");
		if (dF != NULL)
		{
			fprintf (dF, "%d\n", parentPid);
			fclose (dF);
		}
		 else 
			saveLog (true, "Cannot save pid file !!!\n");

	    saveLog (true, "parent pid = %d\n", parentPid);
	    break;
    }
}
bool SquidDaemon::pripareNet()
{
	SUserData myUserData;
	strcpy (myUserData.userName, "Public");
	myUserData.userLimit = 0;
	myUserData.underLimit = 0;
	myUserData.userTraffic = 0;

	myUserData.userCacheTraffic = 0;
	myUserData.underLimit = 0;

	myUserData.oldUserTraffic = myUserData.userTraffic;
	myUserData.userID = 0;
	myUserData.lastTime = 0;

	collected.push_back(myUserData);

	SIdentUser myIdentUser;
	strcpy (myIdentUser.userName, "Public");
	strcpy (myIdentUser.strUserIP, "0.0.0.0");
	myIdentUser.userIP.s_addr = inet_addr("0.0.0.0");
	myIdentUser.rTime = 0;

	myIdentUser.userID = 0;
	myIdentUser.detachConnection = false;
	myIdentUser.dropTime = 0;

	share.push_back(myIdentUser);

	hostent* remoteHost;
	//unsigned int addr;
	int my_error = gethostname(myHostName, 16);

	if (my_error == 0)
	{
		remoteHost = gethostbyname(myHostName);
		sprintf (myIPstr, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));
		saveLog (false, "Host - %s IP - %s\n", myHostName, myIPstr);
	}
	else 
		saveLog (false, "cannot get host name\n");

	if (!createSocket(sockfd, htonl(INADDR_ANY), listenPort))
	{
		saveLog (false, "error create listen socket\n");
		return false;
	}

	if (!createSocket(sockRL, inet_addr("127.0.0.1"), servicePort))
	{
		saveLog (false, "error create service socket\n");
		return false;
	}
	return true;
}

bool SquidDaemon::createSocket(int &sock, u_int32_t s_addr, int s_port)
{
	sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);//SO_REUSEADDR
	
	if(sock != -1) 
	{

		    int on = 1;
			if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on)) < 0)
			saveLog (true, "SetReuseAddr error\n");
			struct linger L;
			L.l_onoff = 0;		/* off */
			L.l_linger = 0;
			if (setsockopt(sock, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
			saveLog (true, "SetNoLinger error\n");

	    struct sockaddr_in sa;
		sa.sin_addr.s_addr = s_addr;
		sa.sin_family = AF_INET;
		sa.sin_port = htons(s_port);

		if(bind(sock, (struct sockaddr *) &sa, sizeof(sa)) != -1) 
		{

			if(listen(sock, 5) == 0) 
			{
				return true;
			}else 
				{
					saveLog(true, "listen error in create socket\n");
					close (sock); 
					workDaemon = false;
				}
		}else 
			{
				saveLog(true, "bind error in create socket\n");
				close (sock);
				workDaemon = false;
			}
	}else 
		{
			saveLog(true, "create socket error\n");
			workDaemon = false;
		}
	return false;
}



void SquidDaemon::daemonize()
{
	pointToDaemon = this;
	do{
		readyToWork = false;
		lsConn.reset();

		/*saveLog(true, "set host for LDAP\n");
		lsConn.setHost(ldapServer);
		saveLog(true, "ready LDAP\n");*/
		startChild();
		if (childPid > 0)
			waitpid(0, 0, 0);
		//waitpid(childPid, 0, WNOHANG);
	}while (workDaemon);
	sleep (1);
	saveLog (true, "closing socket in exit parent\n");
	close(sockRL);
	close(sockfd);
	saveLog (true, "socket closed in exit parent\n");
	saveLog (true, "deinit ldap in exit parent\n");
	/*int i;
	for (i = 0; i < numListenThread; ++i)
		lsConn[i].myLdapDeInit();*/
	lsConn.myLdapDeInit();
	saveLog (true, "deinit ldap in exit parent done !!!\n");
}
void SquidDaemon::startChild()
{
	pointToDaemon = this;
  struct sigaction usa;

		saveLog (true, "start child... \n");
    childPid = fork();
    switch(childPid) 
    {
		case 0:
			//sigset_t mask;
			//sigfillset(&mask);
			//sigdelset(&mask, SIGUSR1);

			//memset(&usa, 0, sizeof(usa));
			//usa.sa_handler = &stopChildDaemon;
			//sigaction(SIGUSR1, &usa, 0);

//find how catch some interrupt		!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			memset(&usa, 0, sizeof(usa));
			usa.sa_handler = &stopChildDaemon;
			sigaction(SIGTERM, &usa, 0);
			//memset(&usa, 0, sizeof(usa));
			//usa.sa_handler = &stopChildDaemon;
			//sigaction(SIGABRT, &usa, 0);

			childDaemonJob();
			saveLog(true, "exit child daemon\n");
			exit(0);

		case -1:
			saveLog (true, "child fork() error\n");
			//return false;
			break;

		default:
			saveLog (true, "child pid = %d\n", childPid);
			//return true;
			break;
    }
}

void SquidDaemon::stopChildDaemon(int signum) 
{
	saveLog (true, "recive TERM signal in child process\n");
	pointToDaemon->workDaemon = false;
	//sleep (1);
	saveLog (true, "save traffic in stopChildDaemon finction\n");
	pointToDaemon->saveTraffic();
	
	sleep (1);

	saveLog (true, "closing socket in stopChildDaemon function\n");
	close(pointToDaemon->sockfd);
	close(pointToDaemon->sockRL);
	saveLog (true, "socket closed in stopChildDaemon function\n");
	saveLog (true, "call exit() in child process\n");

	//fflush (stdin);
	//fflush (stdout);
	//fflush (stderr);
	exit(0);
}

void SquidDaemon::stopParentDaemon(int signum) 
{
	pointToDaemon->workDaemon = false;
	saveLog (true, "recive TERM signal in parent process\n");
	//signal(childPid, SIGUSR1);
	if (kill(pointToDaemon->childPid, SIGTERM))
	//if (kill(pointToDaemon->childPid, SIGUSR1))
	{
		//saveLog (true, "ERROR: Could not send");
	    saveLog (true, "ERROR: Could not send signal to child process %d\n", (int) pointToDaemon->childPid);
	}
}
void SquidDaemon::childDaemonJob()
{
	pointToDaemon = this;

	//saveLog(true, "set host for LDAP\n");
	//lsConn.setHost(ldapServer);
	//saveLog(true, "ready LDAP\n");
	//lsConn.reset();

	size_t stacksize;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	stacksize = 50000;
	pthread_attr_setstacksize (&attr, stacksize);
	pthread_attr_getstacksize (&attr, &stacksize);

	int threadError;
	int i;
	threadInfo ti[numListenThread];
	
	for (i = 0; i < numListenThread; ++i)
	{
		//th_count = i;
		ti[i].pD = this;
		ti[i].numberThread = i;
		//threadError = pthread_create(&listen_thread[i], &attr, listenerThread, (void*)this);
		threadError = pthread_create(&listen_thread[i], &attr, listenerThread, (void*)&ti[i]);
		if (threadError != 0)
		{
			saveLog(true, "Error create listenerThread - % d\n", i+1);
			workDaemon = false;
			return;
		}else
			{
				saveLog(false, "Create listenerThread thread - % d\n", i+1);
			}
	}

	for (i = 0; i < numLocalService; ++i)
	{
		threadError = pthread_create(&service_thread[i], &attr, serviceThread, (void*)this);
		if (threadError != 0)
		{
			saveLog(true, "Error create servise thread - %d\n", i+1);
			workDaemon = false;
			return;
		}else
			{
				saveLog(true, "Create servise thread - %d\n", i+1);
			}
	}


	saveLog (true, "Set effective user and group\n");
	struct passwd *eUserPasswd;
	eUserPasswd = getpwnam (effective_user);
	if (eUserPasswd != NULL)
	{
		int result = setuid (eUserPasswd->pw_uid);
		if (result < 0)
		{
			saveLog (true, "error set effectiv user - %s with uid - %d\n", effective_user, eUserPasswd->pw_uid);
		}
		struct group *eGroup;
		eGroup = getgrnam (effective_group);
		if (eGroup != NULL)
		{
			result = setgid (eGroup->gr_gid);
			if (result < 0)
			{
				saveLog (true, "error set effectiv group - %s with gid - %d\n", effective_group, eGroup->gr_gid);
			}
		}
	}

	readyToWork = true;
	saveLog (true, "ready!!!\n");

	for (i = 0; i < numListenThread; ++i)
	{
		//pthread_detach(listen_thread[i]);
		pthread_join(listen_thread[i], NULL);
		saveLog (true, "wait listen_thread %d done\n", i+1);
	}
	for (i = 0; i < numLocalService; ++i)
	{
		//pthread_detach(service_thread[i]);
		pthread_join(service_thread[i], NULL);
		saveLog (true, "wait service_thread %d done\n", i+1);
	}
 
	saveLog (true, "closing socket in exit child\n");
	close(sockRL);
	close(sockfd);
	saveLog (true, "socket closed in exit child\n");

}

void* SquidDaemon::listenerThread(void *data)
{
	
	//SquidDaemon *sqdp = (SquidDaemon *)(data);
	//static int number_thread = sqdp->th_count;
	threadInfo *ti = (threadInfo *)(data);
	SquidDaemon *sqdp = ti->pD;
	//static 
	int number_thread = ti->numberThread;
	while (!sqdp->readyToWork); 
	
	struct sockaddr_in conn_sa;
    	socklen_t n;
	n = sizeof(conn_sa);
	int fd;

	//char logStr[256];
	struct in_addr userIPaddr;

	char userIPstr[18];
	while (sqdp->workDaemon)
	{

		if((fd = accept(sqdp->sockfd, (struct sockaddr *) &conn_sa, &n)) != -1) 
		{

			userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
			strncpy (userIPstr, inet_ntoa(userIPaddr), 18);
			//strncpy (userIPstr, inet_ntoa(conn_sa.sin_addr), 18);
			sqdp->clientAccess(fd, userIPaddr, userIPstr, number_thread);

			close (fd);

		}
		  else 
			{	
				saveLog (true, "error accept connection from clientTrust\n");
			}
	}
	saveLog (false, "exit listen thread\n");
	pthread_exit(NULL);
}

bool SquidDaemon::clientAccess(int fd, struct in_addr userIPaddr, char *userIPstr, int i_thread)
{
    const int szCMD = 1024;
    char cmd[szCMD] = "";
	char answer[szCMD] = "";
    char cmd2[szCMD] = "";
    bool deRegistration = false;
	
	char seps [] = " ;\n";
	if (recv(fd, cmd, szCMD, 0) > 0)
	{
		char *beginStr = "registrate->";
		char *myStr, *myUser, *myUserIPstr, *myUserHostNameStr;
		//char logStr[1024];
		//sprintf (answer, "don`t have typed string");
		
		myCrypt(cmd);

		bool registerSucces = false;
			if (strchr (cmd, '\n') == NULL) 
			{
				saveLog (true, "don`t recive first string in registration procedure!!!\n");
				return false;
			}
		if (strstr(cmd, "[Public]") == NULL)
		{
			myStr = strstr(cmd, beginStr);
			if (myStr != NULL)
			{
				myStr += strlen(beginStr);
				if ((myUser = strtok(myStr, seps)) != NULL)
				{
					if ((myUserIPstr = strtok(NULL, seps)) != NULL)
					{
						if ((myUserHostNameStr = strtok(NULL, seps)) != NULL)
						{
							registerSucces = true;
							if (userIPaddr.s_addr != inet_addr(myUserIPstr))
							{
								//snprintf (logStr, 1023, "user - %s - IP  don`t conform to real IP %s !!!!!!!!!!!", myUser, myUserIPstr, userIPstr, true);
								saveLog (true, "from user %s - IP %s don`t conform to get IP %s !!!!!!!!!!!\n",
												myUser, myUserIPstr, userIPstr);
							}
						}
					}
				}
			}
			else
				{
					saveLog (true, "don`t have typed string IP-%s\n", userIPstr);
				}
			
			if	(registerSucces)
			{
				time_t ltime;
				time (&ltime);
				sprintf (answer, "Success registration from->%s %s %d \n", myHostName, myIPstr, ltime);

				myCrypt(answer);
				if (send(fd, answer, strlen(answer)+1, 0) > 0) 
				{
					bool attestation = false;
					if (recv(fd, cmd2, szCMD, 0) > 0)
					{
						myCrypt(cmd2);
							if (strchr (cmd2, '\n') == NULL) 
							{
								saveLog (true, "don`t recive second string  in registration procedure!!!\n");
								return false;
							}

						char *attestationStr, *servTimeStr;
						if ((attestationStr = strtok(cmd2, seps)) != NULL)
						{
							if ( (servTimeStr = strtok(NULL, seps)) != NULL)
							{
								time_t servTime = atol(servTimeStr);
								if (servTime > ltime) attestation = true;
								else 
									saveLog(false, "Error Server answer Time");
							}else 
								saveLog(false, "Error Time string");
						}else 
							saveLog(false, "Error attestation string");
					}
					if (attestation)
					{
						int rest = 0, rc = -1;
						char *p;
						for( p = myUser; p < myUser + strlen( myUser ); p++ )
						{
							if ( isascii(* p) )
							{
								if( isupper( *p ) )
									*p = char( tolower( *p ) );
							}
						}
						int uId;
						rc = registerUserIP(userIPaddr, userIPstr, myUser, rest, i_thread, uId);
						sprintf (answer, "Attestation rest->%d %d \n", rest, rc);
						myCrypt(answer);
						send(fd, answer, strlen(answer)+1, 0);
					}else 
						saveLog (false, "attestation error\n");
				}
			}
			else
				{
					saveLog (false, "error registration\n");
					sprintf (answer, "Error registration from->%s %s \n", myHostName, myIPstr);
					myCrypt(answer);
					send(fd, answer, strlen(answer)+1, 0);
				}

		}
		else 
			{
				deregisterUserIP(userIPaddr, userIPstr);
				deRegistration = true;
			}
	}
	return deRegistration;
}

int SquidDaemon::registerUserIP(struct in_addr userIPaddr, char *userIPstr, char *userName, int &getLimit, int i_thread, int &uId)
{
	char fUserIP[256];
	//char logStr[1024];

	char rlBuf[1024];
	char seps [] = " ;\0\n";

	int myLDAPLimit = 0, myLDAPUnderLimit = 0, rc = -1;
	getLimit = 0;
	//rc = myLdapSSLConnect(userName, ldapServer, myLDAPLimit, myLDAPUnderLimit);
	//rc = lsConn[i_thread].myLdapInfo(userName, myLDAPLimit, myLDAPUnderLimit);
				//MUTEX!!!!
       //pthread_mutex_lock(&request_mutex);
	rc = lsConn.myLdapInfo(userName, myLDAPLimit, myLDAPUnderLimit);
       //pthread_mutex_unlock(&request_mutex);		
	if (rc == -1)
	{
		saveLog(true, "LDAP error\n");
		myLDAPLimit = 0;
		myLDAPUnderLimit = 0;
	}

	time_t realTime, registerTime;
	time (&realTime);
		
	unsigned int real_month, last_month, real_year, last_year;

	struct tm *today, *last;
	today =  localtime( &realTime );
		real_month = today->tm_mon;
		real_year = today->tm_year;

	snprintf (fUserIP , 255, "%s/_%s.mda", baseDir, userIPstr);
	FILE *fUI;

	fUI = fopen (fUserIP, "w");
	if (fUI != NULL)
	{
		fprintf (fUI, "%s;%ld;", userName, realTime);
		fclose (fUI);
	}
	 else 
		{
			saveLog (true, "error open fileUserIP (%s) for write !!!!\n", userIPstr);
		}

	snprintf (fUserIP, 255, "%s/%2.2d.%2.2d__%s.mdu", baseDir, today->tm_mon + 1, today->tm_year - 100, userName);
	unsigned long allTraffic = 0, cacheTraffic = 0;//, underLimit= 0;


	bool present;
	present = false;

	int i;
	unsigned int localUserID;
	localUserID = collected.size();
	//localUserID = 0;
	bool fileNotExist = true;
	for (i = 1; i < collected.size(); ++i)
	{
		if (strcmp(collected[i].userName, userName) == 0)
		{
			collected[i].userLimit = myLDAPLimit;
			collected[i].underLimit = myLDAPUnderLimit;

			registerTime = collected[i].lastTime;
			last =  localtime( &registerTime );
			last_month = last->tm_mon;
			last_year = last->tm_year;
	 		if ((last_month != real_month) || (last_year != real_year))
			{
				fileNotExist = true;
				collected[i].userTraffic = 0;
				collected[i].userCacheTraffic = 0;
				collected[i].oldUserTraffic = 0;
			}else
				fileNotExist = false;

			collected[i].lastTime = realTime;

			allTraffic = collected[i].userTraffic;
			cacheTraffic = collected[i].userCacheTraffic;
			//underLimit = collected[i].underLimit;
			localUserID = collected[i].userID;
			present = true;
				break;
		}
	}
	if (!present)
	{
		fUI = fopen (fUserIP, "r");
		if (fUI != NULL)
		{
			char *sUserName, *userLimitStr, *allTrafficStr, *cacheTrafficStr, *underLimitStr, *registerTimeStr;
			if (fgets(rlBuf, 1023, fUI) != NULL)
			{
				fileNotExist = false;
				sUserName = strtok (rlBuf, seps);
				userLimitStr = strtok (NULL, seps);
				if (userLimitStr == NULL)
					userLimitStr = "0";
				allTrafficStr = strtok (NULL, seps);
				if (allTrafficStr == NULL)
					allTrafficStr = "0";
				cacheTrafficStr = strtok (NULL, seps);
				if (cacheTrafficStr == NULL)
					cacheTrafficStr = "0";
				underLimitStr = strtok (NULL, seps);
				if (underLimitStr == NULL)
					underLimitStr = "0";
				allTraffic = atoi(allTrafficStr);
				cacheTraffic = atoi(cacheTrafficStr);
				//underLimit = atoi(underLimitStr);
				if ((registerTimeStr = strtok (NULL, seps)) == NULL)
					registerTime = realTime;
				else
					registerTime = atol (registerTimeStr);
//very stuped!!!
						last =  localtime( &registerTime );
						last_month = last->tm_mon;
						last_year = last->tm_year;
	 					if ((last_month != real_month) || (last_year != real_year))
						{
							allTraffic = 0;
							cacheTraffic = 0;
						}

			}
			fclose (fUI);
		}
		 else 
			{
				saveLog (true,  "can not find for open fileUserTraffik (%s) for read -> recreate\n", userIPstr);
			}

		SUserData myUserData;
		strcpy (myUserData.userName, userName);
		myUserData.userLimit = myLDAPLimit;
		myUserData.underLimit = myLDAPUnderLimit;
		myUserData.userTraffic = allTraffic;

		myUserData.userCacheTraffic = cacheTraffic;
		//myUserData.underLimit = underLimit;

		myUserData.oldUserTraffic = myUserData.userTraffic;
		myUserData.userID = collected.size();
		myUserData.lastTime = realTime;
		collected.push_back(myUserData);

//		firstRegistration = true;
		saveLog (true, "registrate user - %s \n", userName);

	}

	if (fileNotExist)
	{
		fUI = fopen (fUserIP, "w");
		if (fUI != NULL)
		{
			fprintf (fUI, "%s;%d;%d;%d;%d;%d;", 
				userName, myLDAPLimit, allTraffic, cacheTraffic, myLDAPUnderLimit, realTime);
			fclose (fUI);
		}
		 else 
			{
				saveLog (true, "error open fileUserTraffik (%s) for write!!!\n", userIPstr);
			}
	}

	if (collected[localUserID].userID != localUserID)
	{
		saveLog(true, "not accociate betwen userID and member\n");
	}

	present = false;

  if (localUserID > 0)
	{
		for (i = 1; i < share.size(); ++i)
		{
			if (share[i].userIP.s_addr == userIPaddr.s_addr)
			{
				time (&realTime);
				strcpy (share[i].userName, userName);
				if (share[i].userID != localUserID)
				{
					share[i].detachConnection = false;
					share[i].dropTime = 0;
					saveLog (true, "registrate user - %s on present IP - %s \n", userName, userIPstr);
				}
				share[i].userID = localUserID;
				share[i].rTime = realTime;
				present = true;
				uId = i;
					break;
			}
		}
	}
	//uId = localUserID;
	if (!present)
	{
		time (&realTime);

		SIdentUser myIdentUser;
		strcpy (myIdentUser.userName, userName);
		strcpy (myIdentUser.strUserIP, userIPstr);
		myIdentUser.userIP = userIPaddr;
		myIdentUser.rTime = realTime;

		myIdentUser.userID = localUserID;
		myIdentUser.detachConnection = false;
		myIdentUser.dropTime = 0;

		uId = share.size();
		share.push_back(myIdentUser);

		saveLog (true, "registrate user - %s on new IP - %s \n", userName, userIPstr);
	}

	getLimit = (myLDAPLimit - allTraffic + cacheTraffic + myLDAPUnderLimit);
	return rc;
}

void SquidDaemon::deregisterUserIP(struct in_addr userIPaddr, char *userIPstr)
{
	char fUserIP[256];
	FILE *fUI;

	vector<SIdentUser>::iterator iIdent;
	char userNameStr[256];
	//if (firstRegistration)
	//{
		for(iIdent = share.begin(); iIdent != share.end(); ++iIdent)
		{
			if ((*iIdent).userIP.s_addr == userIPaddr.s_addr)
			{
				time_t realTime;
				time (&realTime);

				snprintf(userNameStr, 255, collected[(*iIdent).userID].userName);
				strcpy ((*iIdent).userName, "Public");
				(*iIdent).detachConnection = false;
				(*iIdent).userID = 0;
				(*iIdent).rTime = 0;
				(*iIdent).dropTime = realTime + close_time;
				//if (!(*iIdent).detachConnection) {(*iIdent).detachConnection = true;}
				break;
			}
		}
	//}
	snprintf (fUserIP , 255, "%s/_%s.mda", baseDir, userIPstr);
	fUI = fopen (fUserIP, "w");
	if (fUI != NULL)
	{
		fprintf (fUI, "[Public];0;");
		fclose (fUI);
	}
	saveLog (true, "deregustrate user - %s on IP %s\n", userNameStr, userIPstr);
}

void* SquidDaemon::serviceThread(void *data)
{
	

	SquidDaemon *sqdp = (SquidDaemon *)(data);
	
	//while (!tcpD->readyToWork); 

	struct sockaddr_in conn_sa;
    socklen_t n;
	n = sizeof(conn_sa);
	int fd;

	while (sqdp->workDaemon)
	{

		if((fd = accept(sqdp->sockRL, (struct sockaddr *) &conn_sa, &n)) != -1) 
		{
			int cUserID = 0;
			if (sqdp->readyToWork)
			{
				//if (sqdp->firstRegistration)
				//{
					struct in_addr userIPaddr;
					char userIPstr[18];
					userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
					sprintf (userIPstr, "%s", inet_ntoa(userIPaddr));
					//sqdp->sendToSquid( fd, conn_sa.sin_addr, inet_ntoa(conn_sa.sin_addr), cUserID);
					sqdp->sendToSquid( fd, conn_sa.sin_addr, userIPstr, cUserID);
				//}
			}
			close (fd);
			if (cUserID > 0)
			{
					sqdp->saveUserTrafficToDisk(sqdp->collected[cUserID]);
			}
		}else 
			{	
				if (fd < 0)
				{
					//if(errno == EAGAIN || errno == EWOULDBLOCK)
					//{
						saveLog (false, "error accept connection from squid\n", false);
						//break;
					//}
				}
			}
		//close (fd);
	}
	saveLog (false, "exit service thread\n");
	pthread_exit(NULL);
}

void SquidDaemon::sendToSquid(int fd, struct in_addr rlIPaddr, char *rlIPstr, int &cUserID)
{
	const int szCMD = 1024;
	char cmd[szCMD] = "";
	char answer[szCMD] = "";

	//char logStr[255];

	int myLimit, myTraffic, myCacheAdd, myCacheTraffic, myUnderLimit;
	char seps [] = " ;\0\n";
	char *externalAclStr = "Who is user ", *writeComplete = "Write complete ";//, *squidStr = "User Cache "
	char *myStr, *userIP, *user, *cacheSizeStr, *cached, *requestHost;
	
	int i;
	struct in_addr userIPaddr;

	myLimit = 0;
	myTraffic = 0;
	myCacheTraffic = 0;
	myCacheAdd = 0;
	myUnderLimit = 0;

	time_t realTime;
	time (&realTime);
		bool findUserfromIP = false;

	if (recv(fd, cmd, szCMD, 0) > 0)
	{
		sprintf (answer, "error format\n");
		if ((myStr = strstr(cmd, writeComplete)) != NULL)
		{
										//saveLog (true, cmd);
			snprintf (answer, 1023, "User Permision ALLOW\n");
			myStr += strlen(writeComplete);
			//if (firstRegistration)
			//{
				if ((userIP = strtok(myStr, seps)) != NULL)
				{
									//saveLog(true, "user IP %s\n", userIP);
					if ((cacheSizeStr = strtok(NULL, seps)) != NULL)
					{
						if ((cached = strtok(NULL, seps)) != NULL)
						{
							requestHost = strtok(NULL, seps);
							myCacheAdd = atoi(cacheSizeStr);
							//if (myCacheAdd > 0)
							//{
							userIPaddr.s_addr = inet_addr(userIP);
							int shareNomer = 0;
							for(i = 1; i < share.size(); ++i)
							{
								if ( share[i].userIP.s_addr == userIPaddr.s_addr)
								{
									shareNomer = i;
									//saveLog(true, "find user (%s) time=%d utime=%d uid=%d\n", userIP, realTime, share[i].rTime, share[i].userID);
									//time_t RTime = share[i].rTime;
									//int uId = 0;
									//if (strstr(collected[share[i].userID].userName, "Public") != NULL)
									//	sendRequest(userIPaddr, userIP, uId);

									if (((realTime - share[i].rTime) < allowTime) && (share[i].userID > 0))
									{
										findUserfromIP = true;
										userInfo(i, cUserID, cached, myCacheAdd, realTime);
									}
									else {
											//send request for user!!!
											//char getUserName[1024] = "";
											int uId = 0;
											if (sendRequest(userIPaddr, userIP, uId))
											{
												userInfo(uId, cUserID, cached, myCacheAdd, realTime);
												shareNomer = uId;
											}
											else
												{
														saveLog (true, "dont answer elapsed time - SQUID string %s\n", userIP);
													saveLog (true, "user IP elapsed time - SQUID string - %s\n", cmd);
													if (!share[i].detachConnection)
													{
														share[i].dropTime = realTime + close_time;
														share[i].detachConnection = true;
														saveLog(true, "set user (%s) DROP time\n", userIP);
													}
												}

										}
									if (share[i].dropTime > realTime)
									{
										snprintf (answer, 1023, "User Permision CLOSE\n");
												saveLog(true, "close user (%s) socket in Squid\n", userIP);
									}
									else
									{
										snprintf (answer, 1023, "User Permision ALLOW\n");
									}
									break;
								}//find user IP
							}//for(i = 0; i < share.size(); ++i)
							if (!findUserfromIP)
								{
									//char getUserName[1024] = "";
									int uId = 0;
									if (sendRequest(userIPaddr, userIP, uId))
									{
										userInfo(uId, cUserID, cached, myCacheAdd, realTime);
										if (share[uId].dropTime > realTime)
										{
											snprintf (answer, 1023, "User Permision CLOSE\n");
													saveLog(true, "close user (%s) socket in Squid\n", userIP);
										}
										else
										{
											snprintf (answer, 1023, "User Permision ALLOW\n");
										}
									}
									else
									{
												saveLog (true, "dont answer find user - SQUID string %s\n", userIP);
										saveLog (true, "NOT find user - SQUID string -  %s\n", cmd);
										deregisterUserIP(userIPaddr, userIP);
										/*if (!share[i].detachConnection)
										{
											share[i].dropTime = realTime + close_time;
											share[i].detachConnection = true;
											saveLog(true, "set user (%s) DROP time\n", userIP);
										}*/
									}
								}

							//}//myAddCache
						}//cache
						else {saveLog (true, "error find user cache info from SQUID %s\n", cmd);}
					}//cacheSizeStr
					else {saveLog (true, "error find user Size from SQUID %s\n", cmd);}
					//else snprintf (answer, 1023, "User Permision ALLOW\n");
				}//userIP
				else {saveLog (true, "error find user IP from SQUID %s\n", cmd);}
			//}//firstRegistration

			send(fd, answer, strlen(answer)+1, 0);
		}
			else 
			{
				if ((myStr = strstr(cmd, externalAclStr)) != NULL)
				{
						myStr += strlen(externalAclStr);
						//char localUserName[1024];
						if ((userIP = strtok(myStr, seps)) != NULL)
						{
									userIPaddr.s_addr = inet_addr(userIP);
									//if (firstRegistration)
									//{
										bool findUser = false;
												//time_t realTime;
												//time (&realTime);
										snprintf (answer, 1023, "User description UnKnown 0 0 0 0");
										for(i = 1; i < share.size(); ++i)
										{
											if ( share[i].userIP.s_addr == userIPaddr.s_addr)
											{
												if (((realTime - share[i].rTime) < allowTime) && (share[i].userID > 0))
												{
												myLimit = collected[share[i].userID].userLimit;
												myTraffic = collected[share[i].userID].userTraffic;
												myCacheTraffic = collected[share[i].userID].userCacheTraffic;
												myUnderLimit = collected[share[i].userID].underLimit;
												snprintf (answer, 1023, "User description %s %d %d %d %d", 
														collected[share[i].userID].userName, 
														myLimit, 
														(myTraffic - myCacheTraffic),
														myUnderLimit,
														share[i].rTime);

												//if (((realTime - share[i].rTime) < allowTime) && (share[i].userID > 0))
													findUser = true;
												break;
												}
											}
										}//for(i = 0; i < share.size(); ++i)
										if (!findUser)
										{
											int uId = 0;
											//saveLog (true, "not find user %s\n", userIP);
											if (sendRequest(userIPaddr, userIP, uId))
											{
												//saveLog (true, "name %s\n", userIP);
												snprintf (answer, 1023, "User description %s %d %d %d %d", 
														collected[share[uId].userID].userName, 
														collected[share[uId].userID].userLimit, 
														(collected[share[uId].userID].userTraffic - collected[share[uId].userID].userCacheTraffic),
														collected[share[uId].userID].underLimit,
														collected[share[uId].userID].lastTime);
											}
											else 
											{
												saveLog (true, "dont answer %s\n", userIP);
											}
										}
									//}//if (firstRegistration)
						}
						send(fd, answer, strlen(answer)+1, 0);
				}
				else 
					{
						saveLog (true, "error get local formt %s\n", cmd);
					}
			}
	}
		
}
bool SquidDaemon::userInfo(int &i, int &cUserID, char *cached, int myCacheAdd, time_t realTime)
//bool SquidDaemon::userInfo(int &i, int &cUserID, char *userIP, char *cached, int myCacheAdd, time_t realTime)
{
	bool acsess = true;
	
	if (strstr(cached, "toinet") == NULL)
	{
		collected[share[i].userID].userTraffic += myCacheAdd;
		if (strstr(cached, "cache") != NULL)
		{
			collected[share[i].userID].userCacheTraffic += myCacheAdd;
		}
	}
	if ((collected[share[i].userID].userTraffic - 102400) > 
					collected[share[i].userID].oldUserTraffic)
	{
		collected[share[i].userID].oldUserTraffic = collected[share[i].userID].userTraffic;
		unsigned int real_month, last_month, real_year, last_year;

		struct tm *today, *last;
		today =  localtime( &realTime );
		real_month = today->tm_mon;
		real_year = today->tm_year;
			time_t	registerTime = collected[share[i].userID].lastTime;
			last =  localtime( &registerTime );
		last_month = last->tm_mon;
		last_year = last->tm_year;
		if ((last_month != real_month)	|| (last_year != real_year))
		{
			collected[share[i].userID].userTraffic = 0;
			collected[share[i].userID].userCacheTraffic = 0;
			collected[share[i].userID].oldUserTraffic = 0;
		}
		//saveUserTrafficToDisk(collected[share[i].userID]);
		cUserID = share[i].userID;

				int uId = 0;
				//saveLog (true, "update user info - %s\n", share[i].strUserIP);
				if ( !sendRequest(share[i].userIP, share[i].strUserIP, uId) )
				{
					saveLog (true, "deregistration %s user IP\n", 	share[i].strUserIP);
					deregisterUserIP(share[i].userIP, share[i].strUserIP);
				}
					else
					{
						//saveLog (true, "Update registration of %s user %s\n", 	share[uId].strUserIP, collected[share[uId].userID].userName);
					}

	}

	if (collected[share[i].userID].underLimit != -1)
	{
		//kill user connection if limit is allowed
		int remains = collected[share[i].userID].userLimit -
			collected[share[i].userID].userTraffic + 
			collected[share[i].userID].userCacheTraffic +
			collected[share[i].userID].underLimit;
		//saveLog(true, "Limited !!! user (%s) connection remains=%d dC=%d\n", userIP, remains, int(share[i].detachConnection));
		if (remains < 10)
		{
			saveLog(true, "user (%s) limit exceeding\n", share[i].strUserIP);
			if (!share[i].detachConnection)
			{
				//char dstIPstr[18];
   				//snprintf (dstIPstr, 17, "%s", inet_ntoa (userIP) );
				share[i].dropTime = realTime + close_time;
				share[i].detachConnection = true;
				saveLog(true, "set user (%s) DROP time\n", share[i].strUserIP);
				acsess = false;
			}
		}	
		if (remains > 10240)
		{
			if (share[i].detachConnection)
			{
				share[i].detachConnection = false;
						saveLog(true, "set user (%s) reset detachConnection flag\n", share[i].strUserIP);
				acsess = true;
			}
		}
	}
	return acsess;
}

//bool SquidDaemon::sendRequest(struct in_addr userIPaddr, char *userIPstr, char *userName, int &uId)
bool SquidDaemon::sendRequest(struct in_addr userIPaddr, char *userIPstr, int &uId)
{
	const int szBif = 1024;
	//int  count;
	char recbuf[szBif], sendbuf[szBif];
	char seps [] = " ;	\0\n";
	int s, rc;
	struct sockaddr_in clientsockaddr;
	//struct in_addr localIPaddr;
	//localIPaddr.s_addr = userIPaddr.s_addr;
	bool Code;

	char *firstStr = "Attestation->", *beginStr, *timeStr, *userNameStr, *getUserIPstr;

	time_t realTime, getTime;
	
	//for (count = 0; count < 3; ++ count)
	//{
	Code = false;
	time (&realTime);
	userNameStr="-";
	
	//s = socket(AF_INET, SOCK_STREAM, 0);
	s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);//SO_REUSEADDR

	if (s > 0)
	{
	    int on = 1;
			if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on)) < 0)
			{
				saveLog (true, "SetReuseAddr error\n");
			}
			struct linger L;
			L.l_onoff = 0;		/* off */
			L.l_linger = 0;
			if (setsockopt(s, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
			{
				saveLog (true, "SetNoLinger error\n");
			}

		clientsockaddr.sin_addr.s_addr =  userIPaddr.s_addr;
		//clientsockaddr.sin_addr.s_addr =  inet_addr(regProc);
		clientsockaddr.sin_family = AF_INET;
		clientsockaddr.sin_port   = htons(clientPort);
		rc = connect(s, (struct sockaddr*)&clientsockaddr, sizeof(struct sockaddr_in));
		if (rc == 0)
		{
			sprintf (sendbuf, "Who are you from->%s %s %d \n",  myHostName, myIPstr, realTime);
			myCrypt(sendbuf);
			//rc = send(s, sendbuf, strlen(sendbuf)+1, 0);//send
			rc = send(s, sendbuf, strlen(sendbuf) + 1, 0);//send
			//rc = send(s, sendbuf, szBif, 0);//send
			if (rc > 0)
			{
				rc = recv(s, recbuf, szBif, 0);
				if ( rc > 0)
				{
					myCrypt(recbuf);
					sprintf (sendbuf, "first-string \n");
					if ((beginStr=strstr(recbuf, firstStr)) != NULL)
					{
						beginStr += strlen (firstStr);
						//saveLog (true, "str - %s\n", beginStr);
						if ((timeStr = strtok (beginStr, seps)) != NULL)
						{
							if ((userNameStr = strtok (NULL, seps)) != NULL)
							{
								if ((getUserIPstr = strtok (NULL, seps)) != NULL)
								{
									sprintf (sendbuf, "time-out \n");
									getTime = atol(timeStr);
									//saveLog (true, "time - %d name - %s\n", getTime, userNameStr);

									if (getTime > realTime)
									//if (getTime = (realTime + 5))
									{
										//strncpy (userName, userNameStr, 1024);
										//sprintf (userName, "%s",userNameStr);
										char *p;
										for( p = userNameStr; p < userNameStr + strlen( userNameStr ); p++ )
										{
											if ( isascii(* p) )
											{
												if( isupper( *p ) )
													*p = char( tolower( *p ) );
											}
										}
										if (userIPaddr.s_addr != inet_addr(getUserIPstr))
										{
											saveLog (true, "network IP - %s do not equal ClienTrust IP - %s\n", userIPstr, getUserIPstr);
										}
	
										int getLimit = 0, retcode = -1, numThread = 0;
										retcode = registerUserIP(userIPaddr, userIPstr, userNameStr, getLimit, numThread, uId);
										if (retcode > 0)
											Code = true;
										sprintf (sendbuf, "Attestation rest->%d %d \n", getLimit, retcode);
									}
											else 	saveLog (true, "time answer user error \n");

								}
							}
						}//if ((beginStr=strstr(recbuf, firstStr)) != NULL)
									//close (s);
					}//rc = recv(s, recbuf, sizeof (recbuf), 0);if ( rc > 0)
				//	saveLog(true, "send answer %s\n", sendbuf);
					myCrypt(sendbuf);
					rc = send(s, sendbuf, strlen(sendbuf) + 1, 0);
					//rc = send(s, sendbuf, szBif, 0);// szBif
					if ( rc != strlen(sendbuf) + 1)
					{
						myCrypt(sendbuf);
						saveLog(true, "send confirmation <%s> to %s on %s ERROR\n", sendbuf, userNameStr, userIPstr);
					}
					//sleep (1);
					/*rc = connect(s, (struct sockaddr*)&clientsockaddr, sizeof(struct sockaddr_in));
					if (rc == 0)
					{
						rc = send(s, sendbuf, strlen(sendbuf), 0);
						if (rc != strlen(sendbuf))
						{
							saveLog(true, "error second SEND for user %s on %s\n", userNameStr, userIPstr);
						}
						if ( rc > 0)	
						{
							rc = recv(s, recbuf, sizeof (recbuf), 0);
							if ( rc > 0)
							{
								saveLog(true, "get confirmation <%s> from %s on %s\n", recbuf, userNameStr, userIPstr);
							}
							else
							{
								saveLog(true, "ERROR recive confirmation from %s on %s\n", userNameStr, userIPstr);
							}
						}
						else
						{
							saveLog(true, "error send limit for user %s on %s\n", userNameStr, userIPstr);
						}
						close (s);		
					}
					else 
						{
							saveLog(true, "error second connect for user %s on %s\n", userNameStr, userIPstr);
						}*/
				}
				else 	saveLog (true, "send answer to user \n");
			}
			else saveLog (true, "error connect to user \n");
				close(s);
		}
	}
	//if (Code) break;
	//saveLog (true, "error reqest user IP - %s - reconnect\n", userIPstr);
	//}
	return Code;
}

void SquidDaemon::saveTraffic()
{
	//if (firstRegistration)
	if (collected.size() > 1)
	{
		int j;
		for(j = 1; j < collected.size(); ++j)
		{
			saveUserTrafficToDisk(collected[j]);
		}
	}

}

void SquidDaemon::saveUserTrafficToDisk(SUserData &sud)
{

	char userLimitFileName[clLen];//readBuff[clLen], writeBuff[clLen], 

	time_t realTime, registerTime;
	time (&realTime);

	struct tm *today, *last;
	today =  localtime( &realTime );

	snprintf (userLimitFileName, 255, "%s/%2.2d.%2.2d__%s.mdu", baseDir, today->tm_mon + 1, today->tm_year - 100, sud.userName);

		unsigned int real_month, last_month, real_year, last_year;

		real_month = today->tm_mon;
		real_year = today->tm_year;
	
		registerTime = sud.lastTime;
		last =  localtime( &registerTime );
		last_month = last->tm_mon;
		last_year = last->tm_year;
 		if ((last_month != real_month) || (last_year != real_year))
		{
			sud.userTraffic = 0;
			sud.userCacheTraffic = 0;
			sud.oldUserTraffic = 0;
		}

	FILE *uLF;
	uLF = fopen(userLimitFileName, "w");
	if (uLF != NULL)
	{
		fprintf (uLF, "%s;%d;%d;%d;%d;%d;", 
			sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.lastTime);
		fclose (uLF);
	}
	 else 
		saveLog (true, "Cannot open user limit file to write !!!\n");

}


int main(int argc, char *argv[]) 
{

	char *infStr;
	char seps [] = "=;\0\n";
	
#ifdef _INF_FILE
	snprintf (ldapServer, 256, "192.168.1.3 192.168.1.4 192.168.1.1");
	snprintf (daemonServer, 18, "192.168.1.38");
	listenPort=712;
	servicePort=702;
	proxyPort=8080;
	snprintf (daemonDir, 1024, "/usr/novell/sys/mySQUID/squid_daemon_s");
	snprintf (baseDir, 1024, "/usr/novell/sys/mySQUID/userbase");
	snprintf (logDir, 1024, "/usr/novell/sys/mySQUID");
	snprintf (effective_user, 256, "tsquid");
	snprintf (effective_group, 256, "tsquidgroup");
	clientPort = 711;
#endif
	
	
	char infFileName[1024];
	//snprintf (infFileName, 1024, "squid_daemon.inf");
	snprintf (infFileName, 1024, "/usr/novell/sys/mySQUID/squid_daemon_s/squid_daemon.inf");


	char *iFN;
	if (argc > 1)
	{
		if ((infStr = strstr(argv[1], "--inf=")) != NULL )
		{
			infStr += strlen("--inf=");
			if ((iFN = strtok(infStr, seps)) != NULL)
			{
				snprintf (infFileName, 1024, "%s", iFN);
			}
			
		}
	}

	FILE *infoFile;
	infoFile = fopen (infFileName, "r");
	char rBuf [4096];//, ldapString[256];
	if (infoFile != NULL)
	{
		int countii = 0;
		int numberVariable = 11;
		printf ("open inf file\n");
		while (fgets(rBuf, 4096, infoFile) != NULL)
		{
			int ii;
			char *configMass [] = {"ldapServer",
									"daemonServer",
									"listenPort",
									"servicePort",
									"proxyPort",
									"daemonDir",
									"baseDir",
									"logDir",
									"effective_user",
									"effective_group",
									"clientPort"};

			char *confString, *configMean;//, *ldapServerIP;

			for (ii = 0; ii < numberVariable; ++ii)
			{
				if ((confString = strstr(rBuf, configMass[ii])) != NULL)
				{
					countii ++;
					confString += strlen (configMass[ii]);
					if ((configMean = strtok(confString, seps)) != NULL)
					{
						switch (ii)
						{
							case 0: /*snprintf (ldapString, 256, "%s", configMean);
								sprintf (ldapServer, "");
								while ( (ldapServerIP = strtok(ldapString, ",;\n")) != NULL)
								{
									//sprintf (ldapServer, "%s %s", ldapServer, ldapServerIP);
									strcat (ldapServerIP);
								}*/
								snprintf (ldapServer, 256, "%s", configMean);
								printf ("ldapServer - %s +\n", ldapServer);
								break;
							case 1: snprintf (daemonServer, 256, "%s", configMean);
								printf ("daemonServer - %s +\n", daemonServer);
								break;
							case 2: listenPort = atoi (configMean);
								printf ("listenPort - %d +\n", listenPort);
								break;
							case 3: servicePort = atoi (configMean);
								printf ("servicePort - %d +\n", servicePort);
								break;
							case 4: proxyPort = atoi (configMean);
								printf ("proxyPort - %d +\n", proxyPort);
								break;
							case 5: snprintf (daemonDir, 1024, "%s", configMean);
								printf ("daemonDir - %s +\n", daemonDir);
								break;
							case 6: snprintf (baseDir, 1024, "%s", configMean);
								printf ("baseDir - %s +\n", baseDir);
								break;
							case 7: snprintf (logDir, 1024, "%s", configMean);
								printf ("logDir - %s +\n", logDir);
								break;
							case 8: snprintf (effective_user, 256, "%s", configMean);
								printf ("effective_user - %s +\n", effective_user);
								break;
							case 9: snprintf (effective_group, 256, "%s", configMean);
								printf ("effective_group - %s +\n", effective_group);
								break;
							case 10: clientPort = atoi (configMean);
								printf ("clientPort - %d +\n", proxyPort);
								break;
						}
					}
				}
			}

		}
		fclose (infoFile);
		if (countii < numberVariable)
		{
			printf ("Not full inf file\n");
			exit (0);
		}
	}
	else
		{
			printf ("Cannot open SquidDaemon inf file !!!\n");
			exit (0);
		}

	daemonServerIP.s_addr = inet_addr(daemonServer);
	snprintf (logFileName, 1024, "%s/mySquidDaemon.log", logDir);
	//printf ("log - %s +\n", logFileName);

	SquidDaemon sqd;

	sqd.execute();

	return 0;
}


bool myCrypt(char *strCript)
{
	unsigned int myLen;
	unsigned char cryptSymbol;

	myLen = strlen(strCript);
	cryptSymbol = myLen & 7;

	if ((myLen < 1) || (myLen >= 1024)) return false;
	for (int i = 0; i < myLen ; i ++)
	{
		strCript[i] = (strCript[i] ^ cryptSymbol);

		cryptSymbol --;
		if (cryptSymbol <= 0)
		{
			cryptSymbol = myLen & 7;
		}
	}

	return true;
}

void print_to_file (FILE *fp, const char *format, va_list args)
{
	vfprintf(fp, format, args);
}

void saveLog(bool ntime, const char *format,...)
{
	va_list marker;
    va_start(marker, format);
	FILE *fp;
	fp = fopen(logFileName,"a+");
	if (fp != NULL)
	{
		if (ntime)
		{
			time_t workTime;
			time (&workTime);
			struct tm *today;
			today =  localtime( &workTime );
			fprintf (fp, "%d.%d.%d-%d:%d:%d >", 
					today->tm_mday, today->tm_mon+1, today->tm_year-100 , today->tm_hour, today->tm_min, today->tm_sec);
		}
			
		static char f[4096];   
		snprintf (f, 4095, "%s", format);

		if (strlen(f) > 0)
			print_to_file (fp, f, marker);
		fclose(fp);
	}
	va_end( marker );
}




// Local Variables:
// mode:C++
// End:
