//#include <ldap.h>
//#include <ctype.h>
#include <ldap_ssl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "myldap.h"
#include <vector>
#include <string>
#include <iostream>
#include <fstream>

using std::string;
using std::vector;
using std::iterator;

//extern void saveLog(char *mylog, bool ntime);
//extern void saveLog(bool ntime, const char *format, va_list args);
//extern void saveLog(bool ntime, const char *format,...);
//extern void saveLog(va_alist);
extern void saveLog(bool ntime, const char *format,...);
//void saveLog(bool ntime, const char *format, va_list args);


//-------------------------------------------------------------------------
//int myLDAP::myLdapSearch(LDAP *ld, struct timeval &timeOut, char *searchBase, char  **attrs, int &sLimit, int &sUnderLimit, bool userData)
//int myLDAP::myLdapSearch(LDAP *lovalLD, char *searchBase, char  **attrs, int &sLimit, int &sUnderLimit, bool userData)
int myLDAP::myLdapSearch(LDAP *lovalLD, char *searchBase, char  **attrs,
														int &sLimit, int &sUnderLimit, vector <attrName> &userGroups)
{
	//int mylimit = 0;
	//char logStr[1024];
	LDAPMessage *searchResult, *entry;
	BerElement  *ber;
    char        *attribute, **values;//, *dn;       


	int	rc, i;
	rc = ldap_search_ext_s(  
                    lovalLD,                    // LDAP session handle 
                    searchBase,            // container to search 
                    LDAP_SCOPE_BASE,   // search scope 
                    NULL,     // search filter 
                    attrs,                 // "1.1" returns entry names only
                    0,                     // return attributes and values 
                    NULL,                  // server controls 
                    NULL,                  // client controls 
                    &timeOut,              // &timeOut  search timeout 
                    LDAP_NO_LIMIT,         // no size limit 
                    &searchResult );       // returned results 
    
    if ( rc != LDAP_SUCCESS ) 
    {
        //printf("ldap_search_ext_s: %s\n", ldap_err2string( rc ));
		//snprintf (logStr, 1023, "ldap_search_ext_s: %s\n", ldap_err2string( rc ) );
        //saveLog(logStr, true);
        saveLog(true, "ldap_search_ext_s: %s\n", ldap_err2string( rc ) );
  
		ldap_msgfree( searchResult );
        
		//ldap_unbind_s( lovalLD );
        //ldapssl_client_deinit();

        return ( -1 );
    }   
     
	//bool findIL = false, findUL = false;
	char seps [] = " ;	\0\n";
	char infoStr[256];
	//char grouplevel;
		int limit = 0;
		int unlimit = 0;
		//grouplevel = 0;
	attrName aStr;

	if ( (entry = ldap_first_entry( lovalLD, searchResult )) != NULL)
    {
		for (   attribute = ldap_first_attribute( lovalLD, searchResult, &ber );
			    attribute != NULL; 
	            attribute = ldap_next_attribute( lovalLD, searchResult, ber ) )
		{
            values = ldap_get_values( lovalLD, entry, attribute);
            if (values != NULL)                
            {
                for ( i = 0; values[i] != NULL; i++ )
				{
					if (strstr (attribute, "groupMembership") != NULL)
					{
						//saveLog(false, "finf group %s\n", values[i]);
						strncpy (aStr.name, values[i], 255);
						userGroups.push_back(aStr);
						/*if ((strstr(values[i], "InetGrp")) != NULL)
						{
							strncpy (aStr.name, values[i], 255);
							listAttr.push_back(aStr);
						}*/
					}
					/*
					if (strstr (attribute, "ADSgroupLevel") != NULL)
					{
						strncpy (infoStr, values[i], 255);
						grouplevel = atoi(infoStr);
					}*/

					/*if (strstr (attribute, ""networkAddress"") != NULL)
					{
						sInAddr uinaddr;
						int j;
						for (j = 0; j < 4; ++j)
							uinaddr.b[j]=values[i][j+2];

					}*/

					if (strstr (attribute, "ADSinternetLimit") != NULL)
					{

						limit = 0;

						strncpy (infoStr, values[i], 255);
						char *LimitStr, *LimitScaleStr;

						LimitStr = strtok(infoStr, seps);
						if (LimitStr == NULL) 
							LimitStr = "0";
						limit = atol(LimitStr);
						LimitScaleStr = strtok(NULL, seps);
						if (LimitScaleStr != NULL) 
						{
							if (strcmp (LimitScaleStr, "Gb") == 0)
								limit *= 1073741824;
							if (strcmp (LimitScaleStr, "Mb") == 0)
								limit *= 1048576;
							if (strcmp (LimitScaleStr, "Kb") == 0)
								limit *= 1024;
						}
						sLimit = limit;
						//findIL = true;
					}
					if (strstr (attribute, "ADSunderLimit") != NULL)
					{
						unlimit = 0;

						strncpy (infoStr, values[i], 255);
						char *UnLimitStr, *UnLimitScaleStr;

						UnLimitStr = strtok(infoStr, seps);
						if (UnLimitStr == NULL) 
							UnLimitStr = "0";
						unlimit = atol(UnLimitStr);
						UnLimitScaleStr = strtok(NULL, seps);
						if (UnLimitScaleStr != NULL) 
						{
							if (strcmp (UnLimitScaleStr, "Gb") == 0)
								unlimit *= 1073741824;
							if (strcmp (UnLimitScaleStr, "Mb") == 0)
								unlimit *= 1048576;
							if (strcmp (UnLimitScaleStr, "Kb") == 0)
								unlimit *= 1024;
						}
						sUnderLimit = unlimit;
						//findUL = true;
					}
				}
			 ldap_value_free( values );
             ldap_memfree( attribute );
           }
        }
	/*//if (userData)
	//{
		if (findIL)
		{
			sLimit = limit;
		}
		if (findUL)
		{
			sUnderLimit = unlimit;
		}
	//}*/
		
	  ber_free(ber, 0);
	  ldap_msgfree( searchResult );
	}
	else 
		//saveLog ("no entry description", true);
		saveLog (true, "no entry description");

	return 1;
}
//--------------------------------------------------------------------------
//int myLDAP::myLdapSSLConnect( char *loginName, char *ldapServer, int &ldapLimit, int &ldapUnderLimit)
int myLDAP::myLdapInfo(char *loginName, int &ldapLimit, int &ldapUnderLimit)
{
	int i;

	
	struct timespec myTS;
	myTS.tv_sec = 0;
	myTS.tv_nsec = 50000000;
	
	while (	study == true)
	{
		//sleep (1);
		if (nanosleep (&myTS, 0) == -1)	saveLog(true, "Error nanosleep in myLdapInfo module\n");
	}
	study = true;
	for (i = 0; i < 4; ++i)
	{
		if (ld == NULL) 
		{
			if (myLdapInit() < 0)
			{
				ld = NULL;
				saveLog(true, "error myLdapInit connection\n");
			}
		}
		else
		{
			if (LSC (loginName, ldapLimit, ldapUnderLimit) < 0)
			{
				saveLog(true, "LSC error (%s) - reinit ldap connection\n", loginName);
				myLdapDeInit();
				ld = NULL;
					if (nanosleep (&myTS, 0) == -1)	saveLog(true, "Error 2 nanosleep in myLdapInfo module\n");
	 
			}
			else
			{
				study = false;
				return 1;
			}
		}
	}

	study = false;
	return (-1);
}
//int myLDAP::LSC ( char *loginName, char *ldapServer, int &ldapLimit, int &ldapUnderLimit)
int myLDAP::LSC (char *loginName,int &ldapLimit, int &ldapUnderLimit)
{   
  int sLimit, sUnderLimit, retCode, groupLimit, groupUnderLimit;

    //char        *attrs[] = {"groupMembership", "ADSinternetLimit", "ADSunderLimit", NULL};// 
    char        *attrs[] = {"groupMembership", "ADSinternetLimit", "ADSunderLimit", "networkAddress", NULL};// 
    char        *attrsGroup[] = {"ADSinternetLimit", "ADSunderLimit", NULL};// 

	sLimit = 0;
	sUnderLimit = 0;
	groupLimit = 0;
	groupUnderLimit = 0;
   //searchBase        = loginName;char *searchBase    
		vector <attrName> userGroups;
		userGroups.clear();
	retCode = 1;
	//if (myLdapSearch(ld, loginName, attrs, sLimit, sUnderLimit) <= 0)
	if (myLdapSearch(ld, loginName, attrs, sLimit, sUnderLimit, userGroups) <= 0)
		{
			saveLog(true, "search in user date error\n");
			retCode = -1;
		}
	else
	{
		vector <attrName> podGroups;
		podGroups.clear();
		uint i;
		if (!userGroups.empty())
		{
		for (i = 0; i < userGroups.size(); ++i)
		{
			//saveLog(true, "group - %s \n", userGroups[i].name);
			if (myLdapSearch(ld, userGroups[i].name, attrsGroup, groupLimit, groupUnderLimit, podGroups) <= 0)
				{
					saveLog(true, "search in group %s date error\n", userGroups[i].name);
					retCode = -1;
					break;
				}
			else
			{
				if (sUnderLimit != -1)
				{
					if (groupUnderLimit == -1)
					{
						sUnderLimit = -1;
						//saveLog(true, "user - %s in group - %s have safe Limit !!!!\n", loginName, userGroups[i].name);
					}
						else
						{
							if (groupUnderLimit > sUnderLimit)
								groupUnderLimit = groupUnderLimit;
						}
				}
			}
		}

		
		}
		else
			saveLog (true, "not find groups\n");
	}

	ldapLimit = sLimit;
	ldapUnderLimit = sUnderLimit;

  return( retCode );
}
int myLDAP::myLdapInit()
{
	int         ldapPort, rc;//, i;
    char        *loginDN, *password;   
    //LDAP        *ld;
	
	//struct timeval timeOut = {10,0};   // 10 second connection/search timeout
            
    ldapPort          = 636;
    //loginDN           = NULL;
    //password          = NULL;
    loginDN           = "cn=proxyuser,ou=inet,o=nirctu";
    password          = "in4Teko7up";

    ld = ldapssl_init(ldapHost, ldapPort, 1);            
    if (ld == NULL )
    {
			//ldapssl_client_deinit();
        saveLog(true, "ldapssl_init error\n");
		ld = NULL;
		return( -1 );
    }	
	
    rc = ldap_simple_bind_s( ld, loginDN, password );
    if (rc != LDAP_SUCCESS )
    {
			//ldap_unbind_s ( ld );
			//ldapssl_client_deinit();
	    saveLog(true, "ldap_simple_bind_s: %s\n", ldap_err2string( rc ));
		ld = NULL;
        return( -1 );
    }
	return 1;
}
void myLDAP::myLdapDeInit()
{
	if (ld != NULL)
	{
		int rc;
		if ((rc = ldap_unbind_s( ld )) != 0)
		{
		    saveLog(true, "ldap_unbind_s: %s\n", ldap_err2string( rc ));
		}
		ld = NULL;
	}
}
myLDAP::myLDAP()
{
	study = false;
	snprintf(ldapHost, 255, "192.168.1.4");
	ld = NULL;
	timeOut.tv_sec=10;
	timeOut.tv_usec=0;

	    // Set LDAP version to 3 and set connection timeout. 
	int version;
	version = LDAP_VERSION3;
  ldap_set_option( NULL, LDAP_OPT_PROTOCOL_VERSION, &version);
  ldap_set_option( NULL, LDAP_OPT_NETWORK_TIMEOUT, &timeOut);

  int rc = ldapssl_client_init(   NULL,	NULL );     
    
	if (rc != LDAP_SUCCESS)
  {
     saveLog (true, "ldapssl_client_init error: %s \n", ldap_err2string( rc ));
			exit( -1 );
  }

	rc = ldapssl_set_verify_mode(LDAPSSL_VERIFY_NONE);
    if (rc != LDAP_SUCCESS)
    {
        saveLog ( true, "ldapssl_set_verify_mode error: %s\n", ldap_err2string( rc ));
		exit( -1 );
    }
}
/*void myLDAP::reset()
{
	study = false;
}*/
void myLDAP::setHost(char *ldapServer)
{
	study = true;
	if (ldapServer) snprintf(ldapHost, 255, ldapServer);
	else snprintf(ldapHost, 255, "192.168.1.4");
	study = false;
	//myLdapDeInit();	//ld = NULL;
	/*if (myLdapInit() < 0)
	{
		saveLog(true, "error create myLDAP connections\n");
	}*/
}
myLDAP::~myLDAP()
{
	study = true;
	myLdapDeInit();
	int rc;
	if ((rc = ldapssl_client_deinit()) != 0)
			saveLog(true, "ldapssl_client_deinit: %s\n", ldap_err2string( rc ));
	/*int rc = 0;if ((rc = ldapssl_client_deinit()) != 0)
		saveLog(true, "ldapssl_client_deinit: %s\n", ldap_err2string( rc ));	*/
}

// Local Variables:
// mode:C++
// End:
