#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <syslog.h>
#include <signal.h>

#include <string.h>
#include <stdlib.h>
#include <iomanip>

#include <sys/un.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>


#include <linux/netfilter.h>

#include <linux/netlink.h>
#include <net/if.h>
#include <unistd.h>

#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#include <net/if_arp.h>
#include <netinet/in_systm.h>
#include <netinet/tcp.h>
#include <sys/resource.h>

#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <grp.h>

#include <jni.h>

#include "squid_daemon.h"
//#include "mysql.h"
//#include "myldap.h"

#define BUFFER_SIZE             (8*1024)
const int clLen = 1024;

//pthread_mutex_t request_mutex = PTHREAD_MUTEX_INITIALIZER;



//myLDAP lsConn;
SquidDaemon *pointToParentDaemon;
SquidChild *pointToChildDaemon;

//SquidDaemon::SquidDaemon(vectorAttrs myVectorAttrs, vectorAttrs myBaseInfo) 
SquidDaemon::SquidDaemon(ServerInfo si) 
{
	workDaemon = true;

	allowTime = 31;
	close_time = 30;
	ldapTimeUpdate = 30; 
	//locVectorAttrs = myVectorAttrs;
	loc_si = si;
	/*uint i;
	for (i = 0; i < myVectorAttrs.size(); ++i)
		locVectorAttrs.push_back(myVectorAttrs[i]);
	for (i = 0; i < myBaseInfo.size(); ++i)
		locBaseInfo.push_back(myBaseInfo[i]);*/
};

SquidDaemon::~SquidDaemon() 
{
	//delete lsConn;
}

int SquidDaemon::alreadyRun() 
{
	int pid = 0;
	char rBuf[256];
	FILE *dF;

	dF = fopen(pidFileName, "r");
	if (dF != NULL)
	{
		if (fgets(rBuf, 255, dF) != NULL)
		{
			pid = atoi(rBuf);
			//saveLog (true, " read pid=%d\n", pid);
		}else 
			//saveLog (true, "cannot read pid file\n");
			printf ("cannot read pid file\n");
		fclose (dF);
	}//else saveLog (true, "cannot open pid file\n");
	
	if (pid > 0)
	{
	    if (kill(pid, 0) >= 0)
		{

			saveLog (true, "SquidDaemon already run!!!\n");
			return pid;
		}
	}
	return 0;
}

void SquidDaemon::execute() 
{
	pointToParentDaemon = this;

	struct sigaction act;
	
	int pid;
	if ((pid = alreadyRun()) > 0)
	{
		printf ("serv daemon allreade run! pid = %d\n", pid);
		exit(0);
	}
	
	/*if (!pripareNet())
	{
		printf ("error Net pripare \n");
		saveLog(true, "error Net pripare \n");
		return;
	}*/

	//saveLog (true, "Daemonizing begining.. \n");
	saveLog (true, "_____________________begining...________________________ \n");
    parentPid = fork();

    switch(parentPid) 
    {
	case 0:
	    setsid();
	    chdir("/");

	    close(0);
	    close(1);
	    close(2);

	    memset(&act, 0, sizeof(act));
	    act.sa_handler = stopParentDaemon;
	    sigaction(SIGTERM, &act, NULL);

	    daemonize();
	    saveLog (true, "exit parent daemon\n");
	    exit(0);

	case -1:
	    saveLog (true, "parent fork() error\n");
	    break;

	default:

		FILE *dF;
		dF = fopen(pidFileName, "w");
		if (dF != NULL)
		{
			fprintf (dF, "%d\n", parentPid);
			fclose (dF);
		}
		 else 
			saveLog (true, "Cannot save pid file !!!\n");

	    saveLog (true, "parent pid = %d\n", parentPid);
	    break;
    }
}
bool SquidDaemon::pripareNet()
{
	hostent* remoteHost;
	int my_error = gethostname(myHostName, 16);

	if (my_error == 0)
	{
		remoteHost = gethostbyname(myHostName);
		sprintf (myIPstr, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));
		saveLog (false, "Host - %s IP - %s\n", myHostName, myIPstr);
	}
	else 
		saveLog (false, "cannot get host name\n");

	if (!createSocket(sockfd, htonl(INADDR_ANY), listenPort))
	{
		saveLog (false, "error create listen socket\n");
		return false;
	}

	if (!createSocket(sockRL, htonl(INADDR_ANY), servicePort))
	{
		saveLog (false, "error create service socket\n");
		return false;
	}

	if (!createSocket(sockAP, htonl(INADDR_ANY), authPort))
	{
		saveLog (false, "error create service socket\n");
		return false;
	}
	return true;
}

bool SquidDaemon::createSocket(int &sock, u_int32_t s_addr, int s_port)
{
	sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);//SO_REUSEADDR
	
	if(sock != -1) 
	{

		  int on = 1;
			if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on)) < 0)
			saveLog (true, "SetReuseAddr error\n");
			struct linger L;
			L.l_onoff = 0;		/* off */
			L.l_linger = 0;
			if (setsockopt(sock, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
			saveLog (true, "SetNoLinger error\n");

	    struct sockaddr_in sa;
		sa.sin_addr.s_addr = s_addr;
		sa.sin_family = AF_INET;
		sa.sin_port = htons(s_port);

		if(bind(sock, (struct sockaddr *) &sa, sizeof(sa)) != -1) 
		{
			if(listen(sock, 5) == 0) 
			{
				return true;
			}else 
				{
					saveLog(true, "listen error in create socket\n");
					close (sock); 
					workDaemon = false;
				}
		}else 
			{
				saveLog(true, "bind error in create socket\n");
				close (sock);
				workDaemon = false;
			}
	}else 
		{
			saveLog(true, "create socket error\n");
			workDaemon = false;
		}
	return false;
}

void SquidDaemon::daemonize()
{
	pointToParentDaemon = this;
	do{
				if (!pripareNet())
				{
					printf ("error Net pripare \n");
					saveLog(true, "error Net pripare \n");
					return;
				}
				else 
					saveLog(true, "Net pripare !!!\n");
		startChild();
		if (childPid > 0)
			waitpid(0, 0, 0);

				saveLog (true, "closing socket in daemonize parent\n");
				shutdown(sockfd,SHUT_RDWR);
				shutdown(sockRL,SHUT_RDWR);
				shutdown(sockAP,SHUT_RDWR);
				close(sockfd);
				close(sockRL);
				close(sockAP);
				saveLog (true, "socket closed add down in daemonize parent\n");

	//waitpid(childPid, 0, WNOHANG);
	}while (workDaemon);
		/*saveLog (true, "closing socket in daemonize parent\n");
		shutdown(sockfd,SHUT_RDWR);
		shutdown(sockRL,SHUT_RDWR);
		shutdown(sockAP,SHUT_RDWR);
		close(sockfd);
		close(sockRL);
		close(sockAP);
		saveLog (true, "socket closed add down in daemonize parent\n");*/
	//sleep (1);
	saveLog(true, "finish daemonize \n");
}

void SquidDaemon::startChild()
{
	saveLog (true, "start child... \n");
			SquidChild schld(sockfd, sockRL, sockAP, myHostName, myIPstr, loc_si);
	childPid = fork();
    switch(childPid) 
    {
		case 0:
			//sigset_t mask;
			//sigfillset(&mask);
			//sigdelset(&mask, SIGUSR1);

			//memset(&usa, 0, sizeof(usa));
			//usa.sa_handler = &stopChildDaemon;
			//sigaction(SIGUSR1, &usa, 0);

//find how catch some interrupt		!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			//memset(&usa, 0, sizeof(usa));
			//usa.sa_handler = &stopChildDaemon;
			//sigaction(SIGABRT, &usa, 0);

			schld.childDaemonJob();
			saveLog(true, "exit child daemon\n");
			exit(0);

		case -1:
			saveLog (true, "child fork() error\n");
			//return false;
			break;

		default:
			saveLog (true, "child pid = %d\n", childPid);
			//return true;
			break;
    }
}

//SquidChild::SquidChild(int _sockfd, int _sockRL, int _sockAP, char *_myHostName, char *_myIPstr, vectorAttrs myVectorAttrs, vectorAttrs myBaseInfo)
SquidChild::SquidChild(int _sockfd, int _sockRL, int _sockAP, char *_myHostName, char *_myIPstr, ServerInfo si)
{
	//locVectorAttrs = myVectorAttrs;
	//uint i;
	//for (i = 0; i < myVectorAttrs.size(); ++i)
	//	locVectorAttrs.push_back(myVectorAttrs[i]);
	child_si = si;

	if (!sqlbase.myConnect(si))
		stopChildDaemon(0);

	sockfd = _sockfd;
	sockRL = _sockRL;
	sockAP = _sockAP;
	strcpy(myHostName, _myHostName);
	strcpy(myIPstr, _myIPstr);
	saveLog (true, "initialization <Child> class \n");

	saveLog(true, "Set LDAP host\n");
	//lsConn.setHost(ldapServer, false, myVectorAttrs);
	lsConn.setHost(child_si);
	saveLog(true, "finish Set LDAP host\n");
	if (pthread_mutex_init(&request_mutex, NULL))
	{
		saveLog(true, "Error LDAP mutex init!!!\n");
	}
	if (pthread_mutex_init(&sql_mutex, NULL))
	{
		saveLog(true, "Error SQL mutex init!!!\n");
	}
	pointToChildDaemon = this;
}

SquidChild::~SquidChild()
{
	if (pthread_mutex_destroy(&request_mutex))
	{
		saveLog(true, "Error LDAP mutex destroy!!!\n");
	}
	if (pthread_mutex_destroy(&sql_mutex))
	{
		saveLog(true, "Error SQL mutex destroy!!!\n");
	}
}

void SquidChild::stopChildDaemon(int signum) 
{
	if (pointToChildDaemon->workChildDaemon)
	{
		pointToChildDaemon->workChildDaemon = false;
		saveLog (true, "recive TERM signal in child process\n");
		saveLog (true, "save traffic in stopChildDaemon finction\n");
		pointToChildDaemon->saveTraffic();
		saveLog (true, "traffic was save in stopChildDaemon finction\n");

			saveLog (true, "down socket in stopChildDaemon function\n");
			shutdown(pointToChildDaemon->sockfd,SHUT_RDWR);
			shutdown(pointToChildDaemon->sockRL,SHUT_RDWR);
			shutdown(pointToChildDaemon->sockAP,SHUT_RDWR);
			saveLog (true, "socket down in stopChildDaemon function\n");
			/*close(pointToChildDaemon->sockfd);
			close(pointToChildDaemon->sockRL);
			close(pointToChildDaemon->sockAP);*/
		sleep (1);
		
		saveLog (true, "call exit() in child process\n");
		exit(0);
	}
	else 
	{
		sleep (10);
		exit(0);
	}
}

void SquidDaemon::stopParentDaemon(int signum) 
{
	if (pointToParentDaemon->workDaemon)
	{
		pointToParentDaemon->workDaemon = false;
		saveLog (true, "recive TERM signal in parent process\n");
		if (kill(pointToParentDaemon->childPid, SIGTERM))
		//if (kill(pointToDaemon->childPid, SIGUSR1))
		{
				saveLog (true, "ERROR: Could not send signal to child process %d\n", (int) pointToParentDaemon->childPid);
		}
			
	}
	else 
	{
		sleep (10);
		exit(0);
	}
}

ServerInfo& ServerInfo::operator = (ServerInfo &si)
{
	uint i;
	for (i = 0; i < si.myVectorAttrs.size(); ++i)
		myVectorAttrs.push_back(si.myVectorAttrs[i]);
	needSSL = si.needSSL;
	port = si.port;

	strncpy (ldapServer, si.ldapServer, 255);
	strncpy (host, si.host, 255);
	strncpy (username, si.username, 255);
	strncpy (password, si.password, 255);
	strncpy (database, si.database, 255);
	strncpy (LDAPlogin, si.LDAPlogin, 255);
	strncpy (LDAPpassword, si.LDAPpassword, 255);

	return *this;
};

SIdentUser::SIdentUser()
{
	strcpy (userName, "Public");
	strcpy (strUserIP, "0.0.0.0");
	userIP.s_addr = inet_addr("0.0.0.0");
	rTime = 0;

	userID = 0;
	detachConnection = false;
	dropTime = 0;
}
SUserData::SUserData()
{
	strcpy (userName, "Public");
	userLimit = 0;
	underLimit = 0;
	userTraffic = 0;

	userCacheTraffic = 0;
	underLimit = 0;
	commercialLimit = 0;
	commercialTraffic = 0;
	commercialCacheTraffic = 0;
	
	oldUserTraffic = userTraffic;
	userID = 0;
	lastTime = 0;
	LdapUpdate = 0;
}

void SquidChild::childDaemonJob()
{
	pointToChildDaemon = this;
	//lsConn.setHost(ldapServer, false);
			struct sigaction usa;
			memset(&usa, 0, sizeof(usa));
			usa.sa_handler = &stopChildDaemon;
			sigaction(SIGTERM, &usa, NULL);

	collected.clear();
	SUserData myUserData;

	collected.push_back(myUserData);

	share.clear();
	SIdentUser myIdentUser;

	share.push_back(myIdentUser);

	size_t stacksize;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	stacksize = 50000;
	pthread_attr_setstacksize (&attr, stacksize);
	//pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
	//pthread_attr_getstacksize (&attr, &stacksize);

	int threadError;
	int i;

	workChildDaemon = true;
	
	for (i = 0; i < numListenThread; ++i)
	{
		threadError = pthread_create(&listen_thread[i], &attr, listenerThread, (void*)this);
		if (threadError != 0)
		{
			saveLog(true, "Error create listenerThread - % d\n", i+1);
			workChildDaemon = false;
			return;
		}else
			{
				saveLog(false, "Create listenerThread thread - % d\n", i+1);
			}
	}

	for (i = 0; i < numLocalService; ++i)
	{
		threadError = pthread_create(&service_thread[i], &attr, serviceThread, (void*)this);
		if (threadError != 0)
		{
			saveLog(true, "Error create servise thread - %d\n", i+1);
			workChildDaemon = false;
			return;
		}else
			{
				saveLog(true, "Create servise thread - %d\n", i+1);
			}
	}

	for (i = 0; i < numAuthService; ++i)
	{
		threadError = pthread_create(&auth_thread[i], &attr, authThread, (void*)this);
		if (threadError != 0)
		{
			saveLog(true, "Error create auth thread - %d\n", i+1);
			workChildDaemon = false;
			return;
		}else
			{
				saveLog(true, "Create auth thread - %d\n", i+1);
			}
	}

	pthread_attr_destroy(&attr); 

	saveLog (true, "Set effective user and group\n");
	int result;
	struct passwd *eUserPasswd;
	eUserPasswd = getpwnam (effective_user);
	struct group *eGroup;
	eGroup = getgrnam (effective_group);

	if ((eGroup != NULL) && (eUserPasswd != NULL))
	{
		FILE *fp;
		fp = fopen(logFileName,"a+");
		if (fp != NULL)
		{
			fclose(fp);
			if (chown(logFileName, eUserPasswd->pw_uid, eGroup->gr_gid) != 0)
				saveLog(true, "change logFileName owner error\n");
		}
		fp = fopen(pidFileName, "a+");
		if (fp != NULL)
		{
			fclose (fp);
			if (chown(pidFileName, eUserPasswd->pw_uid, eGroup->gr_gid) != 0)
				saveLog(true, "change logFileName owner error\n");
		}
		else saveLog (true, "cannot open pid file\n");
	}
	else 
		saveLog (true, "error get effective user and group ID\n");

	if (eGroup != NULL)
	{
		result = setgid (eGroup->gr_gid);
		if (result < 0)
		{
			saveLog (true, "error set effectiv group - %s with gid - %d\n", effective_group, eGroup->gr_gid);
		}
	}
	if (eUserPasswd != NULL)
	{
		result = setuid (eUserPasswd->pw_uid);
		if (result < 0)
		{
			saveLog (true, "error set effectiv user - %s with uid - %d\n", effective_user, eUserPasswd->pw_uid);
		}
	}

	readyChildToWork = true;
	workChildDaemon = true;

	saveLog (true, "ready!!!\n");

	for (i = 0; i < numListenThread; ++i)
	{
		pthread_join(listen_thread[i], NULL);
		saveLog (true, "wait listen_thread %d done\n", i+1);
	}
	for (i = 0; i < numLocalService; ++i)
	{
		pthread_join(service_thread[i], NULL);
		saveLog (true, "wait service_thread %d done\n", i+1);
	}
 	for (i = 0; i < numAuthService; ++i)
	{
		//pthread_detach(listen_thread[i]);
		pthread_join(auth_thread[i], NULL);
		saveLog (true, "wait listen_thread %d done\n", i+1);
	} 
	/*saveLog (true, "closing socket in exit child\n");
	close(sockRL);
	close(sockfd);
	close(sockAP);
	saveLog (true, "socket closed in exit child\n");*/

	saveLog (true, "end child process!!!\n");
	readyChildToWork = false;
	workChildDaemon = false;


}

void *SquidChild::listenerThread(void *data)
{
	SquidChild *sqdp = (SquidChild *)(data);

	while (!sqdp->readyChildToWork); 
	
	struct sockaddr_in conn_sa;
    	socklen_t n;
	n = sizeof(conn_sa);
	int fd;

	while (sqdp->workChildDaemon)
	{

		if((fd = accept(sqdp->sockfd, (struct sockaddr *) &conn_sa, &n)) != -1) 
		{

			
			struct in_addr userIPaddr;
			char userIPstr[18];
			userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
			strncpy (userIPstr, inet_ntoa(userIPaddr), 18);
			sqdp->clientAccess(fd, userIPaddr, userIPstr);
			close (fd);
				
			/*	SAnswerData sendData;
				size_t stacksize;
				pthread_attr_t attr;
				pthread_attr_init(&attr);
				stacksize = 50000;
				pthread_attr_setstacksize (&attr, stacksize);
				//pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

			sendData.pToChD = sqdp;
			sendData.userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
			strncpy (sendData.userIPstr, inet_ntoa(sendData.userIPaddr), 18);

				pthread_t answer_thread;

				int threadError;

				threadError = pthread_create(&answer_thread, &attr, sqdp->answerListenerThread, (void*)(&sendData));
				if (threadError != 0)
				{
					saveLog(true, "Error create answer thread for listener\n");
				}
					else
					{
						saveLog(true, "create thread for listen soacket\n");
						pthread_detach(answer_thread);
						while (sendData.pToChD != NULL);
					}
				pthread_attr_destroy(&attr); 
				saveLog(true, "ready for next listen soacket\n");*/
		}
		  else 
			{	
				if (sqdp->workChildDaemon)
					saveLog (true, "error accept connection from clientTrust\n");
			}
	}
	saveLog (false, "exit listen thread\n");
	pthread_exit(NULL);
}

/*void *SquidChild::answerListenerThread(void *data)
{
	SAnswerData *recData = (SAnswerData *)data;
	SAnswerData sendData;
		saveLog (true, "listen thread for - %s\n", recData->userIPstr);
			sendData.pToChD = recData->pToChD;
		saveLog (true, "listen thread step 1\n");
			sendData.userIPaddr.s_addr = recData->userIPaddr.s_addr;
		saveLog (true, "listen thread step 2\n");
			strncpy (sendData.userIPstr, recData->userIPstr, 18);
		saveLog (true, "listen thread - %s\n", sendData.userIPstr);
	recData->pToChD = NULL;
		saveLog (true, "listen thread step 3\n");
	sendData.pToChD->clientAccess(sendData.fd, sendData.userIPaddr, sendData.userIPstr);
	close (sendData.fd);
	pthread_exit(NULL);
}*/

bool SquidChild::clientAccess(int fd, struct in_addr userIPaddr, char *userIPstr)
{
    const int szCMD = 1024;
    char cmd[szCMD] = "";
	char answer[szCMD] = "";
    char cmd2[szCMD] = "";
    bool deRegistration = false;
	
	char seps [] = " ;\n";
	if (recv(fd, cmd, szCMD, 0) > 0)
	{
		char *beginStr = "registrate->";
		char *myStr, *myUser, *myUserIPstr, *myUserHostNameStr;
		//char logStr[1024];
		//sprintf (answer, "don`t have typed string");
		
		myCrypt(cmd);

		bool registerSucces = false;
			if (strchr (cmd, '\n') == NULL) 
			{
				saveLog (true, "don`t recive first string in registration procedure!!!\n");
				return false;
			}
		if (strstr(cmd, "[Public]") == NULL)
		{
			myStr = strstr(cmd, beginStr);
			if (myStr != NULL)
			{
				myStr += strlen(beginStr);
				if ((myUser = strtok(myStr, seps)) != NULL)
				{
					if ((myUserIPstr = strtok(NULL, seps)) != NULL)
					{
						if ((myUserHostNameStr = strtok(NULL, seps)) != NULL)
						{
							registerSucces = true;
							if (userIPaddr.s_addr != inet_addr(myUserIPstr))
							{
								//snprintf (logStr, 1023, "user - %s - IP  don`t conform to real IP %s !!!!!!!!!!!", myUser, myUserIPstr, userIPstr, true);
								saveLog (true, "from user %s - IP %s don`t conform to get IP %s !!!!!!!!!!!\n",
												myUser, myUserIPstr, userIPstr);
							}
						}
					}
				}
			}
			else
				{
					saveLog (true, "don`t have typed string IP-%s\n", userIPstr);
				}
			
			if	(registerSucces)
			{
				time_t ltime;
				time (&ltime);
				sprintf (answer, "Success registration from->%s %s %d \n", myHostName, myIPstr, int(ltime));

				myCrypt(answer);
				if (send(fd, answer, strlen(answer), 0) > 0) 
				{
					bool attestation = false;
					if (recv(fd, cmd2, szCMD, 0) > 0)
					{
						myCrypt(cmd2);
							if (strchr (cmd2, '\n') == NULL) 
							{
								saveLog (true, "don`t recive second string  in registration procedure!!!\n");
								return false;
							}

						char *attestationStr, *servTimeStr;
						if ((attestationStr = strtok(cmd2, seps)) != NULL)
						{
							if ( (servTimeStr = strtok(NULL, seps)) != NULL)
							{
								time_t servTime = atol(servTimeStr);
								if (servTime > ltime) attestation = true;
								else 
									saveLog(false, "Error Server answer Time");
							}else 
								saveLog(false, "Error Time string");
						}else 
							saveLog(false, "Error attestation string");
					}
					if (attestation)
					{
						int rest = 0, rc = -1;
						char *p;
						for( p = myUser; p < myUser + strlen( myUser ); p++ )
						{
							if ( isascii(* p) )
							{
								if( isupper( *p ) )
									*p = char( tolower( *p ) );
							}
						}
						uint uId;
						rc = registerUserIP(userIPaddr, userIPstr, myUser, rest, uId);
						//rc = registerUserIP(userIPaddr, userIPstr, myUser, rest, i_thread, uId);
						sprintf (answer, "Attestation rest->%d %d \n", rest, rc);
						myCrypt(answer);
						send(fd, answer, strlen(answer)+1, 0);
					}else 
						saveLog (false, "attestation error\n");
				}
			}
			else
				{
					saveLog (false, "error registration\n");
					sprintf (answer, "Error registration from->%s %s \n", myHostName, myIPstr);
					myCrypt(answer);
					send(fd, answer, strlen(answer)+1, 0);
				}

		}
		else 
			{
				deregisterUserIP(userIPaddr, userIPstr);
				deRegistration = true;
			}
	}
	return deRegistration;
}

int SquidChild::registerUserIP(struct in_addr userIPaddr, char *userIPstr, char *userName, int &getLimit, uint &uId)
{


	int myLDAPLimit = 0, myLDAPUnderLimit = 0, rc = -1, myLDAPComLimit = 0;
	getLimit = 0;

	uint i;
	time_t realTime, registerTime;
	time (&realTime);
	

	bool notYetLdap = true;
	uint localUserID = 0;

	for (i = 1; i < collected.size(); ++i)
	{
		if (strcmp(collected[i].userName, userName) == 0)
		{
			localUserID = i;
			if ((realTime - collected[i].LdapUpdate) < ldapTimeUpdate)
			{
				//uId = i;
				myLDAPLimit = collected[i].userLimit;
				myLDAPUnderLimit = collected[i].underLimit;
				rc = 1;
				notYetLdap = false;
			}
				break;
		}
	}

	if (notYetLdap)
	{
		pthread_mutex_lock(&request_mutex);
			rc = lsConn.myLdapInfo(userName, myLDAPLimit, myLDAPUnderLimit, myLDAPComLimit);
		pthread_mutex_unlock(&request_mutex);

		if (rc == -1)
			{
				saveLog(true, "LDAP error\n");
				myLDAPLimit = 0;
				myLDAPUnderLimit = 0;
				myLDAPComLimit = 0;
							stopChildDaemon(0);
			}
	}
	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		
	unsigned int real_month, last_month, real_year, last_year;

	struct tm *today, *last;
	today =  localtime( &realTime );
		real_month = today->tm_mon;
		real_year = today->tm_year;

	bool present;
	present = false;

	//localUserID = collected.size();
	//localUserID = 0;
	bool needUpdateMySQL = false;
	if (localUserID > 0)
	{
			if (notYetLdap)
			{
				time_t updateTime=0;
				pthread_mutex_lock(&sql_mutex);
					bool readFromMySQL = sqlbase.readLustTimeFromMySQL(updateTime, userName, real_month, real_year);
				pthread_mutex_unlock(&sql_mutex);		
				if (readFromMySQL)
				{
					if (updateTime > collected[localUserID].lastTime)
					{
						pthread_mutex_lock(&sql_mutex);
								readFromMySQL = sqlbase.readFromMySQL(collected[localUserID], userName, real_month, real_year);
						pthread_mutex_unlock(&sql_mutex);
						saveLog (true, "update user (%s) traffic from MySQL becose it`s recent\n", collected[localUserID].userName);
					}
				}
			}
			//!!!!!!!!!!!!!!!!!!!!!!!!!!!
			collected[localUserID].userLimit = myLDAPLimit;
			collected[localUserID].underLimit = myLDAPUnderLimit;
			collected[localUserID].commercialLimit = myLDAPComLimit;

			registerTime = collected[localUserID].lastTime;
			last =  localtime( &registerTime );
			last_month = last->tm_mon;
			last_year = last->tm_year;
	 		if ((last_month != real_month) || (last_year != real_year))
			{
				//fileNotExist = true;
				collected[localUserID].userTraffic = 0;
				collected[localUserID].userCacheTraffic = 0;
				collected[localUserID].oldUserTraffic = 0;
				needUpdateMySQL = true;
					saveLog (true, "reset user (%s) traffic from MySQL becose it`s recent\n", collected[localUserID].userName);
			}
			//else	fileNotExist = false;

			collected[localUserID].lastTime = realTime;
			collected[localUserID].userID = localUserID;
			if (notYetLdap) 
				collected[localUserID].LdapUpdate = realTime;

			present = true;
			//fileNotExist = false;
			//break;
	}
	//if (!present)
	else
	{
		saveLog(true, "add new user - %s account ID - %d localID - %d\n", userName, collected.size(), localUserID);

		//localUserID = collected.size();
		SUserData myUserData;
		
pthread_mutex_lock(&sql_mutex);
		bool readFromMySQL = sqlbase.readFromMySQL(myUserData, userName, real_month, real_year);
pthread_mutex_unlock(&sql_mutex);		
		//if ( sqlbase.readFromMySQL(myUserData, userName, real_month+1, real_year+1900) )
		if ( readFromMySQL )
		{
				if (strstr(myUserData.userName, "cn="))
				{
					//fileNotExist = false;		
					//strcpy (myUserData.userName, userName);
							saveLog(true, "get user data (%s) from MySQL\n", userName);
					registerTime = myUserData.lastTime;
					last =  localtime( &registerTime );
					last_month = last->tm_mon;
					last_year = last->tm_year;
	 					if ((last_month != real_month) || (last_year != real_year))
						{
							saveLog(true, "reset user data (%s) in MySQL\n", userName);
							myUserData.userTraffic = 0;
							myUserData.userCacheTraffic = 0;
						}
					needUpdateMySQL = false;
				}
				else 
					needUpdateMySQL = true;
		}

		myUserData.userLimit = myLDAPLimit;
		myUserData.underLimit = myLDAPUnderLimit;
		myUserData.commercialLimit = myLDAPComLimit;
		//myUserData.underLimit = underLimit;

		myUserData.oldUserTraffic = myUserData.userTraffic;
		myUserData.userID = collected.size();
		localUserID = myUserData.userID;
		myUserData.lastTime = realTime;
		strncpy (myUserData.userName, userName, 255);

		collected.push_back(myUserData);
		saveLog(true, "added user - %s account ID - %d localID - %d\n", collected[localUserID].userName, myUserData.userID, localUserID);

//		firstRegistration = true;
		saveLog (true, "registrate user - %s \n", userName);

	}

	if (collected[localUserID].userID != localUserID)
	{
		saveLog(true, "not accociate betwen userID(%d) and localUserID (%d) - user - %s\n", 
			collected[localUserID].userID, localUserID, collected[localUserID].userName);
	}
	
	if (needUpdateMySQL)
	{
		saveLog (true,  "update User Traffik (%s) in MySQL\n",userName);
pthread_mutex_lock(&sql_mutex);
		bool writeToMySQL = sqlbase.saveToMySQL(collected[localUserID], real_month, real_year);
pthread_mutex_unlock(&sql_mutex);		
		if (!writeToMySQL)
		{
			saveLog (true, "Cannot save user limit to MySQL\n");
		}
	}

	present = false;

  if (localUserID > 0)
	{
		for (i = 1; i < share.size(); ++i)
		{
			if (share[i].userIP.s_addr == userIPaddr.s_addr)
			{
				time (&realTime);
				strcpy (share[i].userName, userName);
				if (share[i].userID != localUserID)
				{
					share[i].detachConnection = false;
					share[i].dropTime = 0;
					saveLog (true, "registrate user - %s on present IP - %s \n", userName, userIPstr);
				}
				share[i].userID = localUserID;
				share[i].rTime = realTime;
				present = true;
				uId = i;
		pthread_mutex_lock(&sql_mutex);
									sqlbase.saveIPinMySQL(share[i]);
		pthread_mutex_unlock(&sql_mutex);
					break;
			}
		}
	}
	//uId = localUserID;
	if (!present)
	{
		time (&realTime);

		SIdentUser myIdentUser;
		strcpy (myIdentUser.userName, userName);
		strcpy (myIdentUser.strUserIP, userIPstr);
		myIdentUser.userIP.s_addr = userIPaddr.s_addr;
		myIdentUser.rTime = realTime;

		myIdentUser.userID = localUserID;
		myIdentUser.detachConnection = false;
		myIdentUser.dropTime = 0;

		uId = share.size();
					pthread_mutex_lock(&sql_mutex);
															sqlbase.saveIPinMySQL(myIdentUser);
					pthread_mutex_unlock(&sql_mutex);
		share.push_back(myIdentUser);

		saveLog (true, "registrate user - %s on new IP - %s \n", userName, userIPstr);
	}

	//getLimit = (myLDAPLimit - allTraffic + cacheTraffic + myLDAPUnderLimit);
	getLimit = (collected[localUserID].userLimit - collected[localUserID].userTraffic + 
							collected[localUserID].userCacheTraffic + collected[localUserID].underLimit +  
							collected[localUserID].commercialLimit);
	// study this module  
	//pthread_mutex_unlock(&request_mutex);		
	return rc;
}

void SquidChild::deregisterUserIP(struct in_addr userIPaddr, char *userIPstr)
{
	//char fUserIP[256];
	//FILE *fUI;

	vector<SIdentUser>::iterator iIdent;
	char userNameStr[256];
	//if (firstRegistration)
	//{
		for(iIdent = share.begin(); iIdent != share.end(); ++iIdent)
		{
			if ((*iIdent).userIP.s_addr == userIPaddr.s_addr)
			{
				time_t realTime;
				time (&realTime);

				snprintf(userNameStr, 255, collected[(*iIdent).userID].userName);
				strcpy ((*iIdent).userName, "Public");
				(*iIdent).detachConnection = false;
				(*iIdent).userID = 0;
				(*iIdent).rTime = 0;
				(*iIdent).dropTime = realTime + close_time;
				//if (!(*iIdent).detachConnection) {(*iIdent).detachConnection = true;}
						pthread_mutex_lock(&sql_mutex);
											sqlbase.saveIPinMySQL((*iIdent));
						pthread_mutex_unlock(&sql_mutex);
				break;
			}
		}
	//}
	/*snprintf (fUserIP , 255, "%s/_%s.mda", baseDir, userIPstr);
	fUI = fopen (fUserIP, "w");
	if (fUI != NULL)
	{
		fprintf (fUI, "[Public];0;");
		fclose (fUI);
	}*/
	saveLog (true, "deregustrate user - %s on IP %s\n", userNameStr, userIPstr);
}

void *SquidChild::authThread(void *data)
{
	SquidChild *sqdp = (SquidChild *)data;
	
	while (!sqdp->readyChildToWork); 

	struct sockaddr_in conn_sa;
    socklen_t n;
	n = sizeof(conn_sa);
	int fd;
	

	while (sqdp->workChildDaemon)
	{

		if((fd = accept(sqdp->sockAP, (struct sockaddr *) &conn_sa, &n)) != -1) 
		{
			if (sqdp->readyChildToWork)
			{
					struct in_addr userIPaddr;
					char userIPstr[18];
					userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
					sprintf (userIPstr, "%s", inet_ntoa(userIPaddr));
					sqdp->sendToAuth( fd, conn_sa.sin_addr, userIPstr);
					close (fd);
				/*SAnswerData sendData;
				size_t stacksize;
				pthread_attr_t attr;
				pthread_attr_init(&attr);
				stacksize = 50000;
				pthread_attr_setstacksize (&attr, stacksize);
				//pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

						sendData.pToChD = sqdp;
						sendData.userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
						strncpy (sendData.userIPstr, inet_ntoa(sendData.userIPaddr), 18);

							pthread_t answer_thread;

							int threadError;

							threadError = pthread_create(&answer_thread, &attr, sqdp->answerAuthThread, (void*)(&sendData));
							if (threadError != 0)
							{
								saveLog(true, "Error create answer thread for auth\n");
							}
								else
								{
									saveLog(true, "create thread for auth socket\n");
									pthread_detach(answer_thread);
									while (sendData.pToChD != NULL);
								}
				pthread_attr_destroy(&attr); 
				saveLog(true, "ready for next auth socket\n");*/
			}
			else
				close (fd);
		}else 
			{	
				if (fd < 0)
				{
					if (sqdp->workChildDaemon)
							saveLog (false, "error accept connection from squid\n", false);
				}
			}
		//close (fd);
	}
	saveLog (false, "exit auth thread\n");
	pthread_exit(NULL);
}

/*void *SquidChild::answerAuthThread(void *data)
{
	SAnswerData *recData = (SAnswerData *)data;
	SAnswerData sendData;
	saveLog (true, "auth thread for - %s\n", recData->userIPstr);
			sendData.pToChD = recData->pToChD;
		saveLog (true, "auth step 1\n");
			sendData.userIPaddr.s_addr = recData->userIPaddr.s_addr;
		saveLog (true, "auth step 2\n");
			strncpy (sendData.userIPstr, sendData.userIPstr, 18);
	recData->pToChD = NULL;
	saveLog (true, "auth thread - %s\n", recData->userIPstr);
	sendData.pToChD->sendToAuth( sendData.fd, sendData.userIPaddr, sendData.userIPstr);
		saveLog (true, "auth step 3\n");
	close (sendData.fd);
	pthread_exit(NULL);
}*/

int SquidChild::checkUserLimit(int userID)
{
	int permit = 0;
	int myLimit, myTraffic, myCacheTraffic, myUnderLimit, myCommercialLimit;

	time_t realTime, myTime;
	time (&realTime);

	myLimit = 0;
	myTraffic = 0;
	myCacheTraffic = 0;
	myUnderLimit = 0;
	myCommercialLimit = 0;		
		
		/*myLimit = collected[share[i].userID].userLimit;
		myTraffic = collected[share[i].userID].userTraffic;
		myCacheTraffic = collected[share[i].userID].userCacheTraffic;
		myUnderLimit = collected[share[i].userID].underLimit;
		myTime = collected[share[i].userID].lastTime;//share[i].rTime;*/
		myLimit = collected[userID].userLimit;
		myTraffic = collected[userID].userTraffic;
		myCacheTraffic = collected[userID].userCacheTraffic;
		myUnderLimit = collected[userID].underLimit;
		myTime = collected[userID].lastTime;
		myCommercialLimit = collected[userID].commercialLimit;		
		
			if (myUnderLimit == -1)
			{
				permit = 2;
			}
				else
				{
					if ((myLimit + myUnderLimit + myCommercialLimit - myTraffic + myCacheTraffic) > 1024) 
					{
						if ((realTime - myTime) < allowTime) permit = 1;
							else permit = -1;
					}
						else permit = -2;
				}
				
		return permit;		
}
void SquidChild::sendToAuth(int fd, struct in_addr rlIPaddr, char *rlIPstr)
{
	const int szCMD = 1024;
	char cmd[szCMD] = "";
	char answer[szCMD] = "";
	char seps [] = " ;\0\n";

	uint i;
	struct in_addr userIPaddr;
	/*int myLimit, myTraffic, myCacheTraffic, myUnderLimit;
	//char *writeComplete = "Write complete ";//, *squidStr = "User Cache "

	myLimit = 0;
	myTraffic = 0;
	myCacheTraffic = 0;
	myUnderLimit = 0;	*/
	time_t realTime;
	time (&realTime);	 

	//bool findUserfromIP = false;

	char *externalAclStr = "Who is user ";
	char *myStr, *userIP;
	if (recv(fd, cmd, szCMD, 0) > 0)
	{
		if ((myStr = strstr(cmd, externalAclStr)) != NULL)
		{
				myStr += strlen(externalAclStr);
				//char localUserName[1024];
				if ((userIP = strtok(myStr, seps)) != NULL)
				{
							userIPaddr.s_addr = inet_addr(userIP);
							//if (firstRegistration)
							//{
								bool findUser = false;
										//time_t realTime;
										//time (&realTime);
								snprintf (answer, 1023, "User description EmptY denied");
								for(i = 1; i < share.size(); ++i)
								{
									if ( share[i].userIP.s_addr == userIPaddr.s_addr)
									{
										//if (((realTime - share[i].rTime) < allowTime) && (share[i].userID > 0))
										if ((realTime - share[i].rTime) < allowTime) 
										{
											if (share[i].userID > 0)
										{
												char *allowString;
												allowString = "denied";
												 if (checkUserLimit(share[i].userID) > 0)
												 {
														allowString = "allow";
												 }
												 else 
													saveLog (true, "user %s check limit ERROR on %s\n", collected[share[i].userID].userName, userIP);
												snprintf (answer, 1023, "User description %s %s \n", collected[share[i].userID].userName, allowString);
												/*myLimit = collected[share[i].userID].userLimit;
												myTraffic = collected[share[i].userID].userTraffic;
												myCacheTraffic = collected[share[i].userID].userCacheTraffic;
												myUnderLimit = collected[share[i].userID].underLimit;
												snprintf (answer, 1023, "User description %s %d %d %d %d", 
														collected[share[i].userID].userName, 
														myLimit, 
														(myTraffic - myCacheTraffic),
														myUnderLimit,
														int(share[i].rTime));	*/

												//if (((realTime - share[i].rTime) < allowTime) && (share[i].userID > 0))
													findUser = true;
												break;
										}
											else saveLog (true, "real Time user but userID = 0 (%s - %s)\n", collected[share[i].userID].userName, userIP);
										}
									}
								}//for(i = 0; i < share.size(); ++i)
								if (!findUser)
								{
									uint uId = 0;
									//saveLog (true, "not find user %s\n", userIP);
									//if ((sendRequest(userIPaddr, userIP, uId)) && (share[uId].userID > 0))
									if (sendRequest(userIPaddr, userIP, uId)) 
									{
										if (share[uId].userID > 0)
										{
											char *allowString;
											allowString = "denied";

											int numErr;
											 if ((numErr = checkUserLimit(share[uId].userID)) > 0)
											 {
													allowString = "allow";
											 }
											 else 
												 saveLog (true, "check limit error (%d) on auth from %s on %s\n", 
															numErr, collected[share[uId].userID].userName, userIP);
											snprintf (answer, 1023, "User description %s %s \n", collected[share[uId].userID].userName, allowString);
											/*snprintf (answer, 1023, "User description %s %d %d %d %d", 
													collected[share[uId].userID].userName, 
													collected[share[uId].userID].userLimit, 
													int(collected[share[uId].userID].userTraffic - collected[share[uId].userID].userCacheTraffic),
													collected[share[uId].userID].underLimit,
													int(collected[share[uId].userID].lastTime));*/
										}
											else saveLog (true, "get user Requiest but userID = 0 (%s - %s)\n", collected[share[i].userID].userName, userIP);
									}
									else 
									{
										saveLog (true, "dont answer %s on myAuth question\n", userIP);
									}
								}
							//}//if (firstRegistration)
				}
				else 
					saveLog (true, "ERROR - dont get user IP fron auth programm\n");
				send(fd, answer, strlen(answer)+1, 0);
		}
		else 
			{
				saveLog (true, "error get auth format %s\n", cmd);
			}
	}
}

void *SquidChild::serviceThread(void *data)
{
	SquidChild *sqdp = (SquidChild *)(data);
	
	while (!sqdp->readyChildToWork); 

	struct sockaddr_in conn_sa;
    socklen_t n;
	n = sizeof(conn_sa);
	int fd;

	while (sqdp->workChildDaemon)
	{

		if((fd = accept(sqdp->sockRL, (struct sockaddr *) &conn_sa, &n)) != -1) 
		{

			if (sqdp->readyChildToWork)
			{
					uint cUserID = 0;
					struct in_addr userIPaddr;
					char userIPstr[18];
					userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
					sprintf (userIPstr, "%s", inet_ntoa(userIPaddr));
					sqdp->sendToSquid( fd, conn_sa.sin_addr, userIPstr, cUserID);
					close (fd);
					if (cUserID > 0)
					{
							sqdp->saveUserTrafficToDisk(sqdp->collected[cUserID]);
					}
				/*SAnswerData sendData;
				size_t stacksize;
				pthread_attr_t attr;
				pthread_attr_init(&attr);
				stacksize = 50000;
				pthread_attr_setstacksize (&attr, stacksize);
				//pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
						sendData.pToChD = sqdp;
						sendData.userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
						strncpy (sendData.userIPstr, inet_ntoa(sendData.userIPaddr), 18);

							pthread_t answer_thread;

							int threadError;

							threadError = pthread_create(&answer_thread, &attr, sqdp->answerServiceThread, (void*)(&sendData));
							if (threadError != 0)
							{
								saveLog(true, "Error create answer thread for service\n");
							}
								else
								{
									saveLog(true, "create thread for service soacket\n");
									pthread_detach(answer_thread);
									while (sendData.pToChD != NULL);
								}
				pthread_attr_destroy(&attr); 
				saveLog(true, "ready for next auth socket\n");*/
			}
			else
				close (fd);
		}else 
			{	
				if (fd < 0)
				{
					if (sqdp->workChildDaemon)
						saveLog (false, "error accept connection from squid\n", false);
				}
			}
		//close (fd);
	}
	saveLog (false, "exit service thread\n");
	pthread_exit(NULL);
}
/*void *SquidChild::answerServiceThread(void *data)
{
	SAnswerData *recData = (SAnswerData *)data;
	SAnswerData sendData;
	saveLog (true, "Service thread for - %s\n", recData->userIPstr);
			sendData.pToChD = recData->pToChD;
		saveLog (true, "Service step 1\n");
			sendData.userIPaddr.s_addr = recData->userIPaddr.s_addr;
		saveLog (true, "Service step 2\n");
			strncpy (sendData.userIPstr, recData->userIPstr, 18);
	saveLog (true, "Service thread for - %s\n", sendData.userIPstr);
	recData->pToChD = NULL;
		saveLog (true, "Service step 3\n");
	uint cUserID = 0;
	sendData.pToChD->sendToSquid(sendData.fd, sendData.userIPaddr, sendData.userIPstr, cUserID);
	//sendData->pToChD->sendToAuth( sendData->fd, sendData->userIPaddr, sendData->userIPstr);
	close (sendData.fd);
	if (cUserID > 0)
	{
			sendData.pToChD->saveUserTrafficToDisk(sendData.pToChD->collected[cUserID]);
	}
	pthread_exit(NULL);
}*/
void SquidChild::sendToSquid(int fd, struct in_addr rlIPaddr, char *rlIPstr, uint &cUserID)
{
	const int szCMD = 1024;
	char cmd[szCMD] = "";
	char answer[szCMD] = "";

	//char logStr[255];

	int myLimit, myTraffic, myCacheAdd, myCacheTraffic, myUnderLimit;
	char seps [] = " ;\0\n";
	char *writeComplete = "Write complete ";//, *squidStr = "User Cache "
	char *myStr, *userIP,*cacheSizeStr, *cached, *requestHost;// *user, 
	
	uint i;
	struct in_addr userIPaddr;

	myLimit = 0;
	myTraffic = 0;
	myCacheTraffic = 0;
	myCacheAdd = 0;
	myUnderLimit = 0;

	time_t realTime;
	time (&realTime);
		bool findUserfromIP = false;

	if (recv(fd, cmd, szCMD, 0) > 0)
	{
		sprintf (answer, "error format\n");
		if ((myStr = strstr(cmd, writeComplete)) != NULL)
		{
										//saveLog (true, cmd);
			snprintf (answer, 1023, "User Permision ALLOW\n");
			myStr += strlen(writeComplete);
			//if (firstRegistration)
			//{
				if ((userIP = strtok(myStr, seps)) != NULL)
				{
									//saveLog(true, "user IP %s\n", userIP);
					if ((cacheSizeStr = strtok(NULL, seps)) != NULL)
					{
						if ((cached = strtok(NULL, seps)) != NULL)
						{
							requestHost = strtok(NULL, seps);
							myCacheAdd = atoi(cacheSizeStr);
							//if (myCacheAdd > 0)
							//{
							userIPaddr.s_addr = inet_addr(userIP);
							//int shareNomer = 0;
							for(i = 1; i < share.size(); ++i)
							{
								if ( share[i].userIP.s_addr == userIPaddr.s_addr)
								{
									//shareNomer = i;
									//saveLog(true, "find user (%s) time=%d utime=%d uid=%d\n", userIP, realTime, share[i].rTime, share[i].userID);
									//time_t RTime = share[i].rTime;
									//int uId = 0;
									//if (strstr(collected[share[i].userID].userName, "Public") != NULL)
									//	sendRequest(userIPaddr, userIP, uId);

									if (((realTime - share[i].rTime) < allowTime) && (share[i].userID > 0))
									{
										findUserfromIP = true;
										userInfo(i, cUserID, cached, myCacheAdd, realTime);
									}
									else {
											//send request for user!!!
											//char getUserName[1024] = "";
											uint uId = 0;
											if (sendRequest(userIPaddr, userIP, uId))
											{
												userInfo(uId, cUserID, cached, myCacheAdd, realTime);
												//shareNomer = uId;
											}
											else
												{
														saveLog (true, "dont answer elapsed time - SQUID string %s\n", userIP);
													saveLog (true, "user IP elapsed time - SQUID string - %s\n", cmd);
													if (!share[i].detachConnection)
													{
														share[i].dropTime = realTime + close_time;
														share[i].detachConnection = true;
														saveLog(true, "set user (%s) DROP time\n", userIP);
													}
												}

										}
									if (share[i].dropTime > realTime)
									{
										snprintf (answer, 1023, "User Permision CLOSE\n");
												saveLog(true, "close user (%s) socket in Squid(1)\n", userIP);
									}
									else
									{
										snprintf (answer, 1023, "User Permision ALLOW\n");
									}
									break;
								}//find user IP
							}//for(i = 0; i < share.size(); ++i)
							if (!findUserfromIP)
								{
									//char getUserName[1024] = "";
									uint uId = 0;
									if ((sendRequest(userIPaddr, userIP, uId)) && (share[uId].userID > 0))
									{
										userInfo(uId, cUserID, cached, myCacheAdd, realTime);
										if (share[uId].dropTime > realTime)
										{
											snprintf (answer, 1023, "User Permision CLOSE\n");
													saveLog(true, "close user (%s) socket in Squid(2)\n", userIP);
										}
										else
										{
											snprintf (answer, 1023, "User Permision ALLOW\n");
										}
									}
									else
									{
											if (strstr(userIP, "0.0.0.0") == NULL)
											{
												saveLog (true, "dont answer and not find user - SQUID string %s\n", userIP);
												saveLog (true, "NOT find user - SQUID string -  %s\n", cmd);
											}
												//snprintf (answer, 1023, "User Permision CLOSE\n");
												//	saveLog(true, "close user (%s) socket in Squid(3)\n", userIP);
												snprintf (answer, 1023, "User Permision ALLOW\n");
										//deregisterUserIP(userIPaddr, userIP);
										/*if (!share[i].detachConnection)
										{
											share[i].dropTime = realTime + close_time;
											share[i].detachConnection = true;
											saveLog(true, "set user (%s) DROP time\n", userIP);
										}*/
									}
								}

							//}//myAddCache
						}//cache
						else {saveLog (true, "error find user cache info from SQUID %s\n", cmd);}
					}//cacheSizeStr
					else {saveLog (true, "error find user Size from SQUID %s\n", cmd);}
					//else snprintf (answer, 1023, "User Permision ALLOW\n");
				}//userIP
				else {saveLog (true, "error find user IP from SQUID %s\n", cmd);}
			//}//firstRegistration

			send(fd, answer, strlen(answer)+1, 0);
		}

	}
		
}
bool SquidChild::userInfo(uint &i, uint &cUserID, char *cached, int myCacheAdd, time_t realTime)
{
//saveLog (true, "get from %s %d \n", cached, myCacheAdd);
	bool acsess = true;
	
	if (
			(collected[share[i].userID].underLimit != -1) && 
			( (collected[share[i].userID].userTraffic-collected[share[i].userID].userCacheTraffic) >
										collected[share[i].userID].userLimit + collected[share[i].userID].underLimit)
			)
		{
			if (strstr(cached, "toinet") == NULL)
			{
				collected[share[i].userID].commercialTraffic += myCacheAdd;
				if (strstr(cached, "cache") != NULL)
				{
					collected[share[i].userID].commercialCacheTraffic += myCacheAdd;
				}
			}
		}
		
	if (strstr(cached, "toinet") == NULL)
	{
		collected[share[i].userID].userTraffic += myCacheAdd;
//saveLog (true, "add to user %s %d traffic\n", collected[share[i].userID].userName, myCacheAdd);

		if (strstr(cached, "cache") != NULL)
		{
			collected[share[i].userID].userCacheTraffic += myCacheAdd;
		}
	}
	//if ((collected[share[i].userID].userTraffic - 102400) > 
	//				collected[share[i].userID].oldUserTraffic)
	if (((collected[share[i].userID].userTraffic - 102400) > 
					collected[share[i].userID].oldUserTraffic) && (realTime - collected[share[i].userID].lastTime > 0))
	{
		collected[share[i].userID].oldUserTraffic = collected[share[i].userID].userTraffic;
		unsigned int real_month, last_month, real_year, last_year;

		struct tm *today, *last;
		today =  localtime( &realTime );
		real_month = today->tm_mon;
		real_year = today->tm_year;
			time_t	registerTime = collected[share[i].userID].lastTime;
			last =  localtime( &registerTime );
		last_month = last->tm_mon;
		last_year = last->tm_year;
		if ((last_month != real_month)	|| (last_year != real_year))
		{
			collected[share[i].userID].userTraffic = 0;
			collected[share[i].userID].userCacheTraffic = 0;
			collected[share[i].userID].oldUserTraffic = 0;
			saveLog (true, "reset user (%s) traffic \n", collected[share[i].userID].userName);
		}
		//saveUserTrafficToDisk(collected[share[i].userID]);
		cUserID = share[i].userID;
//saveLog (true, "must save user %s traffic\n", collected[share[i].userID].userName);

				//++++++++++++++++++++++++++++++++++++++++++++++++
				uint uId = 0;
				//saveLog (true, "update user info - %s\n", share[i].strUserIP);
				if ( !sendRequest(share[i].userIP, share[i].strUserIP, uId) )
				{
					saveLog (true, "not answer %s user IP in userInfo\n", 	share[i].strUserIP);
					//deregisterUserIP(share[i].userIP, share[i].strUserIP);
					acsess = false;
					//return acsess;
				}
					//++++++++++++++++++++++++++++++++++++++++++++++++*/
	}

	if ((checkUserLimit(share[i].userID) > 0) && acsess)
	{
			//restore user connections
			if (share[i].detachConnection)
			{
				share[i].detachConnection = false;
						saveLog(true, "set user (%s) reset detachConnection flag\n", share[i].strUserIP);
				acsess = true;
			}
	}
	else
		{
			//kill user connection if limit is allowed
			if (acsess) 
				saveLog(true, "user (%s) limit exceeding\n", share[i].strUserIP);
				 else 
					saveLog(true, "user (%s) answer time exceeding\n", share[i].strUserIP);
					
			if (!share[i].detachConnection)
			{
				share[i].dropTime = realTime + close_time;
				share[i].detachConnection = true;
				saveLog(true, "set user (%s) DROP time\n", share[i].strUserIP);
				acsess = false;
			}		
		}
	/*if (collected[share[i].userID].underLimit != -1)
	{

		int remains = collected[share[i].userID].userLimit -
			collected[share[i].userID].userTraffic + 
			collected[share[i].userID].userCacheTraffic +
			collected[share[i].userID].underLimit;
		//saveLog(true, "Limited !!! user (%s) connection remains=%d dC=%d\n", userIP, remains, int(share[i].detachConnection));
		if ((remains < 10) || (!acsess))
		{
			saveLog(true, "user (%s) limit exceeding\n", share[i].strUserIP);
			if (!share[i].detachConnection)
			{
				//char dstIPstr[18];
   				//snprintf (dstIPstr, 17, "%s", inet_ntoa (userIP) );
				share[i].dropTime = realTime + close_time;
				share[i].detachConnection = true;
				saveLog(true, "set user (%s) DROP time\n", share[i].strUserIP);
				acsess = false;
			}
		}	
		if (remains > 10240)
		{
			if (share[i].detachConnection)
			{
				share[i].detachConnection = false;
						saveLog(true, "set user (%s) reset detachConnection flag\n", share[i].strUserIP);
				acsess = true;
			}
		}
	}*/
	return acsess;
}

//bool SquidDaemon::sendRequest(struct in_addr userIPaddr, char *userIPstr, char *userName, int &uId)
bool SquidChild::sendRequest(struct in_addr userIPaddr, char *userIPstr, uint &uId)
{
	const int szBif = 1024;
	//int  count;
	char recbuf[szBif], sendbuf[szBif];
	char seps [] = " ;\n\0";
	int s, rc;
	struct sockaddr_in clientsockaddr;
	//struct in_addr localIPaddr;
	//localIPaddr.s_addr = userIPaddr.s_addr;
	bool Code;

	char *firstStr = "Attestation->", *beginStr, *timeStr, *userNameStr, *getUserIPstr;

	time_t realTime, getTime;
	
	//for (count = 0; count < 3; ++ count)
	//{
	Code = false;
	time (&realTime);
	userNameStr="-";
	
	s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	//s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);//SO_REUSEADDR

	if (s > 0)
	{
	    int on = 1;
			if (setsockopt(s, SOL_SOCKET, SO_KEEPALIVE, (char *) &on, sizeof(on)) < 0)
			{
				saveLog (true, "Set KeepAlive error\n");
			}	
			if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on)) < 0)
			{
				saveLog (true, "SetReuseAddr error\n");
			}
			struct linger L;
			L.l_onoff = 0;		// off
			L.l_linger = 0;
			if (setsockopt(s, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
			{
				saveLog (true, "SetNoLinger error\n");
			}

		clientsockaddr.sin_addr.s_addr =  userIPaddr.s_addr;
		//clientsockaddr.sin_addr.s_addr =  inet_addr(regProc);
		clientsockaddr.sin_family = AF_INET;
		clientsockaddr.sin_port   = htons(clientPort);
		rc = connect(s, (struct sockaddr*)&clientsockaddr, sizeof(struct sockaddr_in));
		if (rc == 0)
		{
			sprintf (sendbuf, "Who are you from->%s %s %d\n",  myHostName, myIPstr, int(realTime));
//saveLog(false, "sendRequest: %s", sendbuf);
			myCrypt(sendbuf);
			rc = send(s, sendbuf, strlen(sendbuf), 0);
			if (rc > 0)
			{
				rc = recv(s, recbuf, szBif, 0);
				if ( rc > 0)
				{
					myCrypt(recbuf);
					sprintf (sendbuf, "first-string \n");
//saveLog(false, "recRequest: %s", recbuf);
					if ((beginStr=strstr(recbuf, firstStr)) != NULL)
					{
						beginStr += strlen (firstStr);
//saveLog(false, "beginStr: %s", beginStr);
						//saveLog (true, "str - %s\n", beginStr);
						if ((timeStr = strtok (beginStr, seps)) != NULL)
						{
//saveLog(false, "timeStr: %s\n", timeStr);
							if ((userNameStr = strtok (NULL, seps)) != NULL)
							{
//saveLog(false, "userNameStr: %s\n", userNameStr);
								if (strstr(userNameStr, "cn=") != NULL)
								{
									if ((getUserIPstr = strtok (NULL, seps)) != NULL)
									{
//saveLog(false, "getUserIPstr: %s\n", getUserIPstr);
										sprintf (sendbuf, "time-out \n");
										getTime = atol(timeStr);
										//saveLog (true, "time - %d name - %s\n", getTime, userNameStr);

										//if (getTime > realTime)
										if (getTime == (realTime + 5))
										{
											//strncpy (userName, userNameStr, 1024);
											//sprintf (userName, "%s",userNameStr);
											stringToLow(userNameStr);
											/*char *p;
											for( p = userNameStr; p < userNameStr + strlen( userNameStr ); p++ )
											{
												if ( isascii(* p) )
												{
													if( isupper( *p ) )
														*p = char( tolower( *p ) );
												}
											}*/
											
											if (userIPaddr.s_addr != inet_addr(getUserIPstr))
											{
												saveLog (true, "network IP - %s do not equal ClienTrust IP - %s\n", userIPstr, getUserIPstr);
											}
		
											int getLimit = 0, retcode = -1, lenSend = 0;//, numThread = 0;
	//saveLog(false, "get ldap info\n", sendbuf);
											retcode = registerUserIP(userIPaddr, userIPstr, userNameStr, getLimit, uId);
											if (retcode > 0)
												Code = true;
												else 
													saveLog (true, "Register user on IP error %s - %s\n", userIPstr, userNameStr);
											sprintf (sendbuf, "Attestation rest->%d %d\n", getLimit, retcode);
													lenSend = strlen(sendbuf);
													myCrypt(sendbuf);
													rc = send(s, sendbuf, lenSend, 0);
	//saveLog(false, "atestRequest: %s", sendbuf);
													//rc = send(s, sendbuf, strlen(sendbuf), 0);
													//if ( rc != int(strlen(sendbuf)))
													if ( rc != lenSend)
													{
														myCrypt(sendbuf);
														saveLog(true, "send confirmation <%s> to %s on %s ERROR (real len = %d rc = %d %s)\n", sendbuf, userNameStr, userIPstr, lenSend, rc);
													}
													if ( rc <= 0)
														saveLog(true, "send NULL confirmation string to %s on %s ERROR\n", userNameStr, userIPstr);
										}//if (getTime == (realTime + 5))
												else 	saveLog (true, "time answer user error \n");

									}//if ((getUserIPstr = strtok (NULL, seps)) != NULL)
									else saveLog (true, "don`t recive user IP string\n");
								}//if ((userNameStr = strtok (NULL, seps)) != NULL)
									else saveLog (true, "don`t recive user name string\n");
							}
						}//if ((timeStr = strtok (beginStr, seps)) != NULL)
							else saveLog (true, "don`t recive time string\n");
									//close (s);
					}//if ((beginStr=strstr(recbuf, firstStr)) != NULL)
					else saveLog (true, "don`t recive typed string (%s)\n", recbuf);
				}//rc = recv(s, recbuf, sizeof (recbuf), 0);if ( rc > 0)
				else 	saveLog (true, "send answer to user error\n");
			}
			else saveLog (true, "error connect to user \n");
		}
		close(s);
	}
	//if (Code) break;
	//saveLog (true, "error reqest user IP - %s - reconnect\n", userIPstr);
	//}
	return Code;
}

void SquidChild::saveTraffic()
{
	//if (firstRegistration)
	if (collected.size() > 1)
	{
		uint j;
		for(j = 1; j < collected.size(); ++j)
		{
			saveLog (true, "save user traffic %s\n", collected[j].userName);
			saveUserTrafficToDisk(collected[j]);
		}
	}

}

void SquidChild::saveUserTrafficToDisk(SUserData &sud)
{

	////readBuff[clLen], writeBuff[clLen], 

	time_t realTime, registerTime;
	time (&realTime);

	struct tm *today, *last;
	today =  localtime( &realTime );


		unsigned int real_month, last_month, real_year, last_year;

		real_month = today->tm_mon;
		real_year = today->tm_year;
	
		registerTime = sud.lastTime;
		last =  localtime( &registerTime );
		last_month = last->tm_mon;
		last_year = last->tm_year;
 		if ((last_month != real_month) || (last_year != real_year))
		{
			sud.userTraffic = 0;
			sud.userCacheTraffic = 0;
			sud.oldUserTraffic = 0;
		}
					
					/*char userLimitFileName[clLen];
					snprintf (userLimitFileName, 255, "%s/%2.2d.%2.2d__%s.mdu", baseDir, today->tm_mon + 1, today->tm_year - 100, sud.userName);
					FILE *uLF;
					uLF = fopen(userLimitFileName, "w");
					if (uLF != NULL)
					{
						fprintf (uLF, "%s;%d;%d;%d;%d;%d;", 
							sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.lastTime);
						fclose (uLF);
					}
					 else 
						saveLog (true, "Cannot open user limit file to write !!!\n");*/
		
		//if (!sqlbase.saveToMySQL(sud, real_month+1, (real_year+1900)))
		pthread_mutex_lock(&sql_mutex);
			bool writeToMySQL	= sqlbase.saveToMySQL(sud, real_month, real_year);
		pthread_mutex_unlock(&sql_mutex);
		if (!writeToMySQL)
		{
			saveLog (true, "Cannot save user limit to MySQL\n");
			//sqlbase.myReconnect();
		}

}


int main(int argc, char *argv[]) 
{
	ServerInfo si;

	char *infStr;
	char seps [] = " ;\0\n";
	
#ifdef _INF_FILE
	snprintf (ldapServer, 256, "192.168.1.3");
	snprintf (daemonServer, 18, "192.168.1.3");
	listenPort=712;
	servicePort=702;
	proxyPort=8080;
	snprintf (daemonDir, 1024, "/usr/novell/sys/mySQUID/squid_daemon_s");
	snprintf (baseDir, 1024, "/usr/novell/sys/mySQUID/userbase");
	snprintf (logDir, 1024, "/usr/novell/sys/mySQUID");
	snprintf (effective_user, 256, "tsquid");
	snprintf (effective_group, 256, "tsquidgroup");
	clientPort = 711;
	authPort = 710;
#endif
	
	
	char infFileName[1024];
	//snprintf (infFileName, 1024, "squid_daemon.inf");
	//snprintf (infFileName, 1024, "/usr/novell/sys/mySQUID/squid_daemon_s/squid_daemon.inf");
	snprintf (infFileName, 1024, "/usr/novell/sys/mySQUID/full.inf");


	char *iFN;
	if (argc > 1)
	{
		if ((infStr = strstr(argv[1], "--inf=")) != NULL )
		{
			infStr += strlen("--inf=");
			if ((iFN = strtok(infStr, seps)) != NULL)
			{
				snprintf (infFileName, 1024, "%s", iFN);
			}
			
		}
	}

	FILE *infoFile;
	infoFile = fopen (infFileName, "r");
	char rBuf [4096];//, ldapString[256];
	if (infoFile != NULL)
	{
		int countii = 0;
		int numberVariable = 20;
		printf ("open inf file\n");
		while (fgets(rBuf, 4096, infoFile) != NULL)
		{
			int ii;
			char *configMass [] = {"ldapServer",
									"daemonServer",
									"listenPort",
									"servicePort",
									"proxyPort",
									"daemonDir",
									"logDir",
									"effective_user",
									"effective_group",
									"clientPort",
									"authPort",
									"ldapAttr",
									"useSSL",
									"MySQLuser",
									"MySQLpassword",
									"MySQLserver",
									"MySQLport",
									"MySQLbase",
									"ldapLogin",
									"ldapPassword"
									};

			char *confString, *configMean;//, *ldapServerIP;

			for (ii = 0; ii < numberVariable; ++ii)
			{
				if ((confString = strstr(rBuf, configMass[ii])) != NULL)
				{
					countii ++;
					confString += strlen (configMass[ii]);
					if ((configMean = strtok(confString, seps)) != NULL)
					{
						switch (ii)
						{
							case 0: //snprintf (ldapServer, 256, "%s", configMean);
								snprintf (si.ldapServer, 256, "%s", configMean);
								printf ("ldapServer - %s +\n", si.ldapServer);
								break;
							case 1: snprintf (daemonServer, 256, "%s", configMean);
								printf ("daemonServer - %s +\n", daemonServer);
								break;
							case 2: listenPort = atoi (configMean);
								printf ("listenPort - %d +\n", listenPort);
								break;
							case 3: servicePort = atoi (configMean);
								printf ("servicePort - %d +\n", servicePort);
								break;
							case 4: proxyPort = atoi (configMean);
								printf ("proxyPort - %d +\n", proxyPort);
								break;
							case 5: snprintf (daemonDir, 1024, "%s", configMean);
								printf ("daemonDir - %s +\n", daemonDir);
								break;
							case 6: snprintf (logDir, 1024, "%s", configMean);
								printf ("logDir - %s +\n", logDir);
								break;
							case 7: snprintf (effective_user, 256, "%s", configMean);
								printf ("effective_user - %s +\n", effective_user);
								break;
							case 8: snprintf (effective_group, 256, "%s", configMean);
								printf ("effective_group - %s +\n", effective_group);
								break;
							case 9: clientPort = atoi (configMean);
								printf ("clientPort - %d +\n", clientPort);
								break;
							case 10: authPort = atoi (configMean);
								printf ("authtPort - %d +\n", authPort);
								break;
							case 11: snprintf (ldapStr, 1024, "%s", configMean);
								printf ("ldapStr - %s +\n", ldapStr);
								break;
							case 12: if (strstr (configMean, "true"))
									 {
										si.needSSL = true;
										 printf ("needSSL - true +\n");
									 }
									 else
									 {
										 si.needSSL = false;
										printf ("neddSSL - false +\n");
									 }
								break;
							case 13: snprintf (si.username, 255, "%s", configMean);
								printf ("MySQL username - %s +\n", si.username);
								break;
							case 14: snprintf (si.password, 255, "%s", configMean);
								printf ("MySQL password - %s +\n", si.password);
								break;
							case 15: snprintf (si.host, 255, "%s", configMean);
								printf ("MySQL host - %s +\n", si.host);
								break;
							case 16: si.port = atoi(configMean);
								printf ("MySQL port - %d +\n", si.port);
								break;
							case 17: snprintf (si.database, 255, "%s", configMean);
								printf ("MySQL base - %s +\n", si.database);
								break;
							case 18: snprintf (si.LDAPlogin, 255, "%s", configMean);
								printf ("LDAPlogin - %s +\n", si.LDAPlogin);
								break;
							case 19: snprintf (si.LDAPpassword, 255, "%s", configMean);
								printf ("LDAPpassword - %s +\n", si.LDAPpassword);
								break;
						}
					}
				}
			}

		}
		fclose (infoFile);
		if (countii < numberVariable)
		{
			printf ("Not full inf file\n");
			exit (0);
		}
	}
	else
		{
			printf ("Cannot open SquidDaemon inf file !!!\n");
			exit (0);
		}

	daemonServerIP.s_addr = inet_addr(daemonServer);
	snprintf (logFileName, 1024, "%s/mySquidDaemon.log", logDir);
	snprintf (pidFileName, 1024, "%s/daemonPid", daemonDir);

	//printf ("log - %s +\n", logFileName);

	//vectorAttrs myAttrs;
	//vectorAttrs myBase;
		myString ms;
		strncpy (ms.str, "groupMembership", 255);
	//printf ("3\n");
		si.myVectorAttrs.push_back (ms);

	char *getAttr;
	char sep2 [] = ",\0\n"; 
	//printf ("begin\n");
	getAttr = strtok (ldapStr, sep2);
	//printf ("begin while\n");
	while (getAttr != NULL)
	{
	//printf ("1\n");
	//printf ("getAttr %s\n", getAttr);
	//printf ("2\n");
		strncpy (ms.str, getAttr, 255);
	//printf ("3\n");
		si.myVectorAttrs.push_back (ms);
	//printf ("4\n");
		getAttr = strtok (NULL, sep2);
	//printf ("5\n");
	}
	//printf ("end\n");
	uint z;
	for (z = 0; z < si.myVectorAttrs.size(); z++)
		printf ("getAttr[%u] %s\n", z, (si.myVectorAttrs[z].str));

	SquidDaemon sqd(si);

	sqd.execute();

	return 0;
}


bool myCrypt(char *strCript)
{
	unsigned int myLen;
	unsigned char cryptSymbol;

	myLen = strlen(strCript);
	cryptSymbol = myLen & 7;

	uint i;
	if ((myLen < 1) || (myLen >= 1024)) return false;
	for (i = 0; i < myLen ; i ++)
	{
		strCript[i] = (strCript[i] ^ cryptSymbol);

		cryptSymbol --;
		if (cryptSymbol <= 0)
		{
			cryptSymbol = myLen & 7;
		}
	}

	return true;
}

void print_to_file (FILE *fp, const char *format, va_list args)
{
	vfprintf(fp, format, args);
}

void saveLog(bool ntime, const char *format,...)
{
	va_list marker;
    va_start(marker, format);
	FILE *fp;
	fp = fopen(logFileName,"a+");
	if (fp != NULL)
	{
		if (ntime)
		{
			time_t workTime;
			time (&workTime);
			struct tm *today;
			today =  localtime( &workTime );
			fprintf (fp, "%d.%d.%d-%d:%d:%d [%d]>", 
					today->tm_mday, today->tm_mon+1, today->tm_year-100 , today->tm_hour, today->tm_min, today->tm_sec,
					workTime);
		}
			
		static char f[4096];   
		snprintf (f, 4095, "%s", format);

		if (strlen(f) > 0)
			print_to_file (fp, f, marker);
		fclose(fp);
	}
	va_end( marker );
}
void stringToLow(char *inStr)
{
		char *p;
		for( p = inStr; p < inStr + strlen( inStr ); p++ )
		{
			if ( isascii(* p) )
			{
				if( isupper( *p ) )
					*p = char( tolower( *p ) );
			}
		}
}



// Local Variables:
// mode:C++
// End:
