/*
//ͻ
// (c) 1995-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_AUT.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_AUT_H )
   #define NWDP_AUT_H

/* Standard Library Header Includes */
   #if !defined(NWDP_ATR_H)
      #include <nwdp_atr.h>
   #endif

/* Header Includes */

/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPAUtilAttributeListCallback)(
   NWDPAccessorRef   accessorRef,
   nparam            callerDefinedParam,
   nint              totalCallsToBeMade,
   nint              currentCallCount,
   pNWDPAttribute    attributePtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPAUtilAttrValueListCallback)(
   NWDPAccessorRef     accessorRef,
   nparam              callerDefinedParam,
   nint                totalCallsToBeMade,
   nint                currentCallCount,
   pNWDPAttributeValue valuePtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPAUtilAddAttributeWithValues(
   NWDPAccessorRef   accessorRef,
   NWDPASAVPRef      destAvpRef,
   pNWDPAttribute    srcAttributePtr,
   pnuint32          qualifierPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilAppendAttrSet(
   NWDPAccessorRef   accessorRef,
   NWDPASAVPRef      destAvpRef,
   pNWDPAttributeSet srcAttrSetPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilAppendAttrValueSet(  
   NWDPAccessorRef         accessorRef,
   pNWDPAttributeValueSet  destAttrValueSetPtr,
   pNWDPAttributeValueSet  srcAttrValueSetPtr
   );

/*
// no longer supported 23 Aug 00 Library version 1.8.6
//  N_EXTERN_LIBRARY(nint)
// NWDPAUtilAsciiToCardinal64(
//    NWDPAccessorRef      accessorRef,
//    pnstr                numericDecimalStringPtr,
//    pNWDPAttributeValue  valuePtr
//    );
// 
//  N_EXTERN_LIBRARY(nint)
// NWDPAUtilCardinal64ToAscii(
//    NWDPAccessorRef      accessorRef,
//    pNWDPAttributeValue  valuePtr,
//    nbool                useSeparators,
//    nuint                sizeOfStringBuffer,
//    pnstr                stringBufferPtr,
//    pnuint               sizeOfResultPtr
//    );
*/

 N_EXTERN_LIBRARY(nint)
NWDPAUtilCompareDataType(
   NWDPAccessorRef accessorRef,
   NWDPAVTEnum dataType,
   nptr data1Ptr,
   nptr data2Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilCompareAttrValue(
   NWDPAccessorRef     accessorRef, 
   pNWDPAttributeValue attrValue1Ptr,  
   pNWDPAttributeValue attrValue2Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilDupAttribute(
   NWDPAccessorRef accessorRef,         
   pNWDPAttribute  destAttributePtr,     
   pNWDPAttribute  srcAttributePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilDupDataType(
   NWDPAccessorRef   accessorRef,
   NWDPAVTEnum       dataType,
   nptr              destPtr,    
   nptr              srcPtr     
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilDupAttrValue(
   NWDPAccessorRef      accessorRef,         
   pNWDPAttributeValue  destAttrValuePtr,     
   pNWDPAttributeValue  srcAttrValuePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilFreeAttribute(
   NWDPAccessorRef accessorRef,         
   pNWDPAttribute  attributePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilFreeAttrValueSet(  
   NWDPAccessorRef         accessorRef,
   pNWDPAttributeValueSet  attrValueSetPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilFreeDataType(
   NWDPAccessorRef   accessorRef,
   NWDPAVTEnum       dataType,
   nptr              dataPtr     
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilFreeAttrValue(
   NWDPAccessorRef      accessorRef,         
   pNWDPAttributeValue  attrValuePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilListAttributes(
   NWDPAccessorRef                accessorRef,
   pNWDPAttributeSet              attributeSetPtr,
   NWDPAUtilAttributeListCallback listCallback,
   nparam                         callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilListAttrValues(
   NWDPAccessorRef                accessorRef,
   pNWDPAttribute                 attributePtr,
   NWDPAUtilAttrValueListCallback listCallback,
   nparam                         callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilMergeAttrSet(
   NWDPAccessorRef   accessorRef,
   NWDPASAVPRef      destAvpRef,
   pNWDPAttributeSet srcAttrSetPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPAUtilRemoveAllAttributes(
   NWDPAccessorRef   accessorRef,
   pNWDPAttributeSet attrSetPtr
   );

#else /* NWDP_AUT_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_aut.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_AUT_H */
