/*
//ͻ
// (c) 1995-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_BRK.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_BRK_H )
   #define NWDP_BRK_H

/* Standard Library Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_BKR_H)
      #include <nwdp_bkr.h>
   #endif

/* Header Includes */

/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

   /*
   // service list callback item structure
   */
   typedef NWDPBrokerService  NWDPServiceListItem,
                      N_FAR *pNWDPServiceListItem;


#include <npackoff.h>

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPBrkServicesListCallback)(
   NWDPAccessorRef      accessorRef,
   nparam               callerDefinedParam,
   nint                 totalCallsToBeMade,
   nint                 currentCallCount,
   pNWDPServiceListItem itemReceivedPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPBrkCreateRefBasedOnFQN(
   NWDPAccessorRef      accessorRef,
   pNWDPNSrvFQN         brokerFqnPtr,
   pNWDPBrkRef          brokerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkDestroyRef(
   NWDPAccessorRef accessorRef,
   pNWDPBrkRef brokerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkDisableService(
   NWDPAccessorRef accessorRef,
   NWDPBrkRef brokerRef,
   NWDPServiceTypeEnum serviceType
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkEnableService(
   NWDPAccessorRef accessorRef,
   NWDPBrkRef brokerRef,
   NWDPServiceTypeEnum serviceType
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkGetConnectionStatus(
   NWDPAccessorRef accessorRef,
   NWDPBrkRef      brokerRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkGetFQN(
   NWDPAccessorRef      accessorRef,
   NWDPBrkRef           brokerRef,
   nuint                sizeOfBuffer,
   pNWDPNSrvFQNBuffer   fqnBufferPtr,
   pnuint               sizeOfResultPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkListServices(
   NWDPAccessorRef accessorRef,
   NWDPBrkRef brokerRef,
   NWDPListServicesEnum supportedVsEnabledFilter,
   NWDPBrkServicesListCallback listCallback,
   nparam callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkShutdown(
   NWDPAccessorRef accessorRef,
   NWDPBrkRef brokerRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPBrkValidateRef(
   NWDPAccessorRef accessorRef,
	NWDPBrkRef brokerRef
   );

#else /* NWDP_BRK_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_spn.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_BRK_H */
