/*
//ͻ
// (c) 1998-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_INF.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_INF_H )
   #define NWDP_INF_H

/* Standard Library Header Includes */

/* Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif


/* Manifest Constant Definitions */
   /* the def below is for use with NWDPInfInsertLineInSection */
   #define NWDP_INF_AFTER_LAST_LINE   -1

/* Macro Definitions */

/* Type Definitions */

   typedef struct NWDPInfLine_T {
      pnchar16                lineBuffer16Ptr;
      pnstr16                 keyName16Ptr;
      pnstr16                 value16Ptr;
      nbool                   lineContentsInvalid;
      nuint32                 flags;
   } NWDPInfLine,
     N_FAR *pNWDPInfLine;

   typedef struct NWDPInfSection_T {
      pnstr16                 sectionName16Ptr;
      nuint                   linesCount;
      pNWDPInfLine            linesPtr;
      nuint32                 flags;
      nbool                   sectionContentsInvalid;
      nuint                   currentLineIndex;
   } NWDPInfSection,
     N_FAR *NWDPInfSectionRef,
     N_FAR * N_FAR *pNWDPInfSectionRef;

   typedef struct NWDPInfStruct_T
   {
      nuint                   sectionsCount;
      NWDPInfSectionRef       sectionsPtr;
   } NWDPInfStruct,
     N_FAR *NWDPInfRef,
     N_FAR * N_FAR *pNWDPInfRef;

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

   N_EXTERN_LIBRARY(nint)
 NWDPInfCreateRef(
   NWDPAccessorRef      accessorRef,      /* I: library accessor reference */
   pnstr                filePathPtr,      /* I: complete INF filename and path */
   pNWDPInfRef          infRefPtr         /* O: returned INF reference */
   );

   N_EXTERN_LIBRARY(nint)
 NWDPInfDestroyRef(
   NWDPAccessorRef      accessorRef,      /* I: library accessor reference */
   pNWDPInfRef          infRefPtr         /* IO: INF reference to be destroyed */
   );

   /* new for 1.3 */
   N_EXTERN_LIBRARY(nint)
 NWDPInfWriteToFile(
   NWDPAccessorRef      accessorRef,      /* I: library accessor reference */
   NWDPInfRef           infRef,           /* I: INF reference */
   pnstr                filePathPtr       /* I: complete INF filename and path */
   );

   /* new for 1.8.6 */
   N_EXTERN_LIBRARY(nint)
 NWDPInfMakeSectionRef16(
   NWDPAccessorRef      accessorRef,      /* I: library accessor reference */
   NWDPInfRef           infRef,           /* I: INF reference from Create */
   pnstr16              sectionName16Ptr, /* I: section name to locate */
   pNWDPInfSectionRef   sectionRefPtr     /* O: returned Section reference */
   );

   N_EXTERN_LIBRARY(nint)
 NWDPInfGetNextKeyAndValue16(
   NWDPAccessorRef   accessorRef,         /* I: library accessor reference */
   NWDPInfSectionRef sectionRef,          /* I: section reference from Make */
   pnstr16           keyNameReturnBuf16Ptr,/* IO: ptr to return data buffer */
   nint              keyNameBufSize,      /* I: return buffer unisize */
   pnstr16           valueReturnBuf16Ptr, /* IO: ptr to return data buffer */
   nint              valueBufSize         /* I: return buffer unisize */
   );
   
   N_EXTERN_LIBRARY(nint)
 NWDPInfGetValueFromKey16(             /* Also sets currentLineIndex */
   NWDPAccessorRef   accessorRef,      /* I: library accessor reference */
   NWDPInfSectionRef sectionRef,       /* I: section reference from Make */
   pnstr16           keyName16Ptr,     /* I: keyName to locate in the section */
   pnstr16           defaultStr16Ptr,  /* I: def str if no data fnd */
   pnstr16           returnBuf16Ptr,   /* IO: ptr to return data buffer */
   nint              bufSize           /* I: return buffer unisize */
   );

   N_EXTERN_LIBRARY(nint)
 NWDPInfInsertLineInSection16(         /* Insert Line before line indicated */
   NWDPAccessorRef   accessorRef,      /* I: library accessor reference */
   NWDPInfRef        infRef,           /* I: INF reference */
   NWDPInfSectionRef sectionRef,       /* I: section reference from Make */
   nint              lineIndex,        /* I: 0-relative line index of new line*/
   pnstr16           newLineBuffer16Ptr/* I: ptr to line data buffer */
   );

   N_EXTERN_LIBRARY(nint)
 NWDPInfReplaceLineInSection16(
   NWDPAccessorRef   accessorRef,      /* I: library accessor reference */
   NWDPInfRef        infRef,           /* I: INF reference */
   NWDPInfSectionRef sectionRef,       /* I: section reference from Make */
   nuint             lineIndex,        /* I: 0-relative line index */
   pnstr16           newLineBuffer16Ptr/* I: ptr to line data buffer */
   );

#else /* NWDP_INF_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_inf.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_INF_H */

