/*
//ͻ
// (c) 1995-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_JOB.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_JOB_H )
   #define NWDP_JOB_H

/* Standard Library Header Includes */

/* Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_ATR_H)
      #include <nwdp_atr.h>
   #endif


/* Manifest Constant Definitions */
   #define NWDP_JOB_FLG_DESTROY_REF    0x00000001L
   #define NWDP_JOB_FLG_SET_RETENTION  0x00000002L

/* Macro Definitions */

/* Type Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPJobCancel(
   NWDPAccessorRef accessorRef,
   pNWDPJobRef jobRefPtr,
   nuint32 flags,
   nuint32 retentionPeriod
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobCopy(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef destPrinterRef,
   NWDPJobRef srcJobRef,
   pNWDPJobRef destJobRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobCreateRef(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef printerRef,
   NWDPAttrSetRef attrSetRef,
   pNWDPJobRef jobRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobCreateRefBasedOnJobId(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef printerRef,
   nuint32 jobId,
   pNWDPJobRef jobRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobDestroyRef(
   NWDPAccessorRef accessorRef,
   pNWDPJobRef jobRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobGetAttributeSet(
   NWDPAccessorRef   accessorRef,
   NWDPJobRef        jobRef,
   NWDPOidSetRef     requestedOidSetRef,
   pNWDPAttrSetRef   resultAttrSetRefPtr,
   pNWDPASAVPRef     avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobGetId(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef,
   pnuint32 jobIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobGetStatus(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef,
   pNWDPAttrSetRef resultAttrSetRefPtr,
   pNWDPASAVPRef avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobInterrupt(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobModifyAttrs(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef,
   NWDPAttrSetRef jobModifyRef,
   NWDPModifyOperatorEnum jobOperator,
   NWDPDocRef  docRef,
   NWDPAttrSetRef docModifyRef,
   NWDPModifyOperatorEnum docOperator
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobMove(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef destPrinterRef,
   pNWDPJobRef jobRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobPause(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobPromote(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobReorder(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef,
   nuint32 referenceJobId
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobResume(
   NWDPAccessorRef accessorRef,
   NWDPJobRef jobRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobSubmit(
   NWDPAccessorRef accessorRef,
   pNWDPJobRef jobRefPtr,
   nuint32 flags
   );

 N_EXTERN_LIBRARY(nint)
NWDPJobValidateRef(
   NWDPAccessorRef accessorRef,
	NWDPJobRef jobRef
   );

#else /* NWDP_JOB_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_job.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_JOB_H */

