/*
//ͻ
// (c) 1995-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_LIB.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_LIB_H )
   #define NWDP_LIB_H

/* Standard Library Header Includes */
   #if !defined( NTYPES_H )
      #define N_INC_NO_OLD_CONSTANTS
      #include <ntypes.h>
      #undef  N_INC_NO_OLD_CONSTANTS
   #endif

/* Header Includes */
   #if !defined(NWDP_WKO_OGH)
       #include <nwdp_wko.ogh>
   #endif
   #if !defined(NWDP_ATT_H)
       #include <nwdp_att.h>
   #endif

/* Manifest Constant Definitions */
#define NWDP_LIBRARY_MAJOR_VERSION     1
#define NWDP_LIBRARY_MINOR_VERSION     8
#define NWDP_LIBRARY_BUGFIX_REVISION   6
#define NWDP_LIBRARY_PREREL_VERSION    0x0000

/*
// For use with NWDPLibSetArtificialMemLimit to turn off this feature
*/
#define NWDP_MEM_LIMIT_NONE            0xFFFFFFFFL

/* Macro Definitions */

/*
// Convenience access to Unicode Table Handles used internally
// by the Library
*/
#define NWDPLocalToUnicodeHandleMac(__accRef) \
   (((NWDPAccessorRef)(__accRef))->cADBPtr->localToUnicodeHandle)

#define NWDPUnicodeToLocalHandleMac(__accRef) \
   (((NWDPAccessorRef)(__accRef))->cADBPtr->unicodeToLocalHandle)

#define NWDPMonocaseHandleMac(__accRef) \
   (((NWDPAccessorRef)(__accRef))->cADBPtr->monocaseHandle)


#if !defined(NWDPAccessorRef)
#define NWDPAccessorRef          NWDPAccessorData N_FAR *
#define NWDPBrkRef               nptr
#define NWDPDocRef               nptr
#define NWDPFilterRef            nptr
#define NWDPJobRef               nptr
#define NWDPNSrvObjRef           nptr
#define NWDPOidRef               NWDPOidStruct N_FAR *
#define NWDPOidSetRef            pNWDPObjectIdentifierSet
#define NWDPAttrSetRef           pNWDPAttrSetStruct
#define NWDPASAVPRef             pNWDPASAVPStruct
#define NWDPPrtRef               nptr
#define NWDPSrsRef               nptr
#define NWDPPsmRef               nptr
#define NWDPResRef               nptr
#define NWDPNtfyRef              nptr
#define NWDPNtfyMethodInfoRef    nptr
#define NWDPNtfyProfileRef       pNWDPEventHandlingProfile
#endif

#define pNWDPAccessorRef         NWDPAccessorRef   N_FAR *
#define pNWDPBrkRef              NWDPBrkRef        N_FAR *
#define pNWDPDocRef              NWDPDocRef        N_FAR *
#define pNWDPFileRef             NWDPFileRef       N_FAR *
#define pNWDPFilterRef           NWDPFilterRef     N_FAR *
#define pNWDPJobRef              NWDPJobRef        N_FAR *
#define pNWDPNSrvObjRef          NWDPNSrvObjRef    N_FAR *
#define pNWDPOidRef              NWDPOidRef        N_FAR *
#define pNWDPOidSetRef           NWDPOidSetRef     N_FAR *
#define pNWDPAttrSetRef          NWDPAttrSetRef    N_FAR *
#define pNWDPASAVPRef            NWDPASAVPRef      N_FAR *
#define pNWDPPrtRef              NWDPPrtRef        N_FAR *
#define pNWDPSrsRef              NWDPSrsRef        N_FAR *
#define pNWDPPsmRef              NWDPPsmRef        N_FAR *
#define pNWDPResRef              NWDPResRef        N_FAR *
#define pNWDPNtfyRef             NWDPNtfyRef       N_FAR *
#define pNWDPNtfyMethodInfoRef   NWDPNtfyMethodInfoRef N_FAR *
#define pNWDPNtfyProfileRef      NWDPNtfyProfileRef N_FAR *

#if defined(N_PLAT_MSW)
   #if defined(N_PLAT_MSW3)
      #define __NWDPLibDefineTaskIdMac                                 \
	   nuint __taskId = (nuint)(HANDLE)GetCurrentTask();                \
	   nuint __subTaskId = 0;
   #elif defined(N_PLAT_MSW4)
      #define __NWDPLibDefineTaskIdMac                                 \
	   nuint __taskId = (nuint)(HANDLE)GetCurrentThread();              \
	   nuint __subTaskId = 0;
   #endif
   #if !defined(MESSAGE_BOX)
      #if defined( __cplusplus )
         #define MESSAGE_BOX(a,b) ::MessageBox(0,(LPSTR)(a),(LPSTR)(b),MB_OK)
      #else
         #define MESSAGE_BOX(a,b) MessageBox(0,(LPSTR)(a),(LPSTR)(b),MB_OK)
      #endif
   #endif
#elif defined(N_PLAT_NLM)
   #define __NWDPLibDefineTaskIdMac                                    \
	nuint __taskId    = (nuint)GetThreadGroupID();                      \
	nuint __subTaskId = (nuint)GetThreadID();
#else
   /*
   // This works for DOS, OS/2 and UNIX
   */
   #define __NWDPLibDefineTaskIdMac                                    \
	nuint __taskId    = (nuint)getpid();                                \
	nuint __subTaskId = 0;
#endif

#if defined(N_DEBUG)
   #if defined(N_PLAT_MSW)
   #define NWDPLibInitMac(__accRefPtr)                                 \
{                                                                      \
   NWDPInitCode __retCode;                                             \
   nchar  __buf1[80];                                                  \
   pnchar __buf2Ptr;                                                   \
   nuint __actualMajorVersion;                                         \
   nuint __actualMinorVersion;                                         \
   nuint __actualBugfixRevision;                                       \
   nuint __actualPrereleaseVersion;                                    \
                                                                       \
   __NWDPLibDefineTaskIdMac;                                           \
   __retCode = NWDPLibInit(                                            \
               NWDP_LIBRARY_MAJOR_VERSION,                             \
               NWDP_LIBRARY_MINOR_VERSION,                             \
               NWDP_LIBRARY_BUGFIX_REVISION,                           \
               NWDP_LIBRARY_PREREL_VERSION,                            \
               __taskId,                                               \
               __subTaskId,                                            \
               __accRefPtr,                                            \
               &__actualMajorVersion,                                  \
               &__actualMinorVersion,                                  \
               &__actualBugfixRevision,                                \
               &__actualPrereleaseVersion                              \
               );                                                      \
   if (__retCode < 0)                                                  \
   {                                                                   \
      switch(__retCode)                                                \
      {                                                                \
         case NWDP_IC_ERR_NO_MEMORY:                                   \
            __buf2Ptr = "NWDP_IC_ERR_NO_MEMORY";                       \
            break;                                                     \
         case NWDP_IC_ERR_NO_ACCESSOR:                                 \
            __buf2Ptr = "NWDP_IC_ERR_NO_ACCESSOR";                     \
            break;                                                     \
         case NWDP_IC_ERR_WRONG_MAJOR_VERSION:                         \
            __buf2Ptr = "NWDP_IC_ERR_WRONG_MAJOR_VERSION";             \
            break;                                                     \
         case NWDP_IC_ERR_OLD_MINOR_VERSION:                           \
            __buf2Ptr = "NWDP_IC_ERR_OLD_MINOR_VERSION";               \
            break;                                                     \
         case NWDP_IC_ERR_OLD_REVISION:                                \
            __buf2Ptr = "NWDP_IC_ERR_OLD_REVISION";                    \
            break;                                                     \
         case NWDP_IC_ERR_IS_PRERELEASE:                               \
            __buf2Ptr = "NWDP_IC_ERR_IS_PRERELEASE";                   \
            break;                                                     \
         case NWDP_IC_ERR_OLD_PRERELEASE:                              \
            __buf2Ptr = "NWDP_IC_ERR_OLD_PRERELEASE";                  \
            break;                                                     \
         case NWDP_IC_ERR_UNICODE_INIT:                                \
            __buf2Ptr = "NWDP_IC_ERR_UNICODE_INIT";                    \
            wsprintf(__buf1,"NWDPLibInit returned error: %d -- %s\n"   \
               "NLS subdirectory is not in the PATH.",                 \
               __retCode,                                              \
               __buf2Ptr                                               \
               );                                                      \
            break;                                                     \
         case NWDP_IC_ERR_WINDOW_CREATE:                               \
            __buf2Ptr = "NWDP_IC_ERR_WINDOW_CREATE -\n"                \
                        "Out of memory?";                              \
            break;                                                     \
         case NWDP_IC_ERR_MISMATCHED_DLL:                              \
            __buf2Ptr = "NWDP_IC_ERR_MISMATCHED_DLL -\n"               \
                        "Use ndir DP?WIN*.DLL /ver\n"                  \
                        "Replace out-of-sync DLL(s)";                  \
            break;                                                     \
         case NWDP_IC_ERR_RPC_WINSOCK_INIT:                            \
            __buf2Ptr = "NWDP_IC_ERR_RPC_WINSOCK_INIT -\n"             \
                        "Out of memory? or Winsock Fail?";             \
            break;                                                     \
         default:                                                      \
            switch (__retCode)                                         \
            {                                                          \
               case NWDP_IC_ERR_NWCALLS_INIT:                          \
                  __buf2Ptr = "NWDP_IC_ERR_NWCALLS_INIT";              \
                  break;                                               \
                                                                       \
               default:                                                \
                  /* Should never get here */                          \
                  __buf2Ptr = "new error";                             \
                  break;                                               \
            }                                                          \
            wsprintf(__buf1,"NWDPLibInit returned error: %d -- %s",    \
               __retCode,                                              \
               __buf2Ptr                                               \
               );                                                      \
            break;                                                     \
      }                                                                \
      if (__retCode < 0 && __retCode >= NWDP_IC_ERR_OLD_PRERELEASE)    \
      {                                                                \
         wsprintf(__buf1,"NWDPLibInit returned error: %d -- %s\n"      \
               "Reported version: %u.%u.%u%x\n"                        \
               "Expected version: %u.%u.%u%x",                         \
               __retCode,                                              \
               __buf2Ptr,                                              \
               __actualMajorVersion,                                   \
               __actualMinorVersion,                                   \
               __actualBugfixRevision,                                 \
               __actualPrereleaseVersion,                              \
               NWDP_LIBRARY_MAJOR_VERSION,                             \
               NWDP_LIBRARY_MINOR_VERSION,                             \
               NWDP_LIBRARY_BUGFIX_REVISION,                           \
               NWDP_LIBRARY_PREREL_VERSION                             \
               );                                                      \
      }                                                                \
      MESSAGE_BOX(__buf1,"NWDPLibInitMac Report");                     \
      exit(__retCode);                                                 \
   }                                                                   \
   else if (__retCode > 0)                                             \
   {                                                                   \
      switch(__retCode)                                                \
      {                                                                \
         case NWDP_IC_WARN_REPEAT_ID:                                  \
            __buf2Ptr = "NWDP_IC_WARN_REPEAT_ID";                      \
            wsprintf(__buf1,                                           \
               "NWDPLibInit returned warning: %d -- %s\n"              \
               "TaskId: %u\n SubTaskId: %u\n",                         \
               __retCode,__buf2Ptr,__taskId,__subTaskId);              \
            break;                                                     \
         default:                                                      \
            switch (__retCode)                                         \
            {                                                          \
               case NWDP_IC_WARN_VER_OBSOLETE:                         \
                  __buf2Ptr = "NWDP_IC_WARN_VER_OBSOLETE";             \
                  break;                                               \
                                                                       \
               default:                                                \
                  /* Should never get here */                          \
                  __buf2Ptr = "new warning";                           \
                  break;                                               \
            }                                                          \
            wsprintf(__buf1,"NWDPLibInit returned warning: %d -- %s",  \
                  __retCode, __buf2Ptr);                               \
            break;                                                     \
      }                                                                \
      MESSAGE_BOX(__buf1,"NWDPLibInitMac Report");                     \
   }                                                                   \
}
   #else
   #define NWDPLibInitMac(__accRefPtr)                                 \
{                                                                      \
   NWDPInitCode __retCode;                                             \
   nuint __actualMajorVersion;                                         \
   nuint __actualMinorVersion;                                         \
   nuint __actualBugfixRevision;                                       \
   nuint __actualPrereleaseVersion;                                    \
                                                                       \
   __NWDPLibDefineTaskIdMac;                                           \
   __retCode = NWDPLibInit(                                            \
               NWDP_LIBRARY_MAJOR_VERSION,                             \
               NWDP_LIBRARY_MINOR_VERSION,                             \
               NWDP_LIBRARY_BUGFIX_REVISION,                           \
               NWDP_LIBRARY_PREREL_VERSION,                            \
               __taskId,                                               \
               __subTaskId,                                            \
               __accRefPtr,                                            \
               &__actualMajorVersion,                                  \
               &__actualMinorVersion,                                  \
               &__actualBugfixRevision,                                \
               &__actualPrereleaseVersion                              \
               );                                                      \
   if (__retCode < 0)                                                  \
   {                                                                   \
      printf("\nNWDPLibInitMac Report\n"                               \
             "\n NWDPLibInit returned error: %d -- ",__retCode);       \
      switch(__retCode)                                                \
      {                                                                \
         case NWDP_IC_ERR_NO_MEMORY:                                   \
            printf("NWDP_IC_ERR_NO_MEMORY");                           \
            break;                                                     \
         case NWDP_IC_ERR_NO_ACCESSOR:                                 \
            printf("NWDP_IC_ERR_NO_ACCESSOR");                         \
            break;                                                     \
         case NWDP_IC_ERR_WRONG_MAJOR_VERSION:                         \
            printf("NWDP_IC_ERR_WRONG_MAJOR_VERSION");                 \
            break;                                                     \
         case NWDP_IC_ERR_OLD_MINOR_VERSION:                           \
            printf("NWDP_IC_ERR_OLD_MINOR_VERSION");                   \
            break;                                                     \
         case NWDP_IC_ERR_OLD_REVISION:                                \
            printf("NWDP_IC_ERR_OLD_REVISION");                        \
            break;                                                     \
         case NWDP_IC_ERR_IS_PRERELEASE:                               \
            printf("NWDP_IC_ERR_IS_PRERELEASE");                       \
            break;                                                     \
         case NWDP_IC_ERR_OLD_PRERELEASE:                              \
            printf("NWDP_IC_ERR_OLD_PRERELEASE");                      \
            break;                                                     \
         case NWDP_IC_ERR_NWCALLS_INIT:                                \
            printf("NWDP_IC_ERR_NWCALLS_INIT\n");                      \
            break;                                                     \
         case NWDP_IC_ERR_UNICODE_INIT:                                \
            printf("NWDP_IC_ERR_UNICODE_INIT\n"                        \
                   "NLS subdirectory is not in the PATH.\n");          \
            break;                                                     \
         case NWDP_IC_ERR_MISMATCHED_SUBLIB:                           \
            printf("NWDP_IC_ERR_MISMATCHED_SUBLIB -\n"                 \
                   "Use ndir DP?DOS*.LIB /ver\n"                       \
                   "Correct Linker error and relink.\n");              \
            break;                                                     \
         case NWDP_IC_ERR_NLM_ID_MISMATCH:                          \
            printf("NWDP_IC_ERR_NLM_ID_MISMATCH -\n"                \
                        "Previous use of taskId value with different NLM Id.");  \
            break;                                                     \
         default:                                                      \
            /* Should never get here */                                \
            printf("new error\n");                                     \
            break;                                                     \
      }                                                                \
      if (__retCode < 0 && __retCode >= NWDP_IC_ERR_OLD_PRERELEASE)    \
      {                                                                \
         printf("\n Reported version: %u.%u.%u%x"                      \
               "\n Expected version: %u.%u.%u%x\n",                    \
               __actualMajorVersion,                                   \
               __actualMinorVersion,                                   \
               __actualBugfixRevision,                                 \
               __actualPrereleaseVersion,                              \
               NWDP_LIBRARY_MAJOR_VERSION,                             \
               NWDP_LIBRARY_MINOR_VERSION,                             \
               NWDP_LIBRARY_BUGFIX_REVISION,                           \
               NWDP_LIBRARY_PREREL_VERSION                             \
               );                                                      \
      }                                                                \
      exit(__retCode);                                                 \
   }                                                                   \
   else if (__retCode > 0)                                             \
   {                                                                   \
      printf("\nNWDPLibInitMac Report\n\n"                             \
             " NWDPLibInit returned warning: %d -- ",__retCode);       \
      switch(__retCode)                                                \
      {                                                                \
         case NWDP_IC_WARN_REPEAT_ID:                                  \
            printf("NWDP_IC_WARN_REPEAT_ID\n");                        \
            printf(" TaskId: %u\n SubTaskId: %u\n",__taskId,__subTaskId); \
            break;                                                     \
         case NWDP_IC_WARN_VER_OBSOLETE:                               \
            printf("NWDP_IC_WARN_VER_OBSOLETE\n");                     \
            break;                                                     \
         default:                                                      \
            /* Should never get here */                                \
            printf("new warning\n");                                   \
            break;                                                     \
      }                                                                \
   }                                                                   \
}
   #endif
#else
   #if defined(N_PLAT_MSW)
   #define NWDPLibInitMac(__accRefPtr)                                 \
{                                                                      \
   NWDPInitCode __retCode;                                             \
   __NWDPLibDefineTaskIdMac;                                           \
   __retCode = NWDPLibInit(                                            \
               NWDP_LIBRARY_MAJOR_VERSION,                             \
               NWDP_LIBRARY_MINOR_VERSION,                             \
               NWDP_LIBRARY_BUGFIX_REVISION,                           \
               NWDP_LIBRARY_PREREL_VERSION,                            \
               __taskId,                                               \
               __subTaskId,                                            \
               __accRefPtr,NULL,NULL,NULL,NULL);                       \
   if (__retCode < 0)                                                  \
      exit(__retCode);                                                 \
}
   #else
   #define NWDPLibInitMac(__accRefPtr)                                 \
{                                                                      \
   NWDPInitCode __retCode;                                             \
   __NWDPLibDefineTaskIdMac;                                           \
   __retCode = NWDPLibInit(                                            \
               NWDP_LIBRARY_MAJOR_VERSION,                             \
               NWDP_LIBRARY_MINOR_VERSION,                             \
               NWDP_LIBRARY_BUGFIX_REVISION,                           \
               NWDP_LIBRARY_PREREL_VERSION,                            \
               __taskId,                                               \
               __subTaskId,                                            \
               __accRefPtr,NULL,NULL,NULL,NULL);                       \
   if (__retCode < 0)                                                  \
      exit(__retCode);                                                 \
}
   #endif
#endif /* N_DEBUG */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

typedef struct CommonAccessorData_T
{
   nptr        localToUnicodeHandle;
   nptr        unicodeToLocalHandle;
   nptr        monocaseHandle;
} NWDPCommonAccessorData, N_FAR *pNWDPCommonAccessorData;

typedef struct AccessorRef_T
{
   nuint32           libError;
   nuint32           otherError;
   nuint32           otherError2; 
   pnstr8            otherErrorStrPtr; /* pointer to an 80 byte buffer */
   pNWDPErrorReturn  otherNDPSErrorReturnPtr;
   nuint32           errorLine;
   pnstr8            errorModule;
   NWDPOidRef        wellKnownOidRefs;
   pNWDPCommonAccessorData cADBPtr;
} NWDPAccessorData, N_FAR *pNWDPAccessorData;


   /*
   // Values returned for NWDPLibInit
   */
typedef enum NWDPInitCode_T
{
   NWDP_IC_SUCCESS                  =  0,

   NWDP_IC_WARN_REPEAT_ID           =  2,
   NWDP_IC_WARN_VER_OBSOLETE        =  3,

   NWDP_IC_ERR_NO_MEMORY            = -2,
   NWDP_IC_ERR_NO_ACCESSOR          = -3,
   NWDP_IC_ERR_WRONG_MAJOR_VERSION  = -4,
   NWDP_IC_ERR_OLD_MINOR_VERSION    = -5,
   NWDP_IC_ERR_OLD_REVISION         = -6,
   NWDP_IC_ERR_IS_PRERELEASE        = -7,
   NWDP_IC_ERR_OLD_PRERELEASE       = -8,
   NWDP_IC_ERR_NWCALLS_INIT         = -9,
   NWDP_IC_ERR_UNICODE_INIT         = -10,
   NWDP_IC_ERR_WINDOW_CREATE        = -11,
   NWDP_IC_ERR_MISMATCHED_DLL       = -12,
   NWDP_IC_ERR_MISMATCHED_SUBLIB    = -13,  /* DOS Only */
   NWDP_IC_ERR_RPC_WINSOCK_INIT     = -14,  /* Win3x Win95 Only */
   NWDP_IC_ERR_LIB_NOT_INIT         = -15,  /* Embedded only */
   NWDP_IC_ERR_NLM_ID_MISMATCH      = -16   /* NLM only */
} NWDPInitCode, N_FAR * pNWDPInitCode;

#include <npackoff.h>

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

   N_EXTERN_LIBRARY(NWDPInitCode)
NWDPLibInit(
   nuint expectedMajorVersion,          /* input */
   nuint expectedMinorVersion,          /* input */ 
   nuint expectedBuxfixRevision,        /* input */ 
   nuint expectedPrereleaseVersion,     /* input */ 
   nuint taskId,                        /* input */
   nuint subTaskId,                     /* input */
   pNWDPAccessorRef accessorRefPtr,     /* output */
   pnuint returnedMajorVersionPtr,      /* output */
   pnuint returnedMinorVersionPtr,      /* output */
   pnuint returnedBugfixRevisionPtr,    /* output */
   pnuint returnedPrereleaseVersionPtr  /* output */
   );

   N_EXTERN_LIBRARY(nint)
NWDPLibTerm(
   pNWDPAccessorRef accessorRefPtr             /* in/out */
   );

   N_EXTERN_LIBRARY(nint)
NWDPLibSetArtificialIODelay(
   NWDPAccessorRef   accessorRef,              /* input */
   nuint32           milliseconds              /* input */
   );

   N_EXTERN_LIBRARY(nint)
NWDPLibGetDefaultLanguageId(
   NWDPAccessorRef accessorRef,                /* input */
   pnint           languageIdPtr               /* output */
   );

/*
// W A R N I N G : Using these routines is not recommended except
// for applications which are consumers of this library for other
// reasons.
// 
// All memory allocated with these routines is automatically freed
// when NWDPLibTerm is called.
*/

N_EXTERN_LIBRARY(nint)
NWDPLibMalloc( 
   NWDPAccessorRef accessorRef,
   pnptr resultMemPtr,
	nint   szMem
   );

N_EXTERN_LIBRARY(nint)
NWDPLibFree(
   NWDPAccessorRef accessorRef,
	nptr memPtr
   );

N_EXTERN_LIBRARY(nint)
NWDPLibRealloc( 
   NWDPAccessorRef accessorRef,
   pnptr  resultMemPtr,
   nptr   sourceMemPtr,
	nint   szMem
   );

N_EXTERN_LIBRARY(nint)
NWDPLibCalloc( 
   NWDPAccessorRef accessorRef,
   pnptr  resultMemPtr,
	nint   numElements,
	nint   szMem
   );

/*
// This is identical to NWDPLibMalloc except for the N_PLAT_NLM case
// where a non-blocking call to __qmalloc is done instead of malloc.
*/
N_EXTERN_LIBRARY(nint)
NWDPLibQMalloc(
   NWDPAccessorRef accessorRef,
   pnptr resultMemPtr,
	nint   szMem
   );

N_EXTERN_LIBRARY(nint)
NWDPLibSetArtificialMemLimit(
   NWDPAccessorRef   accessorRef,              /* input */
   nuint32 mallocsBeforeMallocFail             /* input */
   );

/*
// This entrypoint is not enabled and not intended to be used in
// production code. It is for debug purposes only.
*/
N_EXTERN_LIBRARY(nint)
NWDPLibDisplayError(
   NWDPAccessorRef   accessorRef               /* input */
   );

#else /* NWDP_LIB_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_lib.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_LIB_H */

