/*
//ͻ
// (c) 1995-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_NOT.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_NOT_H )
   #define NWDP_NOT_H

/* Standard Library Header Includes */

/* Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_ATR_H)
      #include <nwdp_atr.h>
   #endif
   #if !defined(NWDP_NTT_H)
      #include <nwdp_ntt.h>
   #endif


/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

   typedef struct 
   {
      NWDPPersistenceEnum     persistence;
      NWDPQualifiedName       consumerName;
      NWDPLanguageId          languageId;
      NWDPNameOrOid           methodId;
      NWDPNotifyDeliveryAddr  deliveryAddress;
      NWDPOctetString         supplierIdOption;
      NWDPQualifiedName       accountOption;
   } NWDPNtfyProfileInfo, N_FAR *pNWDPNtfyProfileInfo;

   typedef struct 
   {
      nuint32                    eventType;
      pNWDPOid                   containingClassOidPtr;
      pNWDPObjectIdentification  containingObjectIdPtr;
      NWDPEventObjectTypeEnum    designator;
      union {
         pNWDPOid      filterClassOidPtr;
         NWDPOidSetRef eventOidSetRef;
      } u;
   } NWDPNtfyEventObjectListItem, N_FAR *pNWDPNtfyEventObjectListItem;

    typedef struct 
   {
      pNWDPEventObjectId   eventObjectIdPtr;
      NWDPAttrSetRef       eventAttrSetRef;
      NWDPASAVPRef         eventAvpRef;  
   } NWDPNtfyGetSupportedListItem, N_FAR *pNWDPNtfyGetSupportedListItem;

#include <npackoff.h>

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPNtfyEventObjectListCallback)(
   NWDPAccessorRef              accessorRef,
   nparam                       callerDefinedParam,
   nint                         totalCallsToBeMade,
   nint                         currentCallCount,
   pNWDPNtfyEventObjectListItem itemReceivedPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPNtfyGetSupportedLstCallback)(
   NWDPAccessorRef               accessorRef,
   nparam                        callerDefinedParam,
   nint                          totalCallsToBeMade,
   nint                          currentCallCount,
   pNWDPNtfyGetSupportedListItem getSupportedListItemPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPNtfyMethodListCallback)(
   NWDPAccessorRef         accessorRef,
   nparam                  callerDefinedParam,
   nint                    totalCallsToBeMade,
   nint                    currentCallCount,
   pNWDPNtfyDeliveryMethod itemReceivedPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPNtfyProfileListCallback)(
   NWDPAccessorRef         accessorRef,
   nparam                  callerDefinedParam,
   nint                    totalCallsToBeMade,
   nint                    currentCallCount,
   NWDPNtfyProfileRef      profileRef
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPNtfyProgrammaticCallback)(
   NWDPAccessorRef         accessorRef,
   NWDPPrtRef              printerRef,
	nint32                  profileId,
	pNWDPEventReport			eventReportPtr
   );                         

 N_TYPEDEF_CALLBACK(nint,
NWDPNtfyPromptListCallback)(
   NWDPAccessorRef         accessorRef,
   nparam                  callerDefinedParam,
   nint                    totalCallsToBeMade,
   nint                    currentCallCount,
   pNWDPNtfyPromptListItem promptListItemPtr
   );


/* Global Variable Declarations */

/* Function Prototype Declarations */

   /********************************************
   *
   *  Notification service-related prototypes
   *
   *********************************************/

 N_EXTERN_LIBRARY(nint)
NWDPNtfyCreateRefBasedOnFQN(
   NWDPAccessorRef      accessorRef,
   pNWDPNSrvFQN         brokerFqnPtr,
	pNWDPNtfyRef         notifyRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyDestroyRef(
   NWDPAccessorRef      accessorRef,
   pNWDPNtfyRef         notifyRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyValidateRef(
   NWDPAccessorRef accessorRef,
	NWDPNtfyRef  notifyRef
   );

   /********************************************
   *
   *  Delivery method-related prototypes
   *
   *********************************************/

 N_EXTERN_LIBRARY(nint)
NWDPNtfyCreateMethodInfoRef(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyRef          notifyRef,
   pNWDPNameOrOid       methodIdPtr,
   NWDPLanguageId       languageId,
   pNWDPNtfyMethodInfoRef methodInfoRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyDestroyMethodInfoRef(
   NWDPAccessorRef      accessorRef,
   pNWDPNtfyMethodInfoRef methodInfoRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyValidateMethodInfoRef(
   NWDPAccessorRef accessorRef,
	NWDPNtfyMethodInfoRef methodInfoRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyAddMethod(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyRef          notifyRef,
   pnstr16              fileName16Ptr,
   pNWDPNameOrOid       methodIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyRemoveMethod(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyRef          notifyRef,
   pNWDPNameOrOid       methodIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyListMethods(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyRef          notifyRef,
   NWDPLanguageId       languageId,
   NWDPNtfyMethodListCallback listCallback,
   nparam               callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyGetDeliveryMethodInfo(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyMethodInfoRef methodInfoRef,
   pNWDPNtfyDeliveryMethod *deliveryMethodPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyListPrompts(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyMethodInfoRef methodInfoRef,
   NWDPNtfyPromptListCallback listCallback,
   nparam               callerDefinedParam
   );

   /********************************************
   *
   *  Profile - Event object-related prototypes
   *
   *********************************************/

/*
// Get Supported Events
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyGetSupportedEvents(
   NWDPAccessorRef                 accessorRef,
   NWDPPrtRef                      printerRef,
   NWDPNtfyGetSupportedLstCallback listCallback,
   nparam                          callerDefinedParam
   );

/*
// Create Profile Ref's
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyCreateProfileRef(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   pNWDPNtfyProfileInfo profileInfoPtr,
   pNWDPNtfyProfileRef  profileRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyCreateProfileRefBOP(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   nuint32              profileId,
   pNWDPNtfyProfileRef  profileRefPtr
   );

/*
// Use & Release Profile Ref's
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyUseProfileRef(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyProfileRef   profileRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyReleaseProfileRef(
   NWDPAccessorRef      accessorRef,
   pNWDPNtfyProfileRef  profileRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyValidateProfileRef(
   NWDPAccessorRef accessorRef,
	NWDPNtfyProfileRef profileRef
   );

/*
// Event Object Management
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyAddDetailEventObject(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr,
   NWDPOidSetRef             eventOidSetRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyAddObjectEventObject(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyAddFilterEventObject(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr,
   pNWDPOid                  filterClassOidPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyRemoveDetailEventObject(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyRemoveObjectEventObject(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyRemoveFilterEventObject(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr,
   pNWDPOid                  filterClassOidPtr
   );


/*
// Event Management
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyAddEvent(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr,
   pNWDPOid                  eventOidPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyRemoveEvent(
   NWDPAccessorRef           accessorRef,
   NWDPNtfyProfileRef        profileRef,
   nuint32                   eventType,
   pNWDPOid                  containingClassOidPtr,
   pNWDPObjectIdentification containingObjectIdOptionPtr,
   pNWDPOid                  eventOidPtr
   );

/*
// Add Profile
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyAddProfile(
   NWDPAccessorRef              accessorRef,
   NWDPNtfyProfileRef           profileRef,
   NWDPNtfyProgrammaticCallback listCallback
   );

/*
// Remove Profile
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyRemoveProfile(
   NWDPAccessorRef accessorRef,
   NWDPNtfyProfileRef  profileRef
   );


/*
// Modify Profile
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyModifyProfile(
   NWDPAccessorRef            accessorRef,
   NWDPNtfyProfileRef         profileRef
   );

/*
// List Profiles
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyListProfiles(
   NWDPAccessorRef         accessorRef,
   NWDPPrtRef              printerRef,
   pNWDPListProfilesChoice profileChoicePtr,
   NWDPNtfyProfileListCallback listCallback,
   nparam                  callerDefinedParam
   );

/*
// Get ProfileId From ProfileRef
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfyGetProfileId(
   NWDPAccessorRef     accessorRef,
   NWDPNtfyProfileRef  profileRef,
   pnuint32            profileIdPtr 
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfyGetProfileInfo(
   NWDPAccessorRef       accessorRef,
   NWDPNtfyProfileRef    profileRef,
   pNWDPNtfyProfileInfo  profileInfoPtr 
   );


/*
// Modify profile information calls
*/
 N_EXTERN_LIBRARY(nint)
NWDPNtfySetMethodId(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyProfileRef   profileRef,
   pNWDPNameOrOid       methodIdPtr 
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfySetDeliveryAddress(
   NWDPAccessorRef         accessorRef,
   NWDPNtfyProfileRef      profileRef,
   pNWDPNotifyDeliveryAddr deliveryAddressPtr 
   );

 N_EXTERN_LIBRARY(nint)
NWDPNtfySetSupplierId(
   NWDPAccessorRef      accessorRef,
   NWDPNtfyProfileRef   profileRef,
   pNWDPOctetString     supplierIdPtr 
   );

 N_EXTERN_LIBRARY(nint)       
NWDPNtfySetLanguageId(
   NWDPAccessorRef    accessorRef,
   NWDPNtfyProfileRef profileRef,
   NWDPLanguageId     languageId
   );


 N_EXTERN_LIBRARY(nint)
NWDPNtfyListEventObjects(
   NWDPAccessorRef                 accessorRef,
   NWDPNtfyProfileRef              profileRef,
   NWDPNtfyEventObjectListCallback listCallback,
   nparam                          callerDefinedParam
   );

/*
// Use NWDPOidListOids to list the events
*/


#else /* NWDP_NOT_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_NOT.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_NOT_H */
