/*
//ͻ
// (c) 2003 Novell, Inc.  All rights reserved.                              
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_NTO.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_NTO_H )
   #define NWDP_NTO_H

/* Standard Library Header Includes */

   #if !defined(NTYPES_H)
      #define N_INC_NO_OLD_CONSTANTS
      #define N_INC_NO_OLD_MACROS
      #include <ntypes.h>
      #undef N_INC_NO_OLD_MACROS
      #undef N_INC_NO_OLD_CONSTANTS
   #endif /* NTYPES_H */


   #if !defined(NWDP_ATT_H)
      #include <nwdp_att.h>
   #endif /* NWDP_ATT_H */

/* Header Includes */

/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */

#define N_PACK_1
#include <npackon.h>


typedef struct {
	nbool restrictedBool;
	nint32 min;
	nint32 max;
} NWDPRestrictionInfo, N_FAR *pNWDPRestrictionInfo;

typedef struct {
	NWDPAddressItemTypeEnum designator;
	union {
		NWDPRestrictionInfo userRestrict;
		NWDPRestrictionInfo serverRestrict;
		NWDPRestrictionInfo volumeRestrict;
		NWDPRestrictionInfo orgUnitRestrict;
		NWDPRestrictionInfo orgRestrict;
		NWDPRestrictionInfo groupRestrict;
		NWDPRestrictionInfo dNRestrict;
		NWDPRestrictionInfo userOrContainerRestrict;
		NWDPRestrictionInfo caseExactStrRestrict;
		NWDPRestrictionInfo caseIgnoreStrRestrict;
		NWDPRestrictionInfo numericStrRestrict;
		NWDPRestrictionInfo dosFileNameRestrict;
		NWDPRestrictionInfo phoneNumberRestrict;
		NWDPRestrictionInfo booleanRestrict;
		NWDPRestrictionInfo integerRestrict;
		NWDPRestrictionInfo netAddressRestrict;
		struct {
			nuint itemCount;
			pNWDPText itemPtr;
		} choiceSet;
		NWDPRestrictionInfo gwUserRestrict;
	} u;
} NWDPDeliveryAddrItem, N_FAR *pNWDPDeliveryAddrItem;

typedef struct {
	NWDPOctetString supplierId;
	nuint32 eventType;
	NWDPObjectIdentifier containingClassOid;
	NWDPObjectIdentification containingObjectId;
	NWDPObjectIdentifier filterClassOid;
	NWDPObjectIdentifier objectClassOid;
	NWDPObjectIdentification objectId;
	NWDPObjectIdentifier eventOid;
	NWDPAttribute eventAttr;
	NWDPText message;
	nuint32 time;
	NWDPQualifiedName accountOption;
	NWDPAttributeSet eventAttrSet;
} NWDPEventReport, N_FAR *pNWDPEventReport;

#else /* NWDP_NTO_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_nto.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_NTO_H */

