/*
//ͻ
// (c) 2003 Novell, Inc.  All rights reserved.                              
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_NTP.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_NTP_H )
   #define NWDP_NTP_H

/* Standard Library Header Includes */

   #if !defined(NTYPES_H)
      #define N_INC_NO_OLD_CONSTANTS
      #define N_INC_NO_OLD_MACROS
      #include <ntypes.h>
      #undef N_INC_NO_OLD_MACROS
      #undef N_INC_NO_OLD_CONSTANTS
   #endif /* NTYPES_H */


   #if !defined(NWDP_ATT_H)
      #include <nwdp_att.h>
   #endif /* NWDP_ATT_H */

/* Header Includes */

/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */

#define N_PACK_1
#include <npackon.h>


typedef enum {
	NWDP_PGRM_DLVR_BIND_SUCCESS = 0,
	NWDP_PGRM_DLVR_BIND_ERROR = 1
} NWDPPrgmDlvrBindResultEnum, N_FAR *pNWDPPrgmDlvrBindResultEnum;

typedef struct {
	NWDPCredentials credentials;
} NWDPPrgmDlvrBindArgument, N_FAR *pNWDPPrgmDlvrBindArgument;

typedef struct {
	NWDPPrgmDlvrBindResultEnum rCode;
} NWDPPrgmDlvrBindResult, N_FAR *pNWDPPrgmDlvrBindResult;

typedef struct {
	nuint8 noopArg;
} NWDPPrgmDlvrUnbindArgument, N_FAR *pNWDPPrgmDlvrUnbindArgument;

typedef struct {
	nuint8 noopArg;
} NWDPPrgmDlvrUnbindResult, N_FAR *pNWDPPrgmDlvrUnbindResult;

typedef enum {
	NWDP_PGRM_DLVR_SEND_SUCCESS = 0,
	NWDP_PGRM_DLVR_SEND_ERROR = 1
} NWDPPrgmDlvrSendResultEnum, N_FAR *pNWDPPrgmDlvrSendResultEnum;

typedef struct {
	nuint32 listenerHandle;
	NWDPOctetString supplierId;
	nuint32 eventType;
	NWDPObjectIdentifier containingClassOid;
	NWDPObjectIdentification containingObjectId;
	NWDPObjectIdentifier filterClassOid;
	NWDPObjectIdentifier objectClassOid;
	NWDPObjectIdentification objectId;
	NWDPObjectIdentifier eventOid;
	NWDPAttribute eventAttr;
	NWDPText message;
	nuint32 time;
	NWDPQualifiedName accountOption;
} NWDPPrgmDlvrSendItem, N_FAR *pNWDPPrgmDlvrSendItem;

typedef struct {
	nuint itemCount;
	pNWDPPrgmDlvrSendItem itemPtr;
} NWDPPrgmDlvrSendArgument, N_FAR *pNWDPPrgmDlvrSendArgument;

typedef struct {
	nuint32 listenerHandle;
	NWDPOctetString supplierId;
	nuint32 eventType;
	NWDPObjectIdentifier containingClassOid;
	NWDPObjectIdentification containingObjectId;
	NWDPObjectIdentifier filterClassOid;
	NWDPObjectIdentifier objectClassOid;
	NWDPObjectIdentification objectId;
	NWDPObjectIdentifier eventOid;
	NWDPAttributeSet eventAttrSet;
	NWDPText message;
	nuint32 time;
	NWDPQualifiedName accountOption;
} NWDPPrgmDlvrSendItem2, N_FAR *pNWDPPrgmDlvrSendItem2;

typedef struct {
	nuint itemCount;
	pNWDPPrgmDlvrSendItem2 itemPtr;
} NWDPPrgmDlvrSendArgument2, N_FAR *pNWDPPrgmDlvrSendArgument2;

typedef struct {
	NWDPPrgmDlvrSendResultEnum rCode;
	struct {
		nuint itemCount;
		pnuint32 itemPtr;
	} failedItems;
} NWDPPrgmDlvrSendResult, N_FAR *pNWDPPrgmDlvrSendResult;

#include <npackoff.h>


/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */



#else /* NWDP_NTP_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_ntp.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_NTP_H */

