/*
//ͻ
// (c) 1995-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_OID.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_OID_H )
   #define NWDP_OID_H

/* Standard Library Header Includes */

/* Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_WKO_OGH)
      #include <nwdp_wko.ogh>
   #endif
   #if !defined(NWDP_ATT_H)
      #include <nwdp_att.h>
   #endif


/* Manifest Constant Definitions */
   /*
   // The default oid Set size. 
   */
   #define NWDP_OID_SET_SIZE  8

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

   /*
   // Language numbers inside the library
   */
   typedef enum 
   {
      NWDP_LID_DEFAULT                = -1,
      NWDP_LID_CANADIAN_FRENCH        =  0,
      NWDP_LID_CHINESE                =  1,              /* simplified */
      NWDP_LID_DANISH                 =  2,
      NWDP_LID_DUTCH                  =  3, 
      NWDP_LID_ENGLISH                =  4,
      NWDP_LID_FINNISH                =  5, 
      NWDP_LID_FRENCH                 =  6,
      NWDP_LID_GERMAN                 =  7,
      NWDP_LID_ITALIAN                =  8,
      NWDP_LID_JAPANESE               =  9,
      NWDP_LID_KOREAN                 = 10,
      NWDP_LID_NORWEGIAN              = 11,
      NWDP_LID_PORTUGUESE             = 12,              /* Brazil */
      NWDP_LID_RUSSIAN                = 13,
      NWDP_LID_SPANISH                = 14,              /* Latin America */
      NWDP_LID_SWEDISH                = 15,
      NWDP_LID_CHINESE_TRAD           = 16,              /* traditional */
      NWDP_LID_POLISH                 = 17,
      NWDP_LID_PORTUGUESE_PORT        = 18,              /* Portugal */
      NWDP_LID_SPANISH_SPAIN          = 19,              /* Spain */
      NWDP_LID_HUNGARIAN              = 20,              
      NWDP_LID_CZECH                  = 21,              
      NWDP_LID_FJP                    = 98,              /* Fake Japanese */
      NWDP_LID_FEU                    = 99               /* Fake European */
   } NWDPLanguageId, N_FAR *pNWDPLanguageId;


   /*
   // Format Id of the buffer returned by NWDPOidInterpretRef
   // 
   // NWDP_ITPF_STRING              represents a zero terminated single-byte 
   //                                  ASCII string.
   // NWDP_ITPF_NUINT32_AND_STRING  represents a 4 byte unsigned integer 
   //                                  followed immediately by a zero
   //                                  terminated ASCII string.
   */
   typedef enum NWDPInterpretFormat_T
   {
      NWDP_ITPF_STRING                 =  0,
      NWDP_ITPF_NUINT32_AND_STRING     =  1
   } NWDPInterpretFormat, N_FAR *pNWDPInterpretFormat;


   /*
   // OID Kinds so we know whether the prefix was "id-oc-","id-att-",
   // "id-vc-", or "id-val-" etc.
   */
   typedef enum NWDPOidKind_T
   {
      NWDP_OK_OBJECT_CLASS             =  0, /* id-oc- */
      NWDP_OK_VALUE_CLASS              =  1, /* id-vc- */
      NWDP_OK_ATTRIBUTE                =  2, /* id-att- */
      NWDP_OK_VALUE                    =  3  /* id-val- */
   } NWDPOidKind, N_FAR *pNWDPOidKind;


   /*
   // List Item definition for NWDPOidListRefValues
   */
   typedef struct
   {
      nint32 enumValue;
      pnuint8 oidInterpretBufferPtr;
      nuint sizeOfResult;
      NWDPInterpretFormat formatId;
   } NWDPOidValueListItem, N_FAR *pNWDPOidValueListItem;


#include <npackoff.h>

/* Callback Definitions */
 N_TYPEDEF_CALLBACK(nint,
NWDPOidValueListCallback)(
   NWDPAccessorRef         accessorRef,
   nparam                  callerDefinedParam,
   nint                    totalCallsToBeMade,
   nint                    currentCallCount,
   pNWDPOidValueListItem   itemReceivedPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPOidSetListCallback)(
   NWDPAccessorRef   accessorRef,
   nparam            callerDefinedParam,
   nint              totalCallsToBeMade,
   nint              currentCallCount,
   pNWDPOid          oidPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPOidCmp(
   NWDPAccessorRef   accessorRef,
   pNWDPOid          oid1Ptr,
   pNWDPOid          oid2Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidCreateRefBasedOnASCII(
   NWDPAccessorRef accessorRef,
   pnstr oidASCIIStringPtr,
   pNWDPOidRef oidRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidCreateRefBasedOnOID(
   NWDPAccessorRef accessorRef,
   pNWDPOid  oidPtr,
   pNWDPOidRef oidRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidCreateRefBasedOnString(
   NWDPAccessorRef accessorRef,
   pnstr oidInterpretPtr,
   NWDPLanguageId languageId,
   NWDPOidKind oidKind,
   pNWDPOidRef oidRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidGetAttrCharacteristics(
   NWDPAccessorRef accessorRef,
   NWDPOidRef oidRef,
   pNWDPAVTEnum  attrTypeEnumPtr,
   pnbool        isMultiValuedPtr,
   pnbool        hasEnumeratedValuesPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidInterpretRef(
   NWDPAccessorRef accessorRef,
   NWDPOidRef oidRef,
   NWDPLanguageId languageId,
   nuint sizeOfBuffer,
   pnuint8 oidInterpretBufferPtr,
   pnuint sizeOfResultPtr,
   pNWDPInterpretFormat formatIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidInterpretRefAsASCII(
   NWDPAccessorRef accessorRef,
   NWDPOidRef oidRef,
   nuint sizeOfBuffer,
   pnstr oidASCIIBufferPtr,
   pnuint sizeOfResultPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidInterpretRefValue(
   NWDPAccessorRef accessorRef,
   NWDPOidRef oidRef,
   nint32 enumValue,
   NWDPLanguageId languageId,
   nuint sizeOfBuffer,
   pnuint8 oidInterpretBufferPtr,
   pnuint sizeOfResultPtr,
   pNWDPInterpretFormat formatIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidInterpretRefWithClosest(
   NWDPAccessorRef accessorRef,
   NWDPOidRef oidRef,
   NWDPLanguageId languageId,
   nuint sizeOfBuffer,
   pnuint8 oidInterpretBufferPtr,
   pnuint sizeOfResultPtr,
   pNWDPInterpretFormat formatIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidListRefValues(
   NWDPAccessorRef accessorRef,
   NWDPOidRef oidRef,
   NWDPLanguageId languageId,
   NWDPOidValueListCallback listCallback,
   nparam callerDefinedParam
   );

 N_EXTERN_LIBRARY(pNWDPOid)
NWDPOidMakeOidPtrFromOidRef(
   NWDPOidRef oidRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidReleaseRef(
   NWDPAccessorRef accessorRef,
   pNWDPOidRef oidRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOidValidateRef(
   NWDPAccessorRef accessorRef,
   NWDPOidRef oidRef
   );

/*
// Oid Set calls
*/
 N_EXTERN_LIBRARY(nint)
NWDPOSAddOid(
   NWDPAccessorRef   accessorRef,
   NWDPOidSetRef     oidSetRef,
   pNWDPOid          oidPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOSCreateRef(
   NWDPAccessorRef accessorRef,
   nuint sizeOfOidSet,
   pNWDPOidSetRef oidSetRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOSListOids(
   NWDPAccessorRef        accessorRef,
   NWDPOidSetRef          oidSetRef,
   NWDPOidSetListCallback listCallback,
   nparam                 callerDefinedParam                   
   );

 N_EXTERN_LIBRARY(nint)
NWDPOSReleaseRef(
   NWDPAccessorRef   accessorRef,
   pNWDPOidSetRef    oidSetRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOSRemoveOid(
   NWDPAccessorRef   accessorRef,
   NWDPOidSetRef     oidSetRef,
   pNWDPOid          oidPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPOSUseRef(
   NWDPAccessorRef   accessorRef,
   NWDPOidSetRef     oidSetRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPOSValidateRef(
   NWDPAccessorRef accessorRef,
   NWDPOidSetRef oidSetRef
   );

#else /* NWDP_OID_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_oid.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_OID_H */

