/*
//ͻ
// (c) 1995-2003 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_RES.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_RES_H )
   #define NWDP_RES_H

/* Standard Library Header Includes */
   #include <time.h>
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_RSM_H)
      #include <nwdp_rsm.h>
   #endif

/* Header Includes */

/* Manifest Constant Definitions */

   /*
   // Return code values to be returned from the callback type,
   // NWDPResSelectNAddCallback
   */
   #define NWDP_RC_RES_DRIVER_SKIP     0
   #define NWDP_RC_RES_DRIVER_ADD      1

   /*
   // Value used for NWDPResSetLanguageContext()
   */
   #define NWDP_LID_NO_CHANGE      ((NWDPLanguageId)-2)
   #define NWDP_LID_SERVER_DEFAULT ((NWDPLanguageId)-3)

   /*
   // Flags for use with NWDPResCreateRefBasedOnDrvrId
   */
   #define NWDP_RES_USE_ANY_LANGUAGE   0x01

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

/*
// List Resource file input structures
*/
   typedef struct
   {
      NWDPFontTypeEnum fontType;
      NWDPOSTypeEnum   osType;
	}NWDPResListFontTypes, N_FAR *pNWDPResListFontTypes;


   typedef struct         /* used for List type 0 */
   {
      NWDPOSTypeEnum   osType;
		pnstr16             printerType16Ptr;
		pnstr16             printerMfr16Ptr;
		pnstr16             infFileName16Ptr;
		pNWDPOctetString    printerIdPtr; /* must be NULL if not used for list */  

	}NWDPResListDrvFiles, N_FAR *pNWDPResListDrvFiles;

   typedef struct         /* used for List type 11 */
   {
      NWDPOSTypeEnum   osType;
		pnstr16             printerType16Ptr;
		pnstr16             printerMfr16Ptr;
		pnstr16             infFileName16Ptr;
		pNWDPOctetString    printerIdPtr; /* must be NULL if not used for list
                                        // or NWDPResCreateRefBasedOnDriverId */  
		pnstr               printerTypePtr;

	}NWDPResListDrvFiles2, N_FAR *pNWDPResListDrvFiles2;

   typedef struct         /* used for List types 5 and 10  */
   {
      pnstr16             vendorDir16Ptr;
		pnstr16             printerType16Ptr;
		pnstr16             printerMfr16Ptr;
		pnstr16             infFileName16Ptr;
		pNWDPOctetString     printerIdPtr; /*must be NULL if not used for list */
	}NWDPResListDefFiles, N_FAR *pNWDPResListDefFiles;

   typedef struct
   {
      NWDPOSTypeEnum   osType;
      NWDPFontTypeEnum fontType;
		pnstr16             fontName16Ptr;
	}NWDPResListFontFiles, N_FAR *pNWDPResListFontFiles;

   typedef struct
   {
		nint                setCount;
      pnstr16             setItem16Ptr;
	}NWDPResUnicodeSet, N_FAR *pNWDPResUnicodeSet;

   typedef struct
   {
      NWDPOSTypeEnum   osType;
      struct {
   		nint              stringCount;
         ppnstr16          stringItem16PtrPtr;
      } keySet;
   }NWDPResTypedKeySet, N_FAR *pNWDPResTypedKeySet;

   /*
   // Resource file list callback item types
   */
   typedef struct
   {
      NWDPResourceListTypeEnum    listType;
      union
      {
         struct							         /* listType = 0 : prn Drv Types*/
		   {
		      pnstr16 printerType16Ptr;
		      pnstr16 printerMfr16Ptr;      /* will contain "N/A" for win31 os */
		      pnstr16 infFileName16Ptr;
		   }ListPrnDrvTypesCB;

		   struct                            /* listType = 1 : prn Def Types*/
		   {
		      pnstr16 printerType16Ptr;
			   pnstr16 printerMfr16Ptr;
		      pnstr16 infFileName16Ptr;
		   }ListPrnDefTypesCB;

		   pnstr16 bannerFileName16Ptr;      /* listType = 2 : banner files*/

		   pnstr16 fontName16Ptr;            /* listType = 3 : prn font types*/

		   struct                            /* listType = 4 : prn driver files*/
		   {
		      pnstr16 fileName16Ptr;
		      pnstr16 driverDirName16Ptr;
            pnstr16 infFileName16Ptr;      /* only contains stuff for DID list*/
		   }ListPrnDrvFilesCB;

		   struct                            /* listType = 5 : prn Def File */
         {
            pnstr16          defFileName16Ptr;
			   NWDPResUnicodeSet win31KeySet;	  
			   NWDPResUnicodeSet win95KeySet;
	      }ListPrnDefFilesCB;        

		   pnstr16 fontFileName16Ptr;        /* listType = 6 : font file*/

		   struct                            /* listType = 10: prn Def File version 2 */
         {
            pnstr16             defFileName16Ptr;
            nint                keySetCount;
			   pNWDPResTypedKeySet keySetPtr;
	      }ListPrnDefFiles_2CB;        

         struct							         /* listType = 11: prn Drv Types version 2 */
		   {
		      pnstr   printerTypePtr;
		      pnstr16 printerType16Ptr;
		      pnstr16 printerMfr16Ptr;       /* will contain "N/A" for win31 os */
		      pnstr16 infFileName16Ptr;
		   }ListPrnDrvTypes_2CB;

         struct							         /* listType = 13 : prn Drv Type Archives */
		   {
		      pnstr16 printerType16Ptr;
		      pnstr16 printerMfr16Ptr;
		      pnstr16 pdlName16Ptr;
		      pnstr16 driverDirName16Ptr;
		      pnstr16 infFileName16Ptr;
            NWDPArchiveTypeEnum archiveType;
            nuint32 archiveSize;
		   }ListPrnDrvTypeArchivesCB;

		   NWDPLanguageId supportedLangId;  /* listType = 14 : supported languages */

      }callback_u;
   }NWDPResListCallbackItem, N_FAR * pNWDPResListCallbackItem;

   /*
   // Add/Delete/Get/GetFD Resource File Input Argument Types
   */
   typedef struct                 /* for printer driver files */
   {
      NWDPOSTypeEnum osType;
	   pnstr16           driverDirName16Ptr; /* L"new" for INF add file else NULL */
	   pnstr16           fileName16Ptr;
   } NWDPResAddPrnDrvFile,       N_FAR *pNWDPResAddPrnDrvFile,
     NWDPResDeletePrnDrvFile,    N_FAR *pNWDPResDeletePrnDrvFile,
     NWDPResGetPrnDrvFile,       N_FAR *pNWDPResGetPrnDrvFile,
     NWDPResGetDatePrnDrvFile,   N_FAR *pNWDPResGetDatePrnDrvFile;

   typedef struct                 /* for printer defn files */
   {
      pnstr16     vendorDir16Ptr;
	   pnstr16     fileName16Ptr;
   } NWDPResAddPrnDefFile,       N_FAR *pNWDPResAddPrnDefFile,
     NWDPResDeletePrnDefFile,    N_FAR *pNWDPResDeletePrnDefFile,
     NWDPResGetPrnDefFile,       N_FAR *pNWDPResGetPrnDefFile,
     NWDPResGetDatePrnDefFile,   N_FAR *pNWDPResGetDatePrnDefFile;

   typedef struct						  /* for prn Drv Type Archives */
   {
      NWDPOSTypeEnum osType;
		pnstr16 driverDirName16Ptr; /* archive filename for add */
      NWDPArchiveTypeEnum archiveType;
	} NWDPResAddDrvArchiveFile,      N_FAR *pNWDPResAddDrvArchiveFile,
	  NWDPResDeleteDrvArchiveFile,   N_FAR *pNWDPResDeleteDrvArchiveFile,
	  NWDPResGetDrvArchiveFile,      N_FAR *pNWDPResGetDrvArchiveFile,
	  NWDPResGetDateDrvArchiveFile,  N_FAR *pNWDPResGetDateDrvArchiveFile;

   /*
   // Add/Delete/Get Resource File Input Argument Types
   */
   /* getting date of a font file not supported in NDPS MR1 */
   typedef struct 						/* for an add of a font file */
   {
      NWDPOSTypeEnum osType;
      NWDPFontTypeEnum fontType;
	   pnstr16    fontName16Ptr;
	   pnstr16    fileName16Ptr ;
   } NWDPResAddFontFile,      N_FAR *pNWDPResAddFontFile,
     NWDPResDeleteFontFile,   N_FAR *pNWDPResDeleteFontFile,
     NWDPResGetFontFile,      N_FAR *pNWDPResGetFontFile;

   typedef struct
   {
         pnstr   printerTypePtr;
         pnstr16 printerType16Ptr;
		   pnstr16 printerMfr16Ptr;
   } NWDPResSelectNAddCallbackItem, N_FAR *pNWDPResSelectNAddCallbackItem;


#include <npackoff.h>

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPResListCallback)(
   NWDPAccessorRef     accessorRef,
   nparam              callerDefinedParam,
   nint                totalCallsToBeMade,
   nint                currentCallCount,
   pNWDPResListCallbackItem resListItemPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPResSelectNAddCallback)(
   NWDPAccessorRef     accessorRef,
   nparam              callerDefinedParam,
   nint                totalCallsToBeMade,
   nint                currentCallCount,
   pNWDPResSelectNAddCallbackItem resSelectNAddItemPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPResAddResourceFile(
   NWDPAccessorRef accessorRef,      /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,                /*I: Reference to RMS*/
   NWDPResourceTypeEnum resType,     /*I: Resource Type flag*/
   pnstr localDirPtr,                /*I: path to local dir to read from */
   nparam addInput                   /*I: generic pointer to input struct */
   );

/* New for 1.1 */
 N_EXTERN_LIBRARY(nint)
NWDPResAddResourceFile2(
   NWDPAccessorRef accessorRef,   /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,             /*I: Reference to RMS*/
   NWDPResourceTypeEnum resType,  /*I: Resource Type flag*/
   pnstr localDirPtr,             /*I: path to local dir to read from */
   nparam addInput,               /*I: generic pointer to input struct */
   pnstr  optionalAnotationStrPtr /*I: Add this to all Printer Names in INF */
   );

 N_EXTERN_LIBRARY(nint)
NWDPResCreateRefBasedOnAddr(
   NWDPAccessorRef accessorRef,  /*I: NDPS Library accessor Reference*/
   pNWDPNetAddress addressPtr,	/*I: given resource man net address */
   pNWDPResRef resRefPtr         /*I: pointer to RMS reference */
	);

   /* new for 1.1 */   
 N_EXTERN_LIBRARY(nint)
NWDPResCreateRefBasedOnDriverId(
   NWDPAccessorRef accessorRef,     /*I :NDPS Library accessor Reference*/
   pNWDPResListDrvFiles2 driverIdPtr,/*I:pointer to the desired driver */
   pNWDPResRef resRefPtr            /*IO:pointer to RMS reference */
	);

   /* new for 1.5 */   
 N_EXTERN_LIBRARY(nint)
NWDPResCreateRefBasedOnDrvrId(
   NWDPAccessorRef         accessorRef,/*I :NDPS Library accessor Reference*/
   pNWDPResListDrvFiles2   driverIdPtr,/*I :pointer to the desired driver */
   NWDPLanguageId          languageId, /*I :language preference */
   pNWDPResRef             resRefPtr,  /*IO:pointer to RMS reference */
   nuint32                 flags       /*I :behavior control */
	);

 N_EXTERN_LIBRARY(nint)
NWDPResCreateRefBasedOnFQN(
   NWDPAccessorRef      accessorRef,  /*I :NDPS Library accessor Reference*/
   pNWDPNSrvFQN         brokerFqnPtr, /*I :Broker FQN Struture ptr*/
   pNWDPResRef          resRefPtr     /*IO:pointer to RMS reference */
   );

 N_EXTERN_LIBRARY(nint)
NWDPResCreateRefBasedOnSrsSAP(
   NWDPAccessorRef accessorRef,    /*I :NDPS Library accessor Reference*/
   pNWDPResRef resRefPtr           /*IO:pointer to RMS reference */
	);

   /* new for 1.1 */   
 N_EXTERN_LIBRARY(nint)
NWDPResCreateRefBasedOnPrinter(
   NWDPAccessorRef accessorRef,    /*I :NDPS Library accessor Reference*/
   NWDPPrtRef printerRef,          /*I :Printer reference */
   pNWDPResRef resRefPtr           /*IO:pointer to RMS reference */
	);

   /* new for 1.8.6 */   
 N_EXTERN_LIBRARY(nint)
NWDPResCreateRefForLocal(
   NWDPAccessorRef accessorRef,    /*I :NDPS Library accessor Reference*/
   pNWDPResRef resRefPtr           /*IO:pointer to RMS reference */
	);

 N_EXTERN_LIBRARY(nint)
NWDPResDeleteResourceFile(
   NWDPAccessorRef accessorRef,     /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,               /*I: Reference to RMS*/
   NWDPResourceTypeEnum resType,    /*I: Resource Type flag*/
   nparam deleteInput               /*I: generic pointer to input struct */  
   );

 N_EXTERN_LIBRARY(nint)
NWDPResDestroyRef(
   NWDPAccessorRef accessorRef,     /*I: NDPS Library accessor Reference*/
   pNWDPResRef resRefPtr            /*I: pointer to RMS reference */
   );

 N_EXTERN_LIBRARY(nint)
NWDPResGetFQN(
   NWDPAccessorRef      accessorRef,
   NWDPResRef           resRef,
   nuint                sizeOfBuffer,
   pNWDPNSrvFQNBuffer   fqnBufferPtr,
   pnuint               sizeOfResultPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPResGetResourceFile(
   NWDPAccessorRef accessorRef,    /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,              /*I: Reference to RMS*/
   NWDPResourceTypeEnum resType,   /*I: Resource Type flag*/
   pnstr localSrcDirPtr,           /*I: src dir for file, must be NULL if not used */
   pnstr localDestDirPtr,          /*I: destination directory for file */
   nparam getInput,                /*I: generic pointer to input struct */
   time_t *fileTimePtr             /*O: date file created */
   );

 N_EXTERN_LIBRARY(nint)
NWDPResGetResourceFileDate(
   NWDPAccessorRef accessorRef,     /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,               /*I: Reference to RMS*/
   NWDPResourceTypeEnum resType,    /*I: Resource Type flag*/
   nparam getDateInput,             /*I: generic pointer to input struct */
   time_t *fileTimePtr              /*0: file creation time in sec since 1/1/70*/
   );
   
 N_EXTERN_LIBRARY(nint)
NWDPResListResource(
   NWDPAccessorRef accessorRef,           /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,                     /*I: Reference to RMS*/
   NWDPResourceListTypeEnum resListType,  /*I: List Resource Type flag*/
   pnstr drivePathPtr,                    /*I: local drive path to list from */
   nparam listInput,				            /*I: generic pointer to input struct */
   NWDPResListCallback listCallback,      /*I: callback function name */
   nparam callerDefinedParam              /*I: Optional pass through param */
   );

 N_EXTERN_LIBRARY(nint)
NWDPResSelectAndAddCABData(
   NWDPAccessorRef accessorRef,           /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,                     /*I: Reference to local */
   NWDPResSelectNAddCallback selectNAddCallback, /*I: callback function name */
   nparam callerDefinedParam,             /*I: Optional pass through param */
   pnstr  optionalAnotationStrPtr,/*I: Add this to all Printer Names in INF */
   nptr   optionalWindowHandle    /*I: for UI */
   );

/* new for 1.8.6 */
 N_EXTERN_LIBRARY(nint)
NWDPResSelectAndAddDriver2(
   NWDPAccessorRef accessorRef,           /*I: NDPS Library accessor Reference*/
   NWDPResRef resRef,                     /*I: Reference to Remote Manager */
   pnstr  infPathPtr,                     /*I: Full path to INF file */
   NWDPResSelectNAddCallback selectNAddCallback, /*I: callback function name */
   nparam callerDefinedParam,             /*I: Optional pass through param */
   pnstr  optionalAnnotationStrPtr, /*I: Add this to all Printer Names in INF */
   nptr   optionalWindowHandle,     /*I: For use of the SetupAPI calls */
   NWDPOSTypeEnum osType            /*I: For what platform? (-1 is "this") */
   );

 N_EXTERN_LIBRARY(nint)
NWDPResValidateRef(
   NWDPAccessorRef accessorRef,     /*I: NDPS Library accessor Reference*/
	NWDPResRef resRef                /*I: pointer to RMS reference */
   );

 N_EXTERN_LIBRARY(nint)
NWDPResSetLanguageContext(
   NWDPAccessorRef accessorRef,      /*I: NDPS Library accessor Reference*/
	NWDPResRef resRef,                /*I: pointer to RMS reference */
   NWDPLanguageId newLanguageId,     /*I: -2 means return current, no chg */
   pNWDPLanguageId previousLangIdPtr /*O: previous language returned */
   );


#else /* NWDP_RES_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_res.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_RES_H */

