/*
//ͻ
// (c) 2003 Novell, Inc.  All rights reserved.                              
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_RSM.H                                           
//͹
// Library VeRsIoN=1.8.6                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_RSM_H )
   #define NWDP_RSM_H

/* Standard Library Header Includes */

   #if !defined(NTYPES_H)
      #define N_INC_NO_OLD_CONSTANTS
      #define N_INC_NO_OLD_MACROS
      #include <ntypes.h>
      #undef N_INC_NO_OLD_MACROS
      #undef N_INC_NO_OLD_CONSTANTS
   #endif /* NTYPES_H */


/* Header Includes */

/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */

#define N_PACK_1
#include <npackon.h>


typedef enum {
	NWDP_RES_PRN_DRV = 0,
	NWDP_RES_PRN_DEF = 1,
	NWDP_RES_BANNER_PAGE = 2,
	NWDP_RES_FONT = 3,
	NWDP_RES_GENERIC_RESOURCE = 4,
	NWDP_RES_PRN_DRV_ARCHIVE = 5
} NWDPResourceTypeEnum, N_FAR *pNWDPResourceTypeEnum;

typedef enum {
	NWDP_RES_LIST_PRN_DRV_TYPES = 0,
	NWDP_RES_LIST_PRN_DEF_TYPES = 1,
	NWDP_RES_LIST_PRN_DEF_TYPES_SH = 2,
	NWDP_RES_LIST_BANNER_PAGE_FILES = 3,
	NWDP_RES_LIST_FONT_TYPES = 4,
	NWDP_RES_LIST_PRN_DRV_FILES = 5,
	NWDP_RES_LIST_PRN_DEF_FILE = 6,
	NWDP_RES_LIST_FONT_FILES = 7,
	NWDP_RES_LIST_GENERIC_TYPE = 8,
	NWDP_RES_LIST_GENERIC_FILES = 9,
	NWDP_RES_LIST_PRN_DEF_FILE_2 = 10,
	NWDP_RES_LIST_PRN_DRV_TYPES_2 = 11,
	NWDP_RES_LIST_PRN_DRV_FILES_2 = 12,
	NWDP_RES_LIST_PRN_DRV_TYPES_ARC = 13,
	NWDP_RES_LIST_LANGUAGES_AVAIL = 14
} NWDPResourceListTypeEnum, N_FAR *pNWDPResourceListTypeEnum;

typedef enum {
	NWDP_RES_OS_DOS = 0,
	NWDP_RES_OS_WIN_31 = 1,
	NWDP_RES_OS_WIN_95 = 2,
	NWDP_RES_OS_WIN_NT = 3,
	NWDP_RES_OS_OS_2 = 4,
	NWDP_RES_OS_MAC = 5,
	NWDP_RES_OS_UNIX = 6,
	NWDP_RES_OS_WIN_NT4 = 7,
	NWDP_RES_OS_WIN_NT5 = 8,
	NWDP_RES_OS_WIN_98 = 9
} NWDPOSTypeEnum, N_FAR *pNWDPOSTypeEnum;

typedef enum {
	NWDP_RES_ARCHIVE_ZIP = 0,
	NWDP_RES_ARCHIVE_JAR = 1
} NWDPArchiveTypeEnum, N_FAR *pNWDPArchiveTypeEnum;

typedef enum {
	NWDP_RES_BANNER_ALL = 0,
	NWDP_RES_BANNER_PCL = 1,
	NWDP_RES_BANNER_PS = 2,
	NWDP_RES_BANNER_TXT = 3
} NWDPBannerTypeEnum, N_FAR *pNWDPBannerTypeEnum;

typedef enum {
	NWDP_RES_FONT_TRUE_TYPE = 0,
	NWDP_RES_FONT_PS = 1,
	NWDP_RES_FONT_SYSTEM = 2,
	NWDP_RES_FONT_SPD = 3,
	NWDP_RES_FONT_TRUE_DOC = 4
} NWDPFontTypeEnum, N_FAR *pNWDPFontTypeEnum;

#include <npackoff.h>


/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */



#else /* NWDP_RSM_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_rsm.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_RSM_H */

